#!/bin/sh

#############################################################
# Name: config cobra
# Desc: a script for config all the cofig file.
############################################################

apipath="/opt/cobra/cobra-api/"
tomcatpath="/usr/share/tomcat6/webapps/"
mulepath="/opt/mule-service/mule-standalone/"

valid_ip(){
    local  ip=$1
    local  stat=1
    if [[ $ip =~ ^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$ ]]; then
        OIFS=$IFS
        IFS='.'
        ip=($ip)
        IFS=$OIFS
        [[ ${ip[0]} -le 255 && ${ip[1]} -le 255 && ${ip[2]} -le 255 && ${ip[3]} -le 255 ]]
        stat=$?
    fi          
    return $stat
}    

read -p "Please input corba-api ip address:" apiaddr
#if [ -z "$apiaddr" ];
#then
#        apiaddr="127.0.0.1"
#fi

count=0
while !(valid_ip "$apiaddr") 
do 
if [[ $count -eq 3 ]];
then 
	echo "Error ip address,quit."
	exit 1
else
	echo "Error ip address,please reput."
	read -p "Please input corba-api ip address:" apiaddr
fi
let count++
done

read -p "Please input database ip address[$apiaddr]:" ipaddress
if [ -z "$ipaddress" ];
then
        ipaddress=$apiaddr
fi

count=0
while !(valid_ip "$ipaddress") 
do
if [[ $count -eq 3 ]];
then
        echo "Error ip address,quit."
        exit 1
else
        echo "Error ip address,please reput."
        read -p "Please input corba-api ip address:" apiaddr
fi
let count++
done


read -p "Please input database name [icinga]:" databasename
if [ -z "$databasename" ];
then 
	databasename="icinga"
fi
read -p "Please input database username [icinga]:" username
if [ -z "$username" ];
then
        username="icinga"
fi
read -s -p "Please input database password [icinga]:" password
if [ -z "$password" ];
then
        password="icinga"
fi
echo 
read -p "Please input database port [3306]:" port
if [ -z "$port" ];
then
        port="3306"
fi

apifilename="config.conf"
if [ -f $apipath$apifilename ];
then
	dos2unix $apipath$apifilename >/dev/null 2>&1
	mv $apipath$apifilename $apipath$apifilename".bak"
else 
	echo $apipath$apifilename" not exist,config quit."
	exit 0
fi
cat $apipath$apifilename".bak" | sed '$s/$/\n/' | while read line 
do 
	case $line in
	db_host*)
		echo "db_host=$ipaddress" >> $apipath$apifilename;;
	db_port*)
		echo "db_port=$port" >> $apipath$apifilename;;
	db_user*)
		echo "db_user=$username" >> $apipath$apifilename;;
	db_pass*)
		echo "db_pass=$password" >> $apipath$apifilename;;
	db_name*)
		echo "db_name=$databasename" >> $apipath$apifilename;;
	server_ip*)
		echo "server_ip=$apiaddr" >> $apipath$apifilename;;
	*)
		echo $line >> $apipath$apifilename;;
	esac
#	if [[ $line == db_host* ]];
#	then
#		echo "db_host=$apiaddr" >> $apipath$apifilename
#	elif [[ $line == db_port* ]];
#	then 
#		echo $line >> $apipath$apifilename
#	fi
done

mulefilename="apps/cobra-esb/classes/mule_config.properties"
if [ -f $mulepath$mulefilename ];
then
        dos2unix $mulepath$mulefilename >/dev/null 2>&1
        mv $mulepath$mulefilename $mulepath$mulefilename".bak"
else
        echo $mulepath$mulefilename" not exist,config quit."
        exit 0
fi
cat $mulepath$mulefilename".bak" | sed '$s/$/\n/' | while read line 
do
        case $line in
        mysql.user*)
                echo "mysql.user=$username" >> $mulepath$mulefilename;;
        mysql.password*)
                echo "mysql.password=$password" >> $mulepath$mulefilename;;
        mysql.url*)
                echo "mysql.url=jdbc:mysql://$ipaddress:$port/$databasename?useUnicode=true&characterEncoding=utf8" >> $mulepath$mulefilename;;
        cobraData.url*)
                echo "cobraData.url=http://$apiaddr:8083" >> $mulepath$mulefilename;;
        *)
                echo $line >> $mulepath$mulefilename;;
        esac
done
IFS=;
casdatabasefile="neokylin-cas/WEB-INF/deployerConfigContext.xml"
if [ -f $tomcatpath$casdatabasefile ];
then
        dos2unix $tomcatpath$casdatabasefile >/dev/null 2>&1
        mv $tomcatpath$casdatabasefile $tomcatpath$casdatabasefile".bak"
else
        echo $tomcatpath$casdatabasefile" not exist,config quit."
        exit 0
fi
i=""
cat $tomcatpath$casdatabasefile".bak" | sed '$s/$/\n/' | while read line 
do
	if [[ $i == "url" ]];
	then
		i=""
		continue
	elif [[ $i == "username" ]];
	then 
		i=""
		continue
	elif [[ $i == "password" ]];
	then
		i=""
                continue
	fi
        case $line in
        *url*)
                echo $line >> $tomcatpath$casdatabasefile
		echo -e "\t\t\t<value>jdbc:mysql://$ipaddress:$port/$databasename?autoReconnect=true</value>" >> $tomcatpath$casdatabasefile
		i="url"
		;;
	*name=\"username\"*)
		echo $line >> $tomcatpath$casdatabasefile
		echo -e "\t\t\t<value>$username</value>" >> $tomcatpath$casdatabasefile
		i="username"
		;;
        *name=\"password\"*)
                echo $line >> $tomcatpath$casdatabasefile
		echo -e "\t\t\t<value>$password</value>" >> $tomcatpath$casdatabasefile
                i="password"
                ;;
	
        *)
		echo $line >> $tomcatpath$casdatabasefile
		;;
        esac
done

webcasipfile="cobra-web/WEB-INF/web.xml"
if [ -f $tomcatpath$webcasipfile ];
then
        dos2unix $tomcatpath$webcasipfile >/dev/null 2>&1
        mv $tomcatpath$webcasipfile $tomcatpath$webcasipfile".bak"
else
        echo $tomcatpath$webcasipfile" not exist,config quit."
        exit 0
fi
i=""
cat $tomcatpath$webcasipfile".bak" | sed '$s/$/\n/' | while read line 
do
        if [[ $i == "servername" ]];
        then
                i=""
                continue
        elif [[ $i == "logouturl" ]];
        then
                i=""
                continue
        elif [[ $i == "loginurl" ]];
        then
                i=""
                continue
	elif [[ $i == "serverurl" ]];
	then
		i=""
		continue
        fi
        case $line in
        *serverName*)
                echo $line >> $tomcatpath$webcasipfile
                echo -e "\t\t<param-value>http://$apiaddr:8080</param-value>" >> $tomcatpath$webcasipfile
                i="servername"
                ;;
        *casServerLogoutUrl*)
                echo $line >> $tomcatpath$webcasipfile
                echo -e "\t\t<param-value>http://$apiaddr:8080/neokylin-cas/logout</param-value>" >> $tomcatpath$webcasipfile
                i="logouturl"
                ;;
        *casServerLoginUrl*)
                echo $line >> $tomcatpath$webcasipfile
                echo -e "\t\t\t<param-value>http://$apiaddr:8080/neokylin-cas/login</param-value>" >> $tomcatpath$webcasipfile
                i="loginurl"
                ;;
	*casServerUrlPrefix*)
		echo $line >> $tomcatpath$webcasipfile
		echo -e "\t\t\t<param-value>http://$apiaddr:8080/neokylin-cas</param-value>" >> $tomcatpath$webcasipfile 
		i="serverurl"
		;;

        *)
                echo $line >> $tomcatpath$webcasipfile
                ;;
        esac
done

cobraesbfile="cobra-web/WEB-INF/classes/config.properties"
if [ -f $tomcatpath$cobraesbfile ];
then
        dos2unix $tomcatpath$cobraesbfile >/dev/null 2>&1
        mv $tomcatpath$cobraesbfile $tomcatpath$cobraesbfile".bak"
else
        echo $tomcatpath$cobraesbfile" not exist,config quit."
        exit 0
fi
cat $tomcatpath$cobraesbfile".bak" | sed '$s/$/\n/' | while read line 
do
        case $line in
        sys_cobra_esbserver_url*)
                echo "sys_cobra_esbserver_url=http://$apiaddr:8083" >> $tomcatpath$cobraesbfile;;
        gluster.server.url*)
                echo "gluster.server.url=https://$apiaddr:8081" >> $tomcatpath$cobraesbfile;;
        sys_cobra_conf_server_url*)
                echo "sys_cobra_conf_server_url=http://$apiaddr:8083" >> $tomcatpath$cobraesbfile;;
        *)
                echo $line >> $tomcatpath$cobraesbfile;;
        esac
done

