#-*-coding = utf-8 -*-
from src.bottle import Bottle, run
from src.bottle import request, response
from src.bottle import error
from src.utils import utils
import json
from src.bottle import static_file
import commands
import traceback
import ConfigParser
from src.monitor.api import CobraApi
from src.config.service import actionutils, createconfigfile, timeperiod, switchportscan, datacollect
from src.config.autodiscovery import discovery_new
import sys
from src.bottle import PasteServer
import os
reload(sys)
sys.setdefaultencoding('utf-8')
#print sys.getdefaultencoding()

#config
'''
global hostip
global port
hostip = '127.0.0.1'
port = 8080
'''
conf = ConfigParser.ConfigParser()
cfg_file = "/opt/cobra/cobra-api/config.conf"
#cfg_file = "../config.conf"
conf.read(cfg_file)
server_ip = conf.get("server", "server_ip")
server_port = conf.get("server", "server_port")
service_path = "/opt/cobra/cobra-api/src/var/"
app = Bottle()

if os.path.exists(service_path) == False:
    os.mkdir(service_path)

###################### JSON dict decorator ########################


def json_wrapper(func):
    def _func(*args, **kwargs):
        try:
            result = func(*args, **kwargs)

            if isinstance(result, (str, unicode)):
                try:
                    result = json.loads(result)
                except:
                    pass

            if isinstance(result, dict) and 'action' in result:
                return result

            if result is None:
                return {'action': True}
            return {'action': True, 'data': result}
        except:
            traceback.print_exc()
            exc_type, exc_value, exc_traceback = sys.exc_info()
            return {'action': False, 'error': str(exc_value)}

    return _func

####################################### API for autodiscovery #######################################


@app.route('/conf/autodiscovery/jobs', method='GET')
@json_wrapper
def get_jobs():
    jobs = discovery_new.get_all_jobs()
    return jobs


@app.route('/conf/autodiscovery/jobscan', method='GET')
@json_wrapper
def scan_job():
    jobid = request.query.jobid
    iprange = request.query.iprange
    filename = request.query.filename
    jobs = discovery_new.scan_job(jobid, iprange, filename)
    return jobs


@app.route('/conf/autodiscovery/newjob', method='GET')
@json_wrapper
def save_jobs():
    #jobs = CobraApi.get_all_jobs()
    iprange = request.query.iprange
    filename = request.query.filename
    jobs = discovery_new.do_jobs(iprange, filename)
    return jobs

'''
# NO-USE
@app.route('/conf/autodiscovery/<jobid:int>/jobdetails', method='GET')
@json_wrapper
def get_jobdetail(jobid):
    assert isinstance(jobid, int)
    result = discovery_new.get_job_result(jobid)
    if result['state'] == 1:
        return static_file(result['filename'], './')
    else:
        return None
'''

####################################### API for monitor #######################################
@app.route('/monitor/hosts', method='GET')
@json_wrapper
def monitor_hosts():
    '''Interface to get hosts
    market: start-number of hosts of asking for
    limit: count of hosts of asking for
    status: host status, -1 stands fo problem, 0 stands for ok, other number stand for all
    
    data: return data, json.'''
    marker = request.query.marker or 0
    limit = request.query.limit or 0
    status = request.query.status or 111
    keyword = request.query.keyword.strip().lower()
    keyword = utils.dealspecialstr(keyword)
    if keyword == "":
        data = CobraApi.get_hosts(
            utils.data_to_int(status), utils.data_to_int(limit),
            utils.data_to_int(marker))
    else:
        data = CobraApi.get_host_by_keyword(
            utils.data_to_int(limit), utils.data_to_int(marker), keyword)
    print data
    return data


@app.route('/monitor/host/<hostid:int>', method='GET')
@json_wrapper
def monitor_host_detail(hostid):
    '''get host detail information'''
    assert isinstance(hostid, int)
    #print request.url
    #print request.content_length
    data = CobraApi.get_host_by_id(hostid)
    return data


@app.route('/monitor/services', method='GET')
@json_wrapper
def monitor_services():
    '''get all services'''
    marker = request.query.marker or 0
    limit = request.query.limit or 0
    status = request.query.status or 111
    keyword = request.query.keyword.strip().lower()
    keyword = utils.dealspecialstr(keyword)
    if keyword == "":
        data = CobraApi.get_services(
            utils.data_to_int(status), utils.data_to_int(limit),
            utils.data_to_int(marker))
    else:
        data = CobraApi.get_services_by_keyword(
            utils.data_to_int(limit), utils.data_to_int(marker), keyword)
    return data


@app.route('/monitor/host/<hostid:int>/services', method='GET')
@json_wrapper
def monitor_host_service(hostid):
    '''get all services of one host'''
    assert isinstance(hostid, int)
    data = CobraApi.get_service_by_host(hostid)
    return data


@app.route('/monitor/host/<hid:int>/service/<sid:int>', method='GET')
@json_wrapper
def monitor_service_detail(hid, sid):
    '''get details of one service(belonging to one host)'''
    assert isinstance(hid, int)
    assert isinstance(sid, int)
    data = CobraApi.get_service_by_id(hid, sid)
    return data


@app.route('/monitor/hostgroups', method='GET')
@json_wrapper
def monitor_hostgroups():
    '''get hostgroup info'''
    limit = request.query.limit or 0
    marker = request.query.marker or 0
    data = CobraApi.get_hostgroups(
        utils.data_to_int(limit), utils.data_to_int(marker))
    print data
    return data


@app.route('/monitor/hostgroup/<hostgroupid:int>/hosts', method='GET')
@json_wrapper
def monitor_hostgroup_hosts(hostgroupid):
    '''get all hosts of one hostgroup'''
    assert isinstance(hostgroupid, int)
    limit = request.query.limit or 0
    marker = request.query.marker or 0
    data = CobraApi.get_hostgroup_hosts(hostgroupid, utils.data_to_int(limit),
                                        utils.data_to_int(marker))
    return data


@app.route('/monitor/logentries', method='GET')
@json_wrapper
def monitor_logentries():
    '''
    get all log entries
    '''
    limit = request.query.limit or 0
    marker = request.query.marker or 0
    keyword = request.query.keyword.strip().lower()
    keyword = utils.dealspecialstr(keyword)
    if (keyword == ""):
        data = CobraApi.get_logentries(
            utils.data_to_int(limit), utils.data_to_int(marker))
    else:
        data = CobraApi.get_logentries_by_keyword(
            utils.data_to_int(limit), utils.data_to_int(marker), keyword)
    return data


'''API for remote control'''


@app.route('/monitor/remotectl', method='GET')
@json_wrapper
def monitor_get_ipmiobj_by_host():
    hostname = request.query.hostname
    data = CobraApi.get_ipmiobj_by_host(hostname)
    print data
    return data


'''
@app.route('/monitor/remotectl', method='POST')
@json_wrapper
def monitor_modify_ipmiobj():
    data = utils.unicode2dict(request.json)
    CobraApi.modify_ipmiobj(data)    
'''


@app.route('/monitor/remotectl/detect', method='POST')
@json_wrapper
def monitor_detect_ipmiobj():
    cmd = request.query.cmd
    #data = utils.unicode2dict(request.json)
    data = request.json
    #print data
    detect_result = CobraApi.detect_remotehost(data, cmd)
    return detect_result


@app.route('/monitor/remotectl/detectall', method='POST')
@json_wrapper
def monitor_detect_all_ipmiobj():
    names = request.query.names
    cmd = request.query.cmd
    result = CobraApi.detect_all_remotehost(names, cmd)
    return result


@app.route('/monitor/checkhostcount', method='GET')
@json_wrapper
def monitor_hostcount_isame():
    result = actionutils.restartcount('host')
    if not result:  # throw Exception when operation failed
        raise Exception('check host count failed')


@app.route('/monitor/checkservicecount', method='GET')
@json_wrapper
def monitor_servicecount_isame():
    result = actionutils.restartcount('service')
    if not result:  # throw Exception when operation failed
        raise Exception('check service count failed')


####################################### API for configure #######################################
# define commandtypes' data
resultlist = [{'id':1,'type_name':'system','hosttype_id':0},\
              {'id':21,'type_name':'Linux-Basic performance monitoring','hosttype_id':1},\
              {'id':22,'type_name':'Linux-Public application services','hosttype_id':1},\
              {'id':23,'type_name':'Linux-Databases','hosttype_id':1},\
              {'id':24,'type_name':'Linux-Middleware','hosttype_id':1},\
              {'id':3,'type_name':'Windows','hosttype_id':2},\
              {'id':4,'type_name':'SNMP','hosttype_id':3},\
              {'id':5,'type_name':'Switch','hosttype_id':4}]
#{'id':6,'type_name':'Printer','hosttype_id':5},\
#{'id':7,'type_name':'VM','hosttype_id':6}]
tblclass = 'commandtypes'
data = {tblclass: resultlist}
commandtypedata = json.dumps(data, ensure_ascii=False, encoding='utf-8')


def get(obj):
    fieldname = request.query.field
    print fieldname
    type = request.query.type
    marker = utils.data_to_int(request.query.marker or 0)
    limit = utils.data_to_int(request.query.limit or 0)
    if fieldname == '':
        if obj == 'hosttype' or obj == 'hostdistribution' or obj == 'hosthardwaretype':
            resultdata = actionutils.selectall(obj, marker, limit)
        else:
            resultdata = actionutils.selectall(obj, marker, limit,
                                               obj + "_name")
    else:
        if obj == 'command':
            resultdata = actionutils.selecttwofieldvalue(
                'command', 'id', fieldname, {'command_type': type})
        else:
            resultdata = actionutils.selecttwofieldvalue(obj, 'id', fieldname)
    return resultdata


def transferinsert():
    #data = utils.unicode2dict(request.json)
    data = request.json
    item = {}
    for key, value in data.items():
        if value and key != 'id':
            item[key] = value
    return item


def get_by_type(obj, colname, colvalue):
    fieldname = request.query.field
    key_value = {colname: colvalue}
    if fieldname == '':
        resultdata = actionutils.selectdetailinformation(obj, key_value)
    else:
        resultdata = actionutils.selecttwofieldvalue(obj, 'id', fieldname,
                                                     key_value)
    return resultdata


def check(tblclass, key, value):
    #data=[value]
    #result=actionutils.selectvalues(tblclass, key, data)
    result = actionutils.selectdetailinformation(tblclass, {key: value})
    return result


@app.route("/conf/configitems", method="POST")
@json_wrapper
def insert_cofnigitems():
    #obj = request.json

    #data = utils.unicode2dict(request.json)
    data = request.json
    print data
    #print data
    if isinstance(data["configitem"], list):
        #print "configitem is a list"
        for item in data["configitem"]:
            hostinformation = item["host"]
            services = item["services"]
            # insert host
            new_item = {}
            for key, value in hostinformation.items():
                if value and key != 'id':
                    new_item[key] = value
            updatehostgroupid = ""
            if new_item.has_key("hostgroups"):
                updatehostgroupid = new_item["hostgroups"]
                del new_item["hostgroups"]
            insertid = actionutils.insertoneinformation("host", new_item)
            if updatehostgroupid != "":
                updata = actionutils.selectdetailinformation(
                    'hostgroup', {'id': updatehostgroupid})
                if updata != {}:
                    updata = eval(updata)
                    updata = updata['hostgroups'][0]
                    updata['members'] = updata['members'] + "," + str(insertid)
                    actionutils.updateoneinformation(
                        'hostgroup', {'id': updatehostgroupid}, updata)

                    # insert service(s)
            if isinstance(services, list):
                #print "services is a list"
                for serviceinformation in services:
                    new_item = {}
                    for key, value in serviceinformation.items():
                        if value and key != 'id':
                            new_item[key] = str(value)
                    new_item['config_name'] = str(new_item['host_name'])
                    new_item['host_name'] = str(insertid)
                    actionutils.insertoneinformation("service", new_item)
            elif isinstance(services, dict):
                new_item = {}
                for key, value in services.items():
                    if value and key != 'id':
                        new_item[key] = str(value)
                new_item['config_name'] = new_item['host_name']
                new_item['host_name'] = str(insertid)
                actionutils.insertoneinformation("service", new_item)

    elif isinstance(data["configitem"], dict):
        #print "dict"
        hostinformation = data["configitem"]["host"]
        services = data["configitem"]["services"]
        # insert host
        new_item = {}
        for key, value in hostinformation.items():
            if value and key != 'id':
                new_item[key] = str(value)
        updatehostgroupid = ""
        if new_item.has_key("hostgroups"):
            updatehostgroupid = new_item["hostgroups"]
            del new_item["hostgroups"]
        insertid = actionutils.insertoneinformation("host", new_item)
        if updatehostgroupid != "":
            updata = actionutils.selectdetailinformation(
                'hostgroup', {'id': updatehostgroupid})
            if updata != {}:
                updata = eval(updata)
                updata = updata['hostgroups'][0]
                updata['members'] = updata['members'] + "," + str(insertid)
                actionutils.updateoneinformation(
                    'hostgroup', {'id': updatehostgroupid}, updata)
        # insert service(s)

        if isinstance(services, list):
            #print "services is a list"
            for serviceinformation in services:
                new_item = {}
                for key, value in serviceinformation.items():
                    if value and key != 'id':
                        new_item[key] = value
                new_item['config_name'] = new_item['host_name']
                new_item['host_name'] = str(insertid)
                actionutils.insertoneinformation("service", new_item)
        elif isinstance(services, dict):
            new_item = {}
            for key, value in services.items():
                if value and key != 'id':
                    new_item[key] = value
            new_item['config_name'] = new_item['host_name']
            new_item['host_name'] = str(insertid)
            actionutils.insertoneinformation("service", new_item)
    return {'hostid': insertid}


@app.route("/conf/createconfigfile", method='POST')
@json_wrapper
def create_configfile():
    createconfigfile.creatConfig().createcommandconfig()
    createconfigfile.creatConfig().createcontactconfig()
    createconfigfile.creatConfig().creathostconfig()
    createconfigfile.creatConfig().createhostgroupconfig()
    createconfigfile.creatConfig().createcontactgroupconfig()
    createconfigfile.creatConfig().creatservcieconfig()
    createconfigfile.creatConfig().createtimeconfig()
    #check config file
    checkcmd = '/opt/cobra/icinga/bin/icinga -v /opt/cobra/icinga/etc/icinga.cfg'
    (status, output) = commands.getstatusoutput(checkcmd)
    if status != 0:
        errorResult = ''
        outerror = output.split("\n")
        for eachline in outerror:
            errorline = eachline.find('Error')
            if errorline != -1:
                if errorResult == '':
                    errorResult = eachline
                else:
                    errorResult = errorResult + "\n" + eachline
        raise Exception(errorResult)
    cmd = "service cobra reload"
    #os.popen(cmd)
    (status, output) = commands.getstatusoutput(cmd)
    #print output,status
    if status != 0:
        raise Exception(output)


'''
API for HOSTGROUPS
'''


@app.route('/conf/hostgroups', method='GET')
@json_wrapper
def get_hostgroups():
    resultdata = get('hostgroup')
    return resultdata


@app.route('/conf/hostgroup/<hostgroupID:int>', method='GET')
@json_wrapper
def get_one_hostgroup(hostgroupID):
    key_vlaue = {'id': hostgroupID}
    result = actionutils.selectdetailinformation('hostgroup', key_vlaue)
    return result


@app.route('/conf/hostgroup', method='POST')
@json_wrapper
def insert_one_hostgroup():
    key_value = transferinsert()
    result = actionutils.insertoneinformation('hostgroup', key_value)


@app.route('/conf/hostgroup/<hostgroupID:int>', method='PUT')
@json_wrapper
def update_one_hostgroup(hostgroupID):
    #key_value=utils.unicode2dict(request.json)
    key_value = request.json
    actionutils.updateoneinformation('hostgroup', {'id': hostgroupID},
                                     key_value)


@app.route('/conf/hostgroup/checkname/<hostgroupName>', method='GET')
@json_wrapper
def check_hostgroup(hostgroupName):
    result = check('hostgroup', 'hostgroup_name', hostgroupName)
    return result


@app.route('/conf/hostgroup/<hostgroupID:int>', method='DELETE')
@json_wrapper
def delete_one_hostgroup(hostgroupID):
    actionutils.deleteoneinformation('hostgroup', {'id': hostgroupID})


@app.route('/conf/hostgroup/inuse/<hostgroupID>', method='GET')
@json_wrapper
def check_hostgroupinuse(hostgroupID):
    result = actionutils.checkinuse('hostgroup', {'id': hostgroupID})
    return result


'''
API for HOSTS
'''


@app.route('/conf/hosts', method='GET')
@json_wrapper
def get_hosts():
    resultdata = get('host')
    return resultdata


@app.route('/conf/hosthwtypes', method='GET')
@json_wrapper
def get_hwtypes():
    resultdata = get('hosthardwaretype')
    return resultdata


@app.route('/conf/hosttypes', method='GET')
@json_wrapper
def get_hosttypes():
    resultdata = get('hosttype')
    return resultdata


@app.route('/conf/hostdistributions', method='GET')
@json_wrapper
def get_hostdistributions():
    resultdata = get('hostdistribution')
    return resultdata


@app.route('/conf/hosttype/<hosttypeid:int>/distributions', method='GET')
@json_wrapper
def get_hostdistributions_by_typeid(hosttypeid):
    resultdata = get_by_type('hostdistribution', 'hosttype_id', hosttypeid)
    return resultdata


@app.route('/conf/host/<hostID:int>', method='GET')
@json_wrapper
def get_one_host(hostID):
    key_vlaue = {'id': hostID}
    result = actionutils.selectdetailinformation('host', key_vlaue)
    return result


@app.route('/conf/host', method='POST')
@json_wrapper
def insert_one_host():
    key_value = transferinsert()
    result = actionutils.insertoneinformation('host', key_value)
    return {'hostid': result}

@app.route('/conf/host/<hostID:int>', method='POST')
@json_wrapper
def alter_one_host(hostID):
    if request.query.method=='put' or request.query.method=="PUT":
	key_value = request.json
        actionutils.updateoneinformation('host', {'id': hostID}, key_value) 
    else:
	result = actionutils.checkinuse('host', {'id': hostID})
        result = eval(result)
        if result.has_key("services"):
            st = result["services"]
            for item in st:
                actionutils.deleteoneinformation('service', {'id': item["id"]})
        actionutils.deleteoneinformation('host', {'id': hostID})

@app.route('/conf/host/<hostID:int>', method='PUT')
@json_wrapper
def update_one_host(hostID):
    #key_value=utils.unicode2dict(request.json)
    key_value = request.json
    actionutils.updateoneinformation('host', {'id': hostID}, key_value)


@app.route('/conf/host/checkname/<hostName>', method='GET')
@json_wrapper
def check_host(hostName):
    result = check('host', 'host_name', hostName)
    return result


@app.route('/conf/host/<hostID:int>', method='DELETE')
@json_wrapper
def delete_one_host(hostID):
    result = actionutils.checkinuse('host', {'id': hostID})
    result = eval(result)
    if result.has_key("services"):
        st = result["services"]
        for item in st:
            actionutils.deleteoneinformation('service', {'id': item["id"]})
    actionutils.deleteoneinformation('host', {'id': hostID})


@app.route('/conf/host/inuse/<hostID>', method='GET')
@json_wrapper
def check_hostinuse(hostID):
    result = actionutils.checkinuse('host', {'id': hostID})
    result = eval(result)
    print result
    if result.has_key("services"):
        del result["services"]
    if result.has_key("hostgroups"):
        del result["hostgroups"]
    result = json.dumps(result, ensure_ascii=False, encoding='utf-8')
    print type("result")
    return result


'''
API for SERVICES
'''


@app.route('/conf/services', method='GET')
@json_wrapper
def get_services():
    #resultdata = get('service')
    marker = utils.data_to_int(request.query.marker or 0)
    limit = utils.data_to_int(request.query.limit or 0)
    resultdata = actionutils.selectallservicewithname(
        'service', marker, limit, "config_name,service_description")
    return resultdata


@app.route('/conf/service/<serviceID:int>', method='GET')
@json_wrapper
def get_one_service(serviceID):
    key_vlaue = {'id': serviceID}
    result = actionutils.selectdetailinformation('service', key_vlaue)
    return result


@app.route('/conf/service', method='POST')
@json_wrapper
def insert_one_service():
    key_value = transferinsert()
    result = actionutils.insertoneinformation('service', key_value)
    return {'serviceid': result}

@app.route('/conf/service/<serviceID:int>', method='POST')
@json_wrapper
def alter_one_service(serviceID):
    if request.query.method=='put' or request.query.method=="PUT":
	key_value = request.json
        actionutils.updateoneinformation('service', {'id': serviceID},
                                              key_value)
    else:
	actionutils.deleteoneinformation('service', {'id': serviceID})

@app.route('/conf/service/<serviceID:int>', method='PUT')
@json_wrapper
def update_one_service(serviceID):
    #key_value=utils.unicode2dict(request.json)
    key_value = request.json
    actionutils.updateoneinformation('service', {'id': serviceID},
                                              key_value)


@app.route('/conf/service/<serviceID:int>', method='DELETE')
@json_wrapper
def delete_one_service(serviceID):
    actionutils.deleteoneinformation('service', {'id': serviceID})


@app.route('/conf/service/inuse/<serviceID>', method='GET')
@json_wrapper
def check_serviceinuse(serviceID):
    result = actionutils.checkinuse('service', {'id': serviceID})
    return result


@app.route('/conf/service/checkname/<hostid>', method='GET')
@json_wrapper
def check_service(hostid):
    serviceName = request.query.servicename
    result = check('service', 'service_description', serviceName)
    if result != {}:
        result = json.loads(result)
        for item in result['services']:
            if item['host_name'] == hostid:
                data = {'services': [item]}
                encodedata = json.dumps(data,
                                        ensure_ascii=False,
                                        encoding='utf-8')
                return encodedata
    return {'action':False}


'''
API for CONTACTGROUPS
'''


@app.route('/conf/contactgroups', method='GET')
@json_wrapper
def get_contactgroups():
    resultdata = get('contactgroup')
    return resultdata


@app.route('/conf/contactgroup/<contactgroupID:int>', method='GET')
@json_wrapper
def get_one_contactgroup(contactgroupID):
    key_vlaue = {'id': contactgroupID}
    result = actionutils.selectdetailinformation('contactgroup', key_vlaue)
    return result


@app.route('/conf/contactgroup', method='POST')
@json_wrapper
def insert_one_contactgroup():
    key_value = transferinsert()
    actionutils.insertoneinformation('contactgroup', key_value)


@app.route('/conf/contactgroup/<contactgroupID:int>', method='PUT')
@json_wrapper
def update_one_contactgroup(contactgroupID):
    #key_value=utils.unicode2dict(request.json)
    key_value = request.json
    actionutils.updateoneinformation('contactgroup', {'id': contactgroupID},
                                     key_value)


@app.route('/conf/contactgroup/checkname/<contactgroupName>', method='GET')
@json_wrapper
def check_contactgroup(contactgroupName):
    result = check('contactgroup', 'contactgroup_name', contactgroupName)
    return result


@app.route('/conf/contactgroup/<contactgroupID:int>', method='DELETE')
@json_wrapper
def delete_one_contactgroup(contactgroupID):
    actionutils.deleteoneinformation('contactgroup', {'id': contactgroupID})


@app.route('/conf/contactgroup/inuse/<contactgroupID>', method='GET')
@json_wrapper
def check_contactgroupinuse(contactgroupID):
    result = actionutils.checkinuse('contactgroup', {'id': contactgroupID})
    return result


'''
API for CONTACTS
'''


@app.route('/conf/contacts', method='GET')
@json_wrapper
def get_contacts():
    resultdata = get('contact')
    return resultdata


@app.route('/conf/contact/<contactID:int>', method='GET')
@json_wrapper
def get_one_contact(contactID):
    key_vlaue = {'id': contactID}
    result = actionutils.selectdetailinformation('contact', key_vlaue)
    return result


@app.route('/conf/contact/checkname/<contactName>', method='GET')
@json_wrapper
def check_contact(contactName):
    result = check('contact', 'contact_name', contactName)
    return result


@app.route('/conf/contact', method='POST')
@json_wrapper
def insert_one_contact():
    #item=transferinsert()
    data = request.json
    if data['host_notification_options'].endswith('u'):
        data['host_notification_options'] = data[
            'host_notification_options'] + ' '
    if data['service_notification_options'].endswith('u'):
        data['service_notification_options'] = data[
            'service_notification_options'] + ' '
    #data=utils.unicode2dict(data)
    item = {}
    for key, value in data.items():
        if value and key != 'id':
            item[key] = value
    result = actionutils.insertoneinformation('contact', item)
    return str(result)

@app.route('/conf/contact/<contactID:int>', method='POST')
@json_wrapper
def alter_one_contact(serviceID):
    if request.query.method=='put' or request.query.method=="PUT":
	data = request.json
    	if data['host_notification_options'].endswith('u'):
            data['host_notification_options'] = data[
           	 'host_notification_options'] + ' '
    	if data['service_notification_options'].endswith('u'):
            data['service_notification_options'] = data[
                'service_notification_options'] + ' '
        actionutils.updateoneinformation('contact', {'id': contactID}, data)
    else:
        actionutils.deleteoneinformation('contact', {'id': contactID})

@app.route('/conf/contact/<contactID:int>', method='PUT')
@json_wrapper
def update_one_contact(contactID):
    data = request.json
    if data['host_notification_options'].endswith('u'):
        data['host_notification_options'] = data[
            'host_notification_options'] + ' '
    if data['service_notification_options'].endswith('u'):
        data['service_notification_options'] = data[
            'service_notification_options'] + ' '
    actionutils.updateoneinformation('contact', {'id': contactID}, data)


@app.route('/conf/contact/<contactID:int>', method='DELETE')
@json_wrapper
def delete_one_contact(contactID):
    actionutils.deleteoneinformation('contact', {'id': contactID})


@app.route('/conf/contact/inuse/<contactID>', method='GET')
@json_wrapper
def check_contactinuse(contactID):
    result = actionutils.checkinuse('contact', {'id': contactID})
    return result


'''
API for COMMANDS
'''


@app.route('/conf/commands', method='GET')
@json_wrapper
def get_commands():
    #response.charset = 'UTF8'
    fieldname = request.query.field
    if request.query.ids:
        obj = 'command'
        keyitem = 'id'
        ids = str(request.query.ids).split(',')
        values = list(ids)
        if fieldname == '':
            resultdata = actionutils.selectvalues(obj, keyitem, values)

    elif request.query.type:
        #typeid = request.query.type
        #resultdata = get_by_type('command','command_type',typeid)
        typeid = str(request.query.type).split(',')
        values = list(typeid)
        #for i in values: 
        #    resultdata = get_by_type('command','command_type',i)
        resultdata = actionutils.selectvalues('command', 'command_type',
                                              values)
    else:
        resultdata = get('command')
    return resultdata


@app.route('/conf/commandtypes', method='GET')
@json_wrapper
def get_commandtypes():
    resultdata = commandtypedata
    return resultdata


@app.route('/conf/commandtypes/<hosttypeid:int>', method='GET')
@json_wrapper
def get_commandtypes_by_hosttype(hosttypeid):
    commandtypes = []
    for i in range(len(resultlist)):
        if resultlist[i]['hosttype_id'] == hosttypeid:
            commandtypes.append(resultlist[i])
    data = {'commandtypes': commandtypes}
    resultdata = json.dumps(data, ensure_ascii=False, encoding='utf-8')
    return resultdata


@app.route('/conf/command/<commandID:int>', method='GET')
@json_wrapper
def get_one_command(commandID):
    key_vlaue = {'id': commandID}
    result = actionutils.selectdetailinformation('command', key_vlaue)
    return result


@app.route('/conf/command/commandsdetail', method='GET')
@json_wrapper
def get_some_commandsdetail():
    key = 'id'
    values = request.query.ids
    result = actionutils.selectincommand('command', key, values)
    return result


@app.route('/conf/command', method='POST')
@json_wrapper
def insert_one_command():
    key_value = request.json
    key_value = transferinsert()
    actionutils.insertoneinformation('command', key_value)


@app.route('/conf/command/<commandID:int>', method='PUT')
@json_wrapper
def update_one_command(commandID):
    key_value = request.json
    #key_value=utils.unicode2dict(request.json)
    actionutils.updateoneinformation('command', {'id': commandID},
                                              key_value)


@app.route('/conf/command/checkname/<commandName>', method='GET')
@json_wrapper
def check_command(commandName):
    result = check('command', 'command_name', commandName)
    return result


@app.route('/conf/command/checkdisplayname/<displayName>', method='GET')
@json_wrapper
def check_displayname(displayName):
    result = check('command', 'display_name', displayName)
    return result


@app.route('/conf/command/<commandID:int>', method='DELETE')
@json_wrapper
def delete_one_command(commandID):
    actionutils.deleteoneinformation('command', {'id': commandID})


@app.route('/conf/command/inuse/<commandID>', method='GET')
@json_wrapper
def check_commandinuse(commandID):
    result = actionutils.checkinuse('command', {'id': commandID})
    return result


'''
API for TIMEPERIODS
'''


@app.route('/conf/timeperiods', method='GET')
@json_wrapper
def get_timeperiods():
    resultdata = get('timeperiod')
    return resultdata


@app.route('/conf/timeperiod/<timeperiodID:int>', method='GET')
@json_wrapper
def get_one_timeperiod(timeperiodID):
    resultlist = []
    resultlist.append(timeperiod.get_time_detail(timeperiodID))
    tblclass = 'timeperiods'
    data = {tblclass: resultlist}
    result = json.dumps(data, ensure_ascii=False, encoding='utf-8')
    return result


@app.route('/conf/timeperiod', method='POST')
@json_wrapper
def insert_one_timeperiod():
    #data = utils.unicode2dict(request.json)
    data = request.json
    del data['id']
    if isinstance(data['time_definitions'], list):
        for item in data['time_definitions']:
            del item['id']
    else:
        del data['time_definitions']['id']
        data['time_definitions'] = [data['time_definitions']]
    timeperiod.add_new_tp(data)


@app.route('/conf/timeperiod/<timeperiodID:int>', method='PUT')
@json_wrapper
def update_one_timeperiod(timeperiodID):
    #key_value=utils.unicode2dict(request.json)
    key_value = request.json
    timeperiod.update_tp(key_value)


@app.route('/conf/timeperiod/checkname/<timeperiodName>', method='GET')
@json_wrapper
def check_timeperiod(timeperiodName):
    resultlist = []
    resultlist.append(timeperiod.get_time_detail(0, timeperiodName))
    if resultlist == [{}]:
        return {}
    tblclass = 'timeperiods'
    data = {tblclass: resultlist}
    result = json.dumps(data, ensure_ascii=False, encoding='utf-8')
    return result


@app.route('/conf/timeperiod/<timeperiodID:int>', method='DELETE')
@json_wrapper
def delete_one_timeperiod(timeperiodID):
    timeperiod.del_tp({'id': timeperiodID})


@app.route('/conf/timeperiod/inuse/<timeperiodID>', method='GET')
@json_wrapper
def check_timeperiodinuse(timeperiodID):
    result = actionutils.checkinuse('timeperiod', {'id': timeperiodID})
    return result


@app.route('/conf/emailconfig', method='GET')
@json_wrapper
def get_emailconfig():
    data = actionutils.get_emaildetail()
    return data


@app.route('/conf/emailconfig', method='POST')
@json_wrapper
def set_emailconfig():
    #data = utils.unicode2dict(request.json)
    data = request.json
    print data
    actionutils.set_emaildetail(data)


@app.route(
    '/conf/services/switch/<snmpcommunity>,<address>,<snmpversion>,<defaultspeed>',
    method='GET')
@json_wrapper
def get_switch_services(snmpcommunity, address, snmpversion, defaultspeed):
    #print snmpcommunity, address, snmpversion, defaultspeed
    result = switchportscan.switch_configwizard_func(snmpcommunity, address,
                                                     snmpversion, defaultspeed)
    return result


'''
NEW API for SYSTEM-CENTER
'''


@app.route('/monitor/hostbyname/<hostname>', method='GET')
@json_wrapper
def monitor_host_detail_by_name(hostname):
    '''get host detail information'''
    '''hostname = request.query.hostname'''

    data = CobraApi.get_host_by_hostname(hostname)
    filename = service_path + hostname + ".host"
    if json.loads(data)['host_detail'] == []:
        if os.path.exists(filename):
            f = open(filename)
            data = f.read()
            f.close()
    else:
        f = open(filename, "w")
        f.write(data)
        f.close()
    return data


@app.route('/monitor/hostbyname/<hostname>/services', method='GET')
@json_wrapper
def monitor_host_service_by_hostname(hostname):
    '''get all services of one host'''
    data = CobraApi.get_service_by_hostname(hostname)
    filename = service_path + hostname + ".service"
    if json.loads(data)['services'] == []:
        if os.path.exists(filename):
            f = open(filename)
            data = f.read()
            f.close()
    else:
        f = open(filename, "w")
        f.write(data)
        f.close()
    return data


@app.route('/monitor/hostgroup/<hostgroupname>/hosts', method='GET')
@json_wrapper
def monitor_hostgroup_hosts_by_hostgroupname(hostgroupname):
    '''get all hosts of one hostgroup'''
    print hostgroupname
    limit = request.query.limit or 0
    marker = request.query.marker or 0
    data = CobraApi.get_hostgroup_hosts_by_hostgroupname(hostgroupname, limit,
                                                         marker)
    return data


@app.route('/conf/host/services/<hostid:int>', method='GET')
@json_wrapper
def get_host_servcies(hostid):
    hostname = request.query.hostname
    resulthosts = json.loads(actionutils.selectdetailinformation(
        'host', {'id': hostid}))
    resultservices = actionutils.selectdetailinformation(
        'service', {'config_name': hostname})
    if resultservices != {}:
        resultservices = json.loads(resultservices)

    resulthostinfo = {}
    if resulthosts and len(resulthosts) == 1:
        resulthostinfo['max_check_attempts'] = resulthosts['hosts'][0][
            'max_check_attempts']
        resulthostinfo['check_interval'] = resulthosts['hosts'][0][
            'check_interval']
        resulthostinfo['notification_interval'] = resulthosts['hosts'][0][
            'notification_interval']
        resulthostinfo['notifications_enabled'] = resulthosts['hosts'][0][
            'notifications_enabled']
        resulthostinfo['retry_interval'] = resulthosts['hosts'][0][
            'retry_interval']
        resulthostinfo['contacts'] = resulthosts['hosts'][0]['contacts']
        resulthostinfo['check_period'] = resulthosts['hosts'][0]['check_period']
        resulthostinfo['hw_type'] = resulthosts['hosts'][0]['hw_type']
        resulthostinfo['hw_password'] = resulthosts['hosts'][0]['hw_password']
        resulthostinfo['hw_user'] = resulthosts['hosts'][0]['hw_user']
        resulthostinfo['hw_address'] = resulthosts['hosts'][0]['hw_address']
    servicelist = []
    if resultservices != {}:
        for item in resultservices['services']:
            serviceitem = {}
            serviceitem['id'] = item['id']
            serviceitem['service_description'] = item['service_description']
            serviceitem['check_command'] = item['check_command']
            serviceitem['max_check_attempts'] = item['max_check_attempts']
            serviceitem['check_interval'] = item['check_interval']
            serviceitem['notification_interval'] = item[
                'notification_interval']
            serviceitem['notifications_enabled'] = item[
                'notifications_enabled']
            serviceitem['retry_interval'] = item['retry_interval']
            serviceitem['contacts'] = item['contacts']
            serviceitem['check_period'] = item['check_period']
            servicelist.append(serviceitem)
    result = {'host': resulthostinfo, 'services': servicelist}
    return json.dumps(result, ensure_ascii=False, encoding='utf-8')


@app.route('/conf/configitems/<hostid:int>', method="PUT")
@json_wrapper
def host_services_update(hostid):
    #put alter post
    key_value = request.json
    hostinfomation = key_value["configitem"]["host"]
    services = key_value["configitem"]["services"]
    actionutils.updateoneinformation('host', {'id': hostid}, hostinfomation)
    print hostinfomation
    print services
    # update service(s)
    for serviceinformation in services:
        print serviceinformation
        print "&&&&&&&&&&&&"
        new_item = {}
        for key, value in serviceinformation.items():
            if value and key != 'id':
                new_item[key] = value
        print "new_item", new_item
        serviceid = serviceinformation['id']
        new_item['config_name'] = new_item['host_name']
        new_item['host_name'] = str(hostid)
        actionutils.updateoneinformation("service", {'id': serviceid},
                                         new_item)


@app.route("/conf/createhostconfigfile", method='POST')
@json_wrapper
def create_hostconfigfile():
    createconfigfile.creatConfig().creathostconfig()
    createconfigfile.creatConfig().creatservcieconfig()
    #check config file
    checkcmd = '/usr/bin/icinga -v /etc/icinga/icinga.cfg'
    (status, output) = commands.getstatusoutput(checkcmd)
    if status != 0:
        errorResult = ''
        outerror = output.split("\n")
        for eachline in outerror:
            errorline = eachline.find('Error')
            if errorline != -1:
                if errorResult == '':
                    errorResult = eachline
                else:
                    errorResult = errorResult + "\n" + eachline
        raise Exception(errorResult)
    cmd = "service icinga reload"
    #os.popen(cmd)
    (status, output) = commands.getstatusoutput(cmd)
    #print output,status
    if status != 0:
        raise Exception(output)


@app.route("/conf/createserviceconfigfile", method='POST')
@json_wrapper
def create_serviceconfigfile():
    createconfigfile.creatConfig().creatservcieconfig()
    #check config file
    checkcmd = '/usr/bin/icinga -v /etc/icinga/icinga.cfg'
    (status, output) = commands.getstatusoutput(checkcmd)
    if status != 0:
        errorResult = ''
        outerror = output.split("\n")
        for eachline in outerror:
            errorline = eachline.find('Error')
            if errorline != -1:
                if errorResult == '':
                    errorResult = eachline
                else:
                    errorResult = errorResult + "\n" + eachline
        raise Exception(errorResult)
    cmd = "service icinga reload"
    (status, output) = commands.getstatusoutput(cmd)
    if status != 0:
        raise Exception(output)


@app.route("/conf/createcontactconfigfile", method='POST')
@json_wrapper
def create_contactconfigfile():
    createconfigfile.creatConfig().createcontactconfig()
    #check config file
    checkcmd = '/usr/bin/icinga -v /etc/icinga/icinga.cfg'
    (status, output) = commands.getstatusoutput(checkcmd)
    if status != 0:
        errorResult = ''
        outerror = output.split("\n")
        for eachline in outerror:
            errorline = eachline.find('Error')
            if errorline != -1:
                if errorResult == '':
                    errorResult = eachline
                else:
                    errorResult = errorResult + "\n" + eachline
        raise Exception(errorResult)
    cmd = "service icinga reload"
    #os.popen(cmd)
    (status, output) = commands.getstatusoutput(cmd)
    if status != 0:
        raise Exception(output)


@app.route('/monitordata', method='GET')
@json_wrapper
def api_monitordata():
    hostname = request.params.get('hostname')
    servicename = request.params.get('servicename')
    timestr = request.params.get('time')
    result = datacollect.rrddata().get_rrdfile_data_period(
        hostname, servicename, timestr)
    return json.dumps(result)


@app.route('/monitordata/now', method='GET')
@json_wrapper
def api_monitordata():
    hostname = request.params.get('hostname')
    servicename = request.params.get('servicename')
    result = datacollect.rrddata().get_rrdfile_data_now(hostname, servicename)
    return json.dumps(result)


@app.route('/monitordata/period', method='GET')
@json_wrapper
def api_monitordata():
    hostname = request.params.get('hostname')
    servicename = request.params.get('servicename')
    starttime = request.params.get('starttime')
    endtime = request.params.get('endtime')
    result = datacollect.rrddata().get_rrdfile_data_ex_period(
        hostname, servicename, starttime, endtime)
    return json.dumps(result)

@app.route('/api/notifications',method='GET')
@json_wrapper
def api_get_notifications():
    fromid = request.params.get('fromid', 0)
    size = request.params.get('limit', 50)
    resultdata = actionutils.selectallid('notification', int(fromid), int(size))
    return resultdata

@app.error(404)
def error404(error):
    return "path is wrong"


'''
RUN THE SERVER
'''
run(app, server=PasteServer, host=server_ip, port=server_port)
#run(app, host = server_ip, port = server_port)
