
from sqlalchemy import Column
from sqlalchemy.dialects.mysql import INTEGER, BIGINT, ENUM, VARCHAR
from sqlalchemy.ext.declarative import declarative_base

DeclarativeBase = declarative_base()

class TblAutodiscovery(DeclarativeBase):
    __tablename__='tbl_autodiscovery'
    
    id = Column('id', BIGINT(20), primary_key=True, autoincrement=True )
    iprange = Column('iprange', VARCHAR(255), default = '' )
    state = Column('state', ENUM('0','1'), default = 0 )
    count = Column('count', INTEGER(10), default = 0 )
    file_name = Column('file_name', VARCHAR(255), default = '' )
    
    def __init__(self, iprange = '', state = '0', count = 0, file_name = ''):
        
        self.iprange = iprange
        self.state = state
        self.count = count
        self.file_name = file_name
        
    def __repr__(self):
        
        return "{'id': %d, 'iprange': %s, 'state': %d, 'count': %d, 'file_name': %s}" \
            % (self.id, self.iprange, self.state, self.count, self.file_name)
        

    