
from sqlalchemy import *
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import relation
import time

DeclarativeBase = declarative_base()

class TblContact(DeclarativeBase):
    __tablename__ = 'tbl_contact'

    access_group = Column('access_group', INTEGER(), nullable=False)
    active = Column('active', Enum(u'0', u'1'), nullable=False)
    address1 = Column('address1', VARCHAR(length=255), nullable=False)
    address2 = Column('address2', VARCHAR(length=255), nullable=False)
    address3 = Column('address3', VARCHAR(length=255), nullable=False)
    address4 = Column('address4', VARCHAR(length=255), nullable=False)
    address5 = Column('address5', VARCHAR(length=255), nullable=False)
    address6 = Column('address6', VARCHAR(length=255), nullable=False)
    alias = Column('alias', VARCHAR(length=255), nullable=False)
    can_submit_commands = Column('can_submit_commands', Integer(), nullable=False)
    config_id = Column('config_id', Integer(), nullable=False)
    contact_name = Column('contact_name', VARCHAR(length=255), nullable=False)
    contactgroups = Column('contactgroups', INTEGER(), nullable=False)
    contactgroups_tploptions = Column('contactgroups_tploptions', Integer(), nullable=False)
    email = Column('email', VARCHAR(length=255), nullable=False)
    host_notification_commands = Column('host_notification_commands', INTEGER(), nullable=False)
    host_notification_commands_tploptions = Column('host_notification_commands_tploptions', Integer(), nullable=False)
    host_notification_options = Column('host_notification_options', VARCHAR(length=20), nullable=False)
    host_notification_period = Column('host_notification_period', INTEGER(), nullable=False)
    host_notifications_enabled = Column('host_notifications_enabled', Integer(), nullable=False)
    id = Column('id', INTEGER(), primary_key=True, autoincrement=True, nullable=False)
    last_modified = Column('last_modified', DATETIME(),nullable=False)
    name = Column('name', VARCHAR(length=255), nullable=False)
    pager = Column('pager', VARCHAR(length=255), nullable=False)
    register = Column('register', Enum(u'0', u'1'), nullable=False)
    retain_nonstatus_information = Column('retain_nonstatus_information', Integer(), nullable=False)
    retain_status_information = Column('retain_status_information', Integer(), nullable=False)
    service_notification_commands = Column('service_notification_commands', INTEGER(), nullable=False)
    service_notification_commands_tploptions = Column('service_notification_commands_tploptions', Integer(), nullable=False)
    service_notification_options = Column('service_notification_options', VARCHAR(length=20), nullable=False)
    service_notification_period = Column('service_notification_period', INTEGER(), nullable=False)
    service_notifications_enabled = Column('service_notifications_enabled', Integer(), nullable=False)
    use_template = Column('use_template', Integer(), nullable=False)
    use_template_tploptions = Column('use_template_tploptions', Integer(), nullable=False)
    use_variables = Column('use_variables', Integer(), nullable=False)
    
    def __init__(self,contact_name='',\
                alias='',\
                contactgroups=0,\
                contactgroups_tploptions=2,\
                host_notifications_enabled=1,\
                service_notifications_enabled=1,\
                host_notification_period=0,\
                service_notification_period=0,\
                host_notification_options='',\
                service_notification_options='',\
                host_notification_commands=0,\
                host_notification_commands_tploptions=2,\
                service_notification_commands=0,\
                service_notification_commands_tploptions=2,\
                can_submit_commands=1,\
                retain_status_information=1,\
                retain_nonstatus_information=1,\
                email='',\
                pager='',\
                address1='',\
                address2='',\
                address3='',\
                address4='',\
                address5='',\
                address6='',\
                name='',\
                use_variables=0,\
                use_template=0,\
                use_template_tploptions=2,\
                register='1',\
                active='1',\
                last_modified=time.strftime('%Y-%m-%d %H:%M:%S',time.localtime()),\
                access_group=0,\
                config_id=1
                ):
        self.contact_name=contact_name
        self.alias=alias
        self.contactgroups=contactgroups
        self.contactgroups_tploptions=contactgroups_tploptions
        self.host_notifications_enabled=host_notifications_enabled
        self.service_notifications_enabled=service_notifications_enabled
        self.host_notification_period=host_notification_period
        self.service_notification_period=service_notification_period
        self.host_notification_options=host_notification_options
        self.service_notification_options=service_notification_options
        self.host_notification_commands=host_notification_commands
        self.host_notification_commands_tploptions=host_notification_commands_tploptions
        self.service_notification_commands=service_notification_commands
        self.service_notification_commands_tploptions=service_notification_commands_tploptions
        self.can_submit_commands=can_submit_commands
        self.retain_status_information=retain_status_information
        self.retain_nonstatus_information=retain_nonstatus_information
        self.email=email
        self.pager=pager
        self.address1=address1
        self.address2=address2
        self.address3=address3
        self.address4=address4
        self.address5=address5
        self.address6=address6
        self.name=name
        self.use_variables=use_variables
        self.use_template=use_template
        self.use_template_tploptions=use_template_tploptions
        self.register=register
        self.active=active
        self.last_modified=last_modified
        self.access_group=access_group
        self.config_id=config_id
    def __repr__(self):
        return "{'id':%s,\
                'contact_name':%s,\
                'alias':%s,\
                'contactgroups':%s,\
                'contactgroups_tploptions':%s,\
                'host_notifications_enabled':%s,\
                'service_notifications_enabled':%s,\
                'host_notification_period':%s,\
                'service_notification_period':%s,\
                'host_notification_options':%s,\
                'service_notification_options':%s,\
                'host_notification_commands':%s,\
                'host_notification_commands_tploptions':%s,\
                'service_notification_commands':%s,\
                'service_notification_commands_tploptions':%s,\
                'can_submit_commands':%s,\
                'retain_status_information':%s,\
                'retain_nonstatus_information':%s,\
                'email':%s,\
                'pager':%s,\
                'address1':%s,\
                'address2':%s,\
                'address3':%s,\
                'address4':%s,\
                'address5':%s,\
                'address6':%s,\
                'name':%s,\
                'use_variables':%s,\
                'use_template':%s,\
                'use_template_tploptions':%s,\
                'register':%s,\
                'active':%s,\
                'last_modified':%s,\
                'access_group':%s,\
                'config_id':%s}" % (self.id,\
                self.contact_name,\
                self.alias,\
                self.contactgroups,\
                self.contactgroups_tploptions,\
                self.host_notifications_enabled,\
                self.service_notifications_enabled,\
                self.host_notification_period,\
                self.service_notification_period,\
                self.host_notification_options,\
                self.service_notification_options,\
                self.host_notification_commands,\
                self.host_notification_commands_tploptions,\
                self.service_notification_commands,\
                self.service_notification_commands_tploptions,\
                self.can_submit_commands,\
                self.retain_status_information,\
                self.retain_nonstatus_information,\
                self.email,\
                self.pager,\
                self.address1,\
                self.address2,\
                self.address3,\
                self.address4,\
                self.address5,\
                self.address6,\
                self.name,\
                self.use_variables,\
                self.use_template,\
                self.use_template_tploptions,\
                self.register,\
                self.active,\
                self.last_modified,\
                self.access_group,\
                self.config_id)

 
class TblContactgroup(DeclarativeBase):
    __tablename__ = 'tbl_contactgroup'

    access_group = Column('access_group', INTEGER(), nullable=False)
    active = Column('active', Enum(u'0', u'1'), nullable=False)
    alias = Column('alias', VARCHAR(length=255), nullable=False)
    config_id = Column('config_id', Integer(), nullable=False)
    contactgroup_members = Column('contactgroup_members', INTEGER(), nullable=False)
    contactgroup_name = Column('contactgroup_name', VARCHAR(length=255), nullable=False)
    id = Column('id', INTEGER(), primary_key=True, autoincrement=True, nullable=False)
    last_modified = Column('last_modified', DATETIME(), nullable=False)
    members = Column('members', INTEGER(), nullable=False)
    register = Column('register', Enum(u'0', u'1'), nullable=False) 
    
    def __init__(self,contactgroup_name='',\
                alias='',\
                members=0,\
                contactgroup_members=0,\
                register='1',\
                active='1',\
                last_modified=time.strftime('%Y-%m-%d %H:%M:%S',time.localtime()),\
                access_group=0,\
                config_id=1):
        self.contactgroup_name=contactgroup_name
        self.alias=alias
        self.members=members
        self.contactgroup_members=contactgroup_members
        self.register=register
        self.active=active
        self.last_modified=last_modified
        self.access_group=access_group
        self.config_id=config_id       
    def __repr__(self):
        return "{'id':%s,\
        'contactgroup_name':%s,\
        'alias':%s,\
        'members':%s,\
        'contactgroup_members':%s,\
        'register':%s,\
        'active':%s,\
        'last_modified':%s,\
        'access_group':%s,\
        'config_id':%s}" % (self.id,\
        self.contactgroup_name,\
        self.alias,\
        self.members,\
        self.contactgroup_members,\
        self.register,\
        self.active,\
        self.last_modified,\
        self.access_group,\
        self.config_id)        

class TblContacttemplate(DeclarativeBase):
    __tablename__ = 'tbl_contacttemplate'

    access_group = Column('access_group', INTEGER(), nullable=False)
    active = Column('active', Enum(u'0', u'1'), nullable=False)
    address1 = Column('address1', VARCHAR(length=255), nullable=False)
    address2 = Column('address2', VARCHAR(length=255), nullable=False)
    address3 = Column('address3', VARCHAR(length=255), nullable=False)
    address4 = Column('address4', VARCHAR(length=255), nullable=False)
    address5 = Column('address5', VARCHAR(length=255), nullable=False)
    address6 = Column('address6', VARCHAR(length=255), nullable=False)
    alias = Column('alias', VARCHAR(length=255), nullable=False)
    can_submit_commands = Column('can_submit_commands', Integer(), nullable=False)
    config_id = Column('config_id', Integer(), nullable=False)
    contactgroups = Column('contactgroups', INTEGER(), nullable=False)
    contactgroups_tploptions = Column('contactgroups_tploptions', Integer(), nullable=False)
    email = Column('email', VARCHAR(length=255), nullable=False)
    host_notification_commands = Column('host_notification_commands', INTEGER(), nullable=False)
    host_notification_commands_tploptions = Column('host_notification_commands_tploptions', Integer(), nullable=False)
    host_notification_options = Column('host_notification_options', VARCHAR(length=20), nullable=False)
    host_notification_period = Column('host_notification_period', INTEGER(), nullable=False)
    host_notifications_enabled = Column('host_notifications_enabled', Integer(), nullable=False)
    id = Column('id', INTEGER(), primary_key=True, autoincrement=True, nullable=False)
    last_modified = Column('last_modified', DATETIME(), nullable=False)
    pager = Column('pager', VARCHAR(length=255), nullable=False)
    register = Column('register', Enum(u'0', u'1'), nullable=False)
    retain_nonstatus_information = Column('retain_nonstatus_information', Integer(), nullable=False)
    retain_status_information = Column('retain_status_information', Integer(), nullable=False)
    service_notification_commands = Column('service_notification_commands', INTEGER(), nullable=False)
    service_notification_commands_tploptions = Column('service_notification_commands_tploptions', Integer(), nullable=False)
    service_notification_options = Column('service_notification_options', VARCHAR(length=20), nullable=False)
    service_notification_period = Column('service_notification_period', INTEGER(), nullable=False)
    service_notifications_enabled = Column('service_notifications_enabled', Integer(), nullable=False)
    template_name = Column('template_name', VARCHAR(length=255), nullable=False)
    use_template = Column('use_template', Integer(), nullable=False)
    use_template_tploptions = Column('use_template_tploptions', Integer(), nullable=False)
    use_variables = Column('use_variables', Integer(), nullable=False)
    
    def __init__(self,template_name='',\
                alias='',\
                contactgroups=0,\
                contactgroups_tploptions=2,\
                host_notifications_enabled=2,\
                service_notifications_enabled=2,\
                host_notification_period=0,\
                service_notification_period=0,\
                host_notification_options='',\
                service_notification_options='',\
                host_notification_commands=0,\
                host_notification_commands_tploptions=2,\
                service_notification_commands=0,\
                service_notification_commands_tploptions=2,\
                can_submit_commands=2,\
                retain_status_information=2,\
                retain_nonstatus_information=2,\
                email='',\
                pager='',\
                address1='',\
                address2='',\
                address3='',\
                address4='',\
                address5='',\
                address6='',\
                use_variables=0,\
                use_template=0,\
                use_template_tploptions=2,\
                register=0,\
                active=1,\
                last_modified='',\
                access_group=0,\
                config_id=0):
        self.template_name=template_name
        self.alias=alias
        self.contactgroups=contactgroups
        self.contactgroups_tploptions=contactgroups_tploptions
        self.host_notifications_enabled=host_notifications_enabled
        self.service_notifications_enabled=service_notifications_enabled
        self.host_notification_period=host_notification_period
        self.service_notification_period=service_notification_period
        self.host_notification_options=host_notification_options
        self.service_notification_options=service_notification_options
        self.host_notification_commands=host_notification_commands
        self.host_notification_commands_tploptions=host_notification_commands_tploptions
        self.service_notification_commands=service_notification_commands
        self.service_notification_commands_tploptions=service_notification_commands_tploptions
        self.can_submit_commands=can_submit_commands
        self.retain_status_information=retain_status_information
        self.retain_nonstatus_information=retain_nonstatus_information
        self.email=email
        self.pager=pager
        self.address1=address1
        self.address2=address2
        self.address3=address3
        self.address4=address4
        self.address5=address5
        self.address6=address6
        self.use_variables=use_variables
        self.use_template=use_template
        self.use_template_tploptions=use_template_tploptions
        self.register=register
        self.active=active
        self.last_modified=last_modified
        self.access_group=access_group
        self.config_id=config_id
        
    def __repr__(self):
        return "{'id':%s,\
        'template_name':%s,\
        'alias':%s,\
        'contactgroups':%s,\
        'contactgroups_tploptions':%s,\
        'host_notifications_enabled':%s,\
        'service_notifications_enabled':%s,\
        'host_notification_period':%s,\
        'service_notification_period':%s,\
        'host_notification_options':%s,\
        'service_notification_options':%s,\
        'host_notification_commands':%s,\
        'host_notification_commands_tploptions':%s,\
        'service_notification_commands':%s,\
        'service_notification_commands_tploptions':%s,\
        'can_submit_commands':%s,\
        'retain_status_information':%s,\
        'retain_nonstatus_information':%s,\
        'email':%s,\
        'pager':%s,\
        'address1':%s,\
        'address2':%s,\
        'address3':%s,\
        'address4':%s,\
        'address5':%s,\
        'address6':%s,\
        'use_variables':%s,\
        'use_template':%s,\
        'use_template_tploptions':%s,\
        'register':%s,\
        'active':%s,\
        'last_modified':%s,\
        'access_group':%s,\
        'config_id':%s}" % (self.id,\
        self.template_name,\
        self.alias,\
        self.contactgroups,\
        self.contactgroups_tploptions,\
        self.host_notifications_enabled,\
        self.service_notifications_enabled,\
        self.host_notification_period,\
        self.service_notification_period,\
        self.host_notification_options,\
        self.service_notification_options,\
        self.host_notification_commands,\
        self.host_notification_commands_tploptions,\
        self.service_notification_commands,\
        self.service_notification_commands_tploptions,\
        self.can_submit_commands,\
        self.retain_status_information,\
        self.retain_nonstatus_information,\
        self.email,\
        self.pager,\
        self.address1,\
        self.address2,\
        self.address3,\
        self.address4,\
        self.address5,\
        self.address6,\
        self.use_variables,\
        self.use_template,\
        self.use_template_tploptions,\
        self.register,\
        self.active,\
        self.last_modified,\
        self.access_group,\
        self.config_id)