
from sqlalchemy import *
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import relation
import time

DeclarativeBase = declarative_base()

class TblHost(DeclarativeBase):
    __tablename__='tbl_host'
    __table_args__=(UniqueConstraint('id',name='id'),UniqueConstraint('host_name',name='host_name'))
    i2d_coords = Column('2d_coords', VARCHAR(length=255), nullable=False)
    i3d_coords = Column('3d_coords', VARCHAR(length=255), nullable=False)
    access_group = Column('access_group', INTEGER(), nullable=False)
    action_url = Column('action_url', VARCHAR(length=255), nullable=False)
    active = Column('active', Enum(u'0', u'1'), nullable=False)
    active_checks_enabled = Column('active_checks_enabled', Integer(), nullable=False)
    address = Column('address', VARCHAR(length=255), nullable=False)
    alias = Column('alias', VARCHAR(length=255), nullable=False)
    check_command = Column('check_command', TEXT(), nullable=False)
    check_freshness = Column('check_freshness', Integer(), nullable=False)
    check_interval = Column('check_interval', INTEGER())
    check_period = Column('check_period', INTEGER(), nullable=False)
    config_id = Column('config_id', Integer(), nullable=False)
    contact_groups = Column('contact_groups', Integer(), nullable=False)
    contact_groups_tploptions = Column('contact_groups_tploptions', Integer(), nullable=False)
    contacts = Column('contacts', Integer(), nullable=False)
    contacts_tploptions = Column('contacts_tploptions', Integer(), nullable=False)
    display_name = Column('display_name', VARCHAR(length=255), nullable=False)
    event_handler = Column('event_handler', INTEGER(), nullable=False)
    event_handler_enabled = Column('event_handler_enabled', Integer(), nullable=False)
    first_notification_delay = Column('first_notification_delay', INTEGER())
    flap_detection_enabled = Column('flap_detection_enabled', Integer(), nullable=False)
    flap_detection_options = Column('flap_detection_options', VARCHAR(length=20), nullable=False)
    freshness_threshold = Column('freshness_threshold', INTEGER())
    high_flap_threshold = Column('high_flap_threshold', INTEGER())
    host_name = Column('host_name', VARCHAR(length=255), nullable=False)
    hostgroups = Column('hostgroups', Integer(), nullable=False)
    hostgroups_tploptions = Column('hostgroups_tploptions', Integer(), nullable=False)
    icon_image = Column('icon_image', VARCHAR(length=500), nullable=False)
    icon_image_alt = Column('icon_image_alt', VARCHAR(length=255), nullable=False)
    id = Column('id', INTEGER(), primary_key=True,  autoincrement=True,nullable=False)
    initial_state = Column('initial_state', VARCHAR(length=20), nullable=False)
    last_modified = Column('last_modified', DATETIME(), nullable=False)
    low_flap_threshold = Column('low_flap_threshold', INTEGER())
    max_check_attempts = Column('max_check_attempts', INTEGER())
    name = Column('name', VARCHAR(length=255), nullable=False)
    notes = Column('notes', VARCHAR(length=255), nullable=False)
    notes_url = Column('notes_url', VARCHAR(length=255), nullable=False)
    notification_interval = Column('notification_interval', INTEGER())
    notification_options = Column('notification_options', VARCHAR(length=20), nullable=False)
    notification_period = Column('notification_period', INTEGER(), nullable=False)
    notifications_enabled = Column('notifications_enabled', Integer(), nullable=False)
    obsess_over_host = Column('obsess_over_host', Integer(), nullable=False)
    parents = Column('parents', Integer(), nullable=False)
    parents_tploptions = Column('parents_tploptions', Integer(), nullable=False)
    passive_checks_enabled = Column('passive_checks_enabled', Integer(), nullable=False)
    process_perf_data = Column('process_perf_data', Integer(), nullable=False)
    register = Column('register', Enum(u'0', u'1'), nullable=False)
    retain_nonstatus_information = Column('retain_nonstatus_information', Integer(), nullable=False)
    retain_status_information = Column('retain_status_information', Integer(), nullable=False)
    retry_interval = Column('retry_interval', INTEGER())
    stalking_options = Column('stalking_options', VARCHAR(length=20), nullable=False)
    statusmap_image = Column('statusmap_image', VARCHAR(length=255), nullable=False)
    use_template = Column('use_template', Integer(), nullable=False)
    use_template_tploptions = Column('use_template_tploptions', Integer(), nullable=False)
    use_variables = Column('use_variables', Integer(), nullable=False)
    vrml_image = Column('vrml_image', VARCHAR(length=255), nullable=False)
    hw_user = Column('hw_user',VARCHAR(length=255))
    hw_password = Column('hw_password',VARCHAR(length=255))
    hw_address = Column('hw_address',VARCHAR(length=255))
    hw_type = Column('hw_type',INTEGER(), nullable=False)
    soft_type = Column('soft_type',INTEGER(), nullable=False)

    
    def __init__(self,host_name='',\
                alias='',\
                display_name='',\
                address='',\
                parents=0,\
                parents_tploptions=2,\
                hostgroups=0,\
                hostgroups_tploptions=2,\
                check_command='',\
                use_template=0,\
                use_template_tploptions=2,\
                initial_state='',\
                max_check_attempts=None,\
                check_interval=None,\
                retry_interval=None,\
                active_checks_enabled=1,\
                passive_checks_enabled=1,\
                check_period=0,\
                obsess_over_host=1,\
                check_freshness=1,\
                freshness_threshold=None,\
                event_handler=0,\
                event_handler_enabled=1,\
                low_flap_threshold=None,\
                high_flap_threshold=None,\
                flap_detection_enabled=1,\
                flap_detection_options='',\
                process_perf_data=1,\
                retain_status_information=1,\
                retain_nonstatus_information=1,\
                contacts=0,\
                contacts_tploptions=2,\
                contact_groups=0,\
                contact_groups_tploptions=2,\
                notification_interval=None,\
                notification_period=0,\
                first_notification_delay=None,\
                notification_options='',\
                notifications_enabled=1,\
                stalking_options='',\
                notes='',\
                notes_url='',\
                action_url='',\
                icon_image='',\
                icon_image_alt='',\
                vrml_image='',\
                statusmap_image='',\
                i2d_coords='',\
                i3d_coords='',\
                use_variables=0,\
                name='',\
                register='1',\
                active='1',\
                last_modified=time.strftime('%Y-%m-%d %H:%M:%S',time.localtime()),\
                access_group=0,\
                config_id=1,\
                hw_address='',\
                hw_user='',\
                hw_password='',\
                hw_type=1,\
                soft_type=0):
        self.host_name=host_name
        self.alias=alias
        self.display_name=display_name
        self.address=address
        self.parents=parents
        self.parents_tploptions=parents_tploptions
        self.hostgroups=hostgroups
        self.hostgroups_tploptions=hostgroups_tploptions
        self.check_command=check_command
        self.use_template=use_template
        self.use_template_tploptions=use_template_tploptions
        self.initial_state=initial_state
        self.max_check_attempts=max_check_attempts
        self.check_interval=check_interval
        self.retry_interval=retry_interval
        self.active_checks_enabled=active_checks_enabled
        self.passive_checks_enabled=passive_checks_enabled
        self.check_period=check_period
        self.obsess_over_host=obsess_over_host
        self.check_freshness=check_freshness
        self.freshness_threshold=freshness_threshold
        self.event_handler=event_handler
        self.event_handler_enabled=event_handler_enabled
        self.low_flap_threshold=low_flap_threshold
        self.high_flap_threshold=high_flap_threshold
        self.flap_detection_enabled=flap_detection_enabled
        self.flap_detection_options=flap_detection_options
        self.process_perf_data=process_perf_data
        self.retain_status_information=retain_status_information
        self.retain_nonstatus_information=retain_nonstatus_information
        self.contacts=contacts
        self.contacts_tploptions=contacts_tploptions
        self.contact_groups=contact_groups
        self.contact_groups_tploptions=contact_groups_tploptions
        self.notification_interval=notification_interval
        self.notification_period=notification_period
        self.first_notification_delay=first_notification_delay
        self.notification_options=notification_options
        self.notifications_enabled=notifications_enabled
        self.stalking_options=stalking_options
        self.notes=notes
        self.notes_url=notes_url
        self.action_url=action_url
        self.icon_image=icon_image
        self.icon_image_alt=icon_image_alt
        self.vrml_image=vrml_image
        self.statusmap_image=statusmap_image
        self.i2d_coords=i2d_coords
        self.i3d_coords=i3d_coords
        self.use_variables=use_variables
        self.name=name
        self.register=register
        self.active=active
        self.last_modified=last_modified
        self.access_group=access_group
        self.config_id=config_id
        self.hw_address=hw_address
        self.hw_user=hw_user
        self.hw_password=hw_password
        self.hw_type=hw_type
        self.soft_type=soft_type
    
    def __repr__(self):
        '''return "{'id':%s,\
                'host_name':%s,\
                'alias':%s,\
                'display_name':%s,\
                'address':%s,\
                'hw_address':%s,\
                'hw_type':%s,\
                'soft_type':%s,\
                'parents':%s,\
                'parents_tploptions':%s,\
                'hostgroups':%s,\
                'hostgroups_tploptions':%s,\
                'check_command':%s,\
                'use_template':%s,\
                'use_template_tploptions':%s,\
                'initial_state':%s,\
                'max_check_attempts':%s,\
                'check_interval':%s,\
                'retry_interval':%s,\
                'active_checks_enabled':%s,\
                'passive_checks_enabled':%s,\
                'check_period':%s,\
                'obsess_over_host':%s,\
                'check_freshness':%s,\
                'freshness_threshold':%s,\
                'event_handler':%s,\
                'event_handler_enabled':%s,\
                'low_flap_threshold':%s,\
                'high_flap_threshold':%s,\
                'flap_detection_enabled':%s,\
                'flap_detection_options':%s,\
                'process_perf_data':%s,\
                'retain_status_information':%s,\
                'retain_nonstatus_information':%s,\
                'contacts':%s,\
                'contacts_tploptions':%s,\
                'contact_groups':%s,\
                'contact_groups_tploptions':%s,\
                'notification_interval':%s,\
                'notification_period':%s,\
                'first_notification_delay':%s,\
                'notification_options':%s,\
                'notifications_enabled':%s,\
                'stalking_options':%s,\
                'notes':%s,\
                'notes_url':%s,\
                'action_url':%s,\
                'icon_image':%s,\
                'icon_image_alt':%s,\
                'vrml_image':%s,\
                'statusmap_image':%s,\
                '2d_coords':%s,\
                '3d_coords':%s,\
                'use_variables':%s,\
                'name':%s,\
                'register':%s,\
                'active':%s,\
                'last_modified':%s,\
                'access_group':%s,\
                'config_id':%s}" % (self.id,\
                self.host_name,\
                self.alias,\
                self.display_name,\
                self.address,\
                self.hw_address,\
                self.hw_type,\
                self.soft_type,\
                self.parents,\
                self.parents_tploptions,\
                self.hostgroups,\
                self.hostgroups_tploptions,\
                self.check_command,\
                self.use_template,\
                self.use_template_tploptions,\
                self.initial_state,\
                self.max_check_attempts,\
                self.check_interval,\
                self.retry_interval,\
                self.active_checks_enabled,\
                self.passive_checks_enabled,\
                self.check_period,\
                self.obsess_over_host,\
                self.check_freshness,\
                self.freshness_threshold,\
                self.event_handler,\
                self.event_handler_enabled,\
                self.low_flap_threshold,\
                self.high_flap_threshold,\
                self.flap_detection_enabled,\
                self.flap_detection_options,\
                self.process_perf_data,\
                self.retain_status_information,\
                self.retain_nonstatus_information,\
                self.contacts,\
                self.contacts_tploptions,\
                self.contact_groups,\
                self.contact_groups_tploptions,\
                self.notification_interval,\
                self.notification_period,\
                self.first_notification_delay,\
                self.notification_options,\
                self.notifications_enabled,\
                self.stalking_options,\
                self.notes,\
                self.notes_url,\
                self.action_url,\
                self.icon_image,\
                self.icon_image_alt,\
                self.vrml_image,\
                self.statusmap_image,\
                self.i2d_coords,\
                self.i3d_coords,\
                self.use_variables,\
                self.name,\
                self.register,\
                self.active,\
                self.last_modified,\
                self.access_group,\
                self.config_id)'''
        return "{'id':%s,\
                'host_name':%s,\
                'alias':%s,\
                'display_name':%s,\
                'address':%s,\
                'hw_address':%s,\
                'hw_type':%s,\
                'soft_type':%s,\
                'parents':%s,\
                'hostgroups':%s,\
                'check_command':%s,\
                'use_template':%s,\
                'initial_state':%s,\
                'max_check_attempts':%s,\
                'check_interval':%s,\
                'retry_interval':%s,\
                'active_checks_enabled':%s,\
                'passive_checks_enabled':%s,\
                'check_period':%s,\
                'event_handler':%s,\
                'event_handler_enabled':%s,\
                'process_perf_data':%s,\
                'retain_status_information':%s,\
                'retain_nonstatus_information':%s,\
                'contacts':%s,\
                'contact_groups':%s,\
                'notification_interval':%s,\
                'notification_period':%s,\
                'first_notification_delay':%s,\
                'notification_options':%s,\
                'notifications_enabled':%s,\
                'notes':%s,\
                'notes_url':%s,\
                'action_url':%s,\
                'icon_image':%s,\
                'icon_image_alt':%s,\
                'register':%s,\
                'active':%s,\
                'last_modified':%s}" % (self.id,\
                self.host_name,\
                self.alias,\
                self.display_name,\
                self.address,\
                self.hw_address,\
                self.hw_type,\
                self.soft_type,\
                self.parents,\
                self.hostgroups,\
                self.check_command,\
                self.use_template,\
                self.initial_state,\
                self.max_check_attempts,\
                self.check_interval,\
                self.retry_interval,\
                self.active_checks_enabled,\
                self.passive_checks_enabled,\
                self.check_period,\
                self.event_handler,\
                self.event_handler_enabled,\
                self.process_perf_data,\
                self.retain_status_information,\
                self.retain_nonstatus_information,\
                self.contacts,\
                self.contact_groups,\
                self.notification_interval,\
                self.notification_period,\
                self.first_notification_delay,\
                self.notification_options,\
                self.notifications_enabled,\
                self.notes,\
                self.notes_url,\
                self.action_url,\
                self.icon_image,\
                self.icon_image_alt,\
                self.register,\
                self.active,\
                self.last_modified)

class TblHostgroup(DeclarativeBase):
    __tablename__ = 'tbl_hostgroup'

    access_group = Column('access_group', INTEGER(), nullable=False)
    action_url = Column('action_url', VARCHAR(length=255), nullable=False)
    active = Column('active', Enum(u'0', u'1'), nullable=False)
    alias = Column('alias', VARCHAR(length=255), nullable=False)
    config_id = Column('config_id', Integer(), nullable=False)
    hostgroup_members = Column('hostgroup_members', Integer(), nullable=False)
    hostgroup_name = Column('hostgroup_name', VARCHAR(length=255), nullable=False)
    id = Column('id', INTEGER(), primary_key=True, autoincrement=True, nullable=False)
    last_modified = Column('last_modified', DATETIME(), nullable=False)
    members = Column('members', Integer(), nullable=False)
    notes = Column('notes', VARCHAR(length=255), nullable=False)
    notes_url = Column('notes_url', VARCHAR(length=255), nullable=False)
    register = Column('register', Enum(u'0', u'1'), nullable=False)
    def __init__(self,hostgroup_name='',\
                alias='',\
                members=0,\
                hostgroup_members=0,\
                notes='',\
                notes_url='',\
                action_url='',\
                register='1',\
                active='1',\
                last_modified=time.strftime('%Y-%m-%d %H:%M:%S',time.localtime()),\
                access_group=0,\
                config_id=1,\
                ):
        self.hostgroup_name=hostgroup_name
        self.alias=alias
        self.members=members
        self.hostgroup_members=hostgroup_members
        self.notes=notes
        self.notes_url=notes_url
        self.action_url=action_url
        self.register=register
        self.active=active
        self.last_modified=last_modified
        self.access_group=access_group
        self.config_id=config_id
    def __repr__(self):
        '''return "{'id':%s,\
                'hostgroup_name':%s,\
                'alias':%s,\
                'members':%s,\
                'hostgroup_members':%s,\
                'notes':%s,\
                'notes_url':%s,\
                'action_url':%s,\
                'register':%s,\
                'active':%s,\
                'last_modified':%s,\
                'access_group':%s,\
                'config_id':%s}" % (self.id,\
                self.hostgroup_name,\
                self.alias,\
                self.members,\
                self.hostgroup_members,\
                self.notes,\
                self.notes_url,\
                self.action_url,\
                self.register,\
                self.active,\
                self.last_modified,\
                self.access_group,\
                self.config_id)'''
        return "{'id':%s,\
                'hostgroup_name':%s,\
                'alias':%s,\
                'members':%s,\
                'hostgroup_members':%s,\
                'register':%s,\
                'active':%s,\
                'last_modified':%s,\}" % (self.id,\
                self.hostgroup_name,\
                self.alias,\
                self.members,\
                self.hostgroup_members,\
                self.register,\
                self.active,\
                self.last_modified)

class TblHosttemplate(DeclarativeBase):
    __tablename__ = 'tbl_hosttemplate'

    i2d_coords = Column('2d_coords', VARCHAR(length=255), nullable=False)
    i3d_coords = Column('3d_coords', VARCHAR(length=255), nullable=False)
    access_group = Column('access_group', INTEGER(), nullable=False)
    action_url = Column('action_url', VARCHAR(length=255), nullable=False)
    active = Column('active', Enum(u'0', u'1'), nullable=False)
    active_checks_enabled = Column('active_checks_enabled', Integer(), nullable=False)
    alias = Column('alias', VARCHAR(length=255), nullable=False)
    check_command = Column('check_command', TEXT(), nullable=False)
    check_freshness = Column('check_freshness', Integer(), nullable=False)
    check_interval = Column('check_interval', INTEGER())
    check_period = Column('check_period', INTEGER(), nullable=False)
    config_id = Column('config_id', Integer(), nullable=False)
    contact_groups = Column('contact_groups', Integer(), nullable=False)
    contact_groups_tploptions = Column('contact_groups_tploptions', Integer(), nullable=False)
    contacts = Column('contacts', Integer(), nullable=False)
    contacts_tploptions = Column('contacts_tploptions', Integer(), nullable=False)
    event_handler = Column('event_handler', INTEGER(), nullable=False)
    event_handler_enabled = Column('event_handler_enabled', Integer(), nullable=False)
    first_notification_delay = Column('first_notification_delay', INTEGER())
    flap_detection_enabled = Column('flap_detection_enabled', Integer(), nullable=False)
    flap_detection_options = Column('flap_detection_options', VARCHAR(length=20), nullable=False)
    freshness_threshold = Column('freshness_threshold', INTEGER())
    high_flap_threshold = Column('high_flap_threshold', INTEGER())
    hostgroups = Column('hostgroups', Integer(), nullable=False)
    hostgroups_tploptions = Column('hostgroups_tploptions', Integer(), nullable=False)
    icon_image = Column('icon_image', VARCHAR(length=500), nullable=False)
    icon_image_alt = Column('icon_image_alt', VARCHAR(length=255), nullable=False)
    id = Column('id', INTEGER(), primary_key=True, autoincrement=True, nullable=False)
    initial_state = Column('initial_state', VARCHAR(length=20), nullable=False)
    last_modified = Column('last_modified', DATETIME(), nullable=False)
    low_flap_threshold = Column('low_flap_threshold', INTEGER())
    max_check_attempts = Column('max_check_attempts', INTEGER())
    notes = Column('notes', VARCHAR(length=255), nullable=False)
    notes_url = Column('notes_url', VARCHAR(length=255), nullable=False)
    notification_interval = Column('notification_interval', INTEGER())
    notification_options = Column('notification_options', VARCHAR(length=20), nullable=False)
    notification_period = Column('notification_period', INTEGER(), nullable=False)
    notifications_enabled = Column('notifications_enabled', Integer(), nullable=False)
    obsess_over_host = Column('obsess_over_host', Integer(), nullable=False)
    parents = Column('parents', Integer(), nullable=False)
    parents_tploptions = Column('parents_tploptions', Integer(), nullable=False)
    passive_checks_enabled = Column('passive_checks_enabled', Integer(), nullable=False)
    process_perf_data = Column('process_perf_data', Integer(), nullable=False)
    register = Column('register', Enum(u'0', u'1'), nullable=False)
    retain_nonstatus_information = Column('retain_nonstatus_information', Integer(), nullable=False)
    retain_status_information = Column('retain_status_information', Integer(), nullable=False)
    retry_interval = Column('retry_interval', INTEGER())
    stalking_options = Column('stalking_options', VARCHAR(length=20), nullable=False)
    statusmap_image = Column('statusmap_image', VARCHAR(length=255), nullable=False)
    template_name = Column('template_name', VARCHAR(length=255), nullable=False)
    use_template = Column('use_template', Integer(), nullable=False)
    use_template_tploptions = Column('use_template_tploptions', Integer(), nullable=False)
    use_variables = Column('use_variables', Integer(), nullable=False)
    vrml_image = Column('vrml_image', VARCHAR(length=255), nullable=False)
    
    def __init__(self,template_name='',\
                alias='',\
                parents=0,\
                parents_tploptions=2,\
                hostgroups=0,\
                hostgroups_tploptions=2,\
                check_command='',\
                use_template=0,\
                use_template_tploptions=2,\
                initial_state='',\
                max_check_attempts=None,\
                check_interval=None,\
                retry_interval=None,\
                active_checks_enabled=2,\
                passive_checks_enabled=2,\
                check_period=0,\
                obsess_over_host=2,\
                check_freshness=2,\
                freshness_threshold=None,\
                event_handler=0,\
                event_handler_enabled=2,\
                low_flap_threshold=None,\
                high_flap_threshold=None,\
                flap_detection_enabled=2,\
                flap_detection_options='',\
                process_perf_data=2,\
                retain_status_information=2,\
                retain_nonstatus_information=2,\
                contacts=0,\
                contacts_tploptions=2,\
                contact_groups=0,\
                contact_groups_tploptions=2,\
                notification_interval=None,\
                notification_period=0,\
                first_notification_delay=None,\
                notification_options='',\
                notifications_enabled=2,\
                stalking_options='',\
                notes='',\
                notes_url='',\
                action_url='',\
                icon_image='',\
                icon_image_alt='',\
                vrml_image='',\
                statusmap_image='',\
                i2d_coords='',\
                i3d_coords='',\
                use_variables=0,\
                register=1,\
                active=1,\
                last_modified='',\
                access_group=0,\
                config_id=0):
        self.template_name=template_name
        self.alias=alias
        self.parents=parents
        self.parents_tploptions=parents_tploptions
        self.hostgroups=hostgroups
        self.hostgroups_tploptions=hostgroups_tploptions
        self.check_command=check_command
        self.use_template=use_template
        self.use_template_tploptions=use_template_tploptions
        self.initial_state=initial_state
        self.max_check_attempts=max_check_attempts
        self.check_interval=check_interval
        self.retry_interval=retry_interval
        self.active_checks_enabled=active_checks_enabled
        self.passive_checks_enabled=passive_checks_enabled
        self.check_period=check_period
        self.obsess_over_host=obsess_over_host
        self.check_freshness=check_freshness
        self.freshness_threshold=freshness_threshold
        self.event_handler=event_handler
        self.event_handler_enabled=event_handler_enabled
        self.low_flap_threshold=low_flap_threshold
        self.high_flap_threshold=high_flap_threshold
        self.flap_detection_enabled=flap_detection_enabled
        self.flap_detection_options=flap_detection_options
        self.process_perf_data=process_perf_data
        self.retain_status_information=retain_status_information
        self.retain_nonstatus_information=retain_nonstatus_information
        self.contacts=contacts
        self.contacts_tploptions=contacts_tploptions
        self.contact_groups=contact_groups
        self.contact_groups_tploptions=contact_groups_tploptions
        self.notification_interval=notification_interval
        self.notification_period=notification_period
        self.first_notification_delay=first_notification_delay
        self.notification_options=notification_options
        self.notifications_enabled=notifications_enabled
        self.stalking_options=stalking_options
        self.notes=notes
        self.notes_url=notes_url
        self.action_url=action_url
        self.icon_image=icon_image
        self.icon_image_alt=icon_image_alt
        self.vrml_image=vrml_image
        self.statusmap_image=statusmap_image
        self.i2d_coords=i2d_coords
        self.i3d_coords=i3d_coords
        self.use_variables=use_variables
        self.register=register
        self.active=active
        self.last_modified=last_modified
        self.access_group=access_group
        self.config_id=config_id
    def __repr__(self):
        return "{'id':%s,\
                'template_name':%s,\
                'alias':%s,\
                'parents':%s,\
                'parents_tploptions':%s,\
                'hostgroups':%s,\
                'hostgroups_tploptions':%s,\
                'check_command':%s,\
                'use_template':%s,\
                'use_template_tploptions':%s,\
                'initial_state':%s,\
                'max_check_attempts':%s,\
                'check_interval':%s,\
                'retry_interval':%s,\
                'active_checks_enabled':%s,\
                'passive_checks_enabled':%s,\
                'check_period':%s,\
                'obsess_over_host':%s,\
                'check_freshness':%s,\
                'freshness_threshold':%s,\
                'event_handler':%s,\
                'event_handler_enabled':%s,\
                'low_flap_threshold':%s,\
                'high_flap_threshold':%s,\
                'flap_detection_enabled':%s,\
                'flap_detection_options':%s,\
                'process_perf_data':%s,\
                'retain_status_information':%s,\
                'retain_nonstatus_information':%s,\
                'contacts':%s,\
                'contacts_tploptions':%s,\
                'contact_groups':%s,\
                'contact_groups_tploptions':%s,\
                'notification_interval':%s,\
                'notification_period':%s,\
                'first_notification_delay':%s,\
                'notification_options':%s,\
                'notifications_enabled':%s,\
                'stalking_options':%s,\
                'notes':%s,\
                'notes_url':%s,\
                'action_url':%s,\
                'icon_image':%s,\
                'icon_image_alt':%s,\
                'vrml_image':%s,\
                'statusmap_image':%s,\
                '2d_coords':%s,\
                '3d_coords':%s,\
                'use_variables':%s,\
                'register':%s,\
                'active':%s,\
                'last_modified':%s,\
                'access_group':%s,\
                'config_id':%s}" % (self.id,\
                self.template_name,\
                self.alias,\
                self.parents,\
                self.parents_tploptions,\
                self.hostgroups,\
                self.hostgroups_tploptions,\
                self.check_command,\
                self.use_template,\
                self.use_template_tploptions,\
                self.initial_state,\
                self.max_check_attempts,\
                self.check_interval,\
                self.retry_interval,\
                self.active_checks_enabled,\
                self.passive_checks_enabled,\
                self.check_period,\
                self.obsess_over_host,\
                self.check_freshness,\
                self.freshness_threshold,\
                self.event_handler,\
                self.event_handler_enabled,\
                self.low_flap_threshold,\
                self.high_flap_threshold,\
                self.flap_detection_enabled,\
                self.flap_detection_options,\
                self.process_perf_data,\
                self.retain_status_information,\
                self.retain_nonstatus_information,\
                self.contacts,\
                self.contacts_tploptions,\
                self.contact_groups,\
                self.contact_groups_tploptions,\
                self.notification_interval,\
                self.notification_period,\
                self.first_notification_delay,\
                self.notification_options,\
                self.notifications_enabled,\
                self.stalking_options,\
                self.notes,\
                self.notes_url,\
                self.action_url,\
                self.icon_image,\
                self.icon_image_alt,\
                self.vrml_image,\
                self.statusmap_image,\
                self.i2d_coords,\
                self.i3d_coords,\
                self.use_variables,\
                self.register,\
                self.active,\
                self.last_modified,\
                self.access_group,\
                self.config_id)
                
class TblHosthardwaretype(DeclarativeBase):
    __tablename__ = 'tbl_hosthardwaretype'

    id = Column('id', INTEGER(), primary_key=True,  autoincrement=True,nullable=False)
    hosthardware_name = Column('hosthardware_name', VARCHAR(length=255))
    
    def __init__(self,hosthardware_name=''):
        self.hosthardware_name = hosthardware_name
        
    def __repr__(self):
        return "{'id':%s,\
                'hosthardware_name':%s}" % (self.id,
                self.hosthardware_name)

class TblHosttype(DeclarativeBase):
    __tablename__ = 'tbl_hosttype'

    id = Column('id', INTEGER(), primary_key=True,  autoincrement=True,nullable=False)
    type_name = Column('type_name', VARCHAR(length=255),nullable=False)
    type_description = Column('type_description', VARCHAR(length=255),nullable=False)
    
    def __init__(self,type_name='',type_description=''):
        self.type_name = type_name
        self.type_description = type_description
        
    def __repr__(self):
        return "{'id':%s,\
                'type_name':%s,\
                'type_description':%s}" % (self.id,\
                self.type_description,\
                self.type_name)
                
class TblHostdistribution(DeclarativeBase):
    __tablename__ = 'tbl_hostdistribution'

    id = Column('id', INTEGER(), primary_key=True,  autoincrement=True,nullable=False)
    hosttype_id = Column('hosttype_id',INTEGER(),nullable=False)
    distribution_name = Column('distribution_name', VARCHAR(length=255),nullable=False)
    
    def __init__(self,hosttype_id='',\
                 distribution_name=''):
        self.hosttype_id = hosttype_id
        self.distribution_name = distribution_name
        
    def __repr__(self):
        return "{'id':%s,\
                'hosttype_id':%s,\
                'distribution_name':%s}" % (self.id,\
                self.hosttype_id,\
                self.distribution_name)   
    
    
