#-*-coding = utf-8 -*-
from sqlalchemy.dialects.mysql import \
BIGINT, BINARY, BIT, BLOB, BOOLEAN, CHAR, DATE, \
DATETIME, DECIMAL, DECIMAL, DOUBLE, ENUM, FLOAT, INTEGER, \
LONGBLOB, LONGTEXT, MEDIUMBLOB, MEDIUMINT, MEDIUMTEXT, NCHAR, \
NUMERIC, NVARCHAR, REAL, SET, SMALLINT, TEXT, TIME, TIMESTAMP, \
TINYBLOB, TINYINT, TINYTEXT, VARBINARY, VARCHAR, YEAR
from sqlalchemy import Boolean, Column, DateTime, ForeignKey
from sqlalchemy import ForeignKeyConstraint, Integer, MetaData, String
from sqlalchemy import Table, Text
from sqlalchemy import create_engine, event, exc
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import sessionmaker
import json
from string import atof
from sqlalchemy.schema import UniqueConstraint
from sqlalchemy.schema import Index
from sqlalchemy.engine import reflection
import ConfigParser
from src.config.db import * 
import sys
from src.monitor.db import CobraSQLAlchemyResult
from sqlalchemy.pool import NullPool, Pool
# create MySQL connection
'''
user='icinga'
passwd='icinga'
dbname='icinga'
hostip='127.0.0.1'
port='3306'
'''


cfg_file = "/opt/cobra/cobra-api/config.conf"


conf = ConfigParser.ConfigParser()
conf.read(cfg_file)
#print conf.sections()
db_host = conf.get("db", "db_host")   
db_port = conf.get("db", "db_port")   
db_user = conf.get("db", "db_user")   
db_pass = conf.get("db", "db_pass") 
db_name = conf.get("db", "db_name")

#connect = 'mysql://'+db_user+':'+db_pass+'@'+db_host+':'+db_port+'/'+db_name+'?charset=utf8'
connect = 'postgresql://'+db_user+':'+db_pass+'@'+db_host+':'+db_port+'/'+db_name

mysql_engine=create_engine(connect, encoding="utf-8", echo=False, pool_size = 20, pool_recycle=3600)
#mysql_engine=create_engine(connect, encoding="utf-8", echo=False, poolclass=NullPool)
#mysql_engine=create_engine("mysql://root:qwer1234@localhost:3306/db_nagiosql_v32?charset=utf8",encoding="utf-8",echo=False)
metadata= MetaData()
DeclarativeBase = declarative_base()

@event.listens_for(Pool, "checkout")
def ping_connection(dbapi_connection, connection_record, connection_proxy):
    cursor = dbapi_connection.cursor()
    try:
        cursor.execute("SELECT 1")
    except:
        # raise DisconnectionError - pool will try
        # connecting again up to three times before raising.
        raise exc.DisconnectionError()
    cursor.close()
# define dictionary of table to class
table2class = { 'host' : dbhosts.TblHost, 
                'hostgroup':dbhosts.TblHostgroup,
                #'hosttemplate':dbhosts.TblHosttemplate,
                'command':dbothers.TblCommand,
                'relationinformation':dbothers.TblRelationinformation,
                'timedefinition':dbtimes.TblTimedefinition,
                'timeperiod':dbtimes.TblTimeperiod,
                'lnkTimeperiodToTimeperiod':links_time.TblLnkTimeperiodToTimeperiod,
                '"lnkTimeperiodToTimeperiod"':links_time.TblLnkTimeperiodToTimeperiod,
                'lnkTimeperiodToTimeperioduse':links_time.TblLnkTimeperiodToTimeperiodUse,
                '"lnkTimeperiodToTimeperioduse"':links_time.TblLnkTimeperiodToTimeperiodUse,
                'service':dbservices.TblService,
                #'servicetemplate':dbservices.TblServicetemplate,
                'lnkServicetemplateToContact':links_services.TblLnkServicetemplateToContact,
                '"lnkServicetemplateToContact"':links_services.TblLnkServicetemplateToContact,
                'lnkServicetemplateToContactgroup':links_services.TblLnkServicetemplateToContactgroup,
                '"lnkServicetemplateToContactgroup"':links_services.TblLnkServicetemplateToContactgroup,
                'lnkServicetemplateToHost':links_services.TblLnkServicetemplateToHost,
                '"lnkServicetemplateToHost"':links_services.TblLnkServicetemplateToHost,
                'lnkServicetemplateToHostgroup':links_services.TblLnkServicetemplateToHostgroup,
                '"lnkServicetemplateToHostgroup"':links_services.TblLnkServicetemplateToHostgroup,
                'lnkServicetemplateToServicegroup':links_services.TblLnkServicetemplateToServicegroup,
                '"lnkServicetemplateToServicegroup"':links_services.TblLnkServicetemplateToServicegroup,
                'lnkServicetemplateToServicetemplate':links_services.TblLnkServicetemplateToServicetemplate,
                '"lnkServicetemplateToServicetemplate"':links_services.TblLnkServicetemplateToServicetemplate,
                'lnkServiceToContact':links_services.TblLnkServiceToContact,
                '"lnkServiceToContact"':links_services.TblLnkServiceToContact,
                'lnkServiceToContactgroup':links_services.TblLnkServiceToContactgroup,
                '"lnkServiceToContactgroup"':links_services.TblLnkServiceToContactgroup,
                'lnkServiceToHost':links_services.TblLnkServiceToHost,
                '"lnkServiceToHost"':links_services.TblLnkServiceToHost,
                'lnkServiceToHostgroup':links_services.TblLnkServiceToHostgroup,
		'"lnkServiceToHostgroup"':links_services.TblLnkServiceToHostgroup,
                'lnkServiceToServicegroup':links_services.TblLnkServiceToServicegroup,
                '"lnkServiceToServicegroup"':links_services.TblLnkServiceToServicegroup,
                'lnkServiceToServicetemplate':links_services.TblLnkServiceToServicetemplate,
                '"lnkServiceToServicetemplate"':links_services.TblLnkServiceToServicetemplate, 
                'contact':dbcontacts.TblContact,
                'contactgroup':dbcontacts.TblContactgroup,
                #'contacttemplate':dbcontacts.TblContacttemplate,
                'lnkHostToContact':links_hosts.TblLnkHostToContact,
                '"lnkHostToContact"':links_hosts.TblLnkHostToContact,
                'lnkHostToContactgroup':links_hosts.TblLnkHostToContactgroup,
                '"lnkHostToContactgroup"':links_hosts.TblLnkHostToContactgroup,
                'lnkHostToHost':links_hosts.TblLnkHostToHost,
                '"lnkHostToHost"':links_hosts.TblLnkHostToHost,
                'lnkHostToHostgroup':links_hosts.TblLnkHostToHostgroup,
                '"lnkHostToHostgroup"':links_hosts.TblLnkHostToHostgroup,
                'lnkHostToHosttemplate':links_hosts.TblLnkHostToHosttemplate,
                '"lnkHostToHosttemplate"':links_hosts.TblLnkHostToHosttemplate,
                'lnkHostgroupToHost':links_hosts.TblLnkHostgroupToHost,
                '"lnkHostgroupToHost"':links_hosts.TblLnkHostgroupToHost,
                'lnkHostgroupToHostgroup':links_hosts.TblLnkHostgroupToHostgroup,
                '"lnkHostgroupToHostgroup"':links_hosts.TblLnkHostgroupToHostgroup,
                'lnkHosttemplateToContact':links_hosts.TblLnkHosttemplateToContact,
                '"lnkHosttemplateToContact"':links_hosts.TblLnkHosttemplateToContact,
                'lnkHosttemplateToContactgroup':links_hosts.TblLnkHosttemplateToContactgroup,
                '"lnkHosttemplateToContactgroup"':links_hosts.TblLnkHosttemplateToContactgroup,
                'lnkHosttemplateToHost':links_hosts.TblLnkHosttemplateToHost,
                '"lnkHosttemplateToHost"':links_hosts.TblLnkHosttemplateToHost,
                'lnkHosttemplateToHostgroup':links_hosts.TblLnkHosttemplateToHostgroup,
                '"lnkHosttemplateToHostgroup"':links_hosts.TblLnkHosttemplateToHostgroup,
                'lnkHosttemplateToHosttemplate':links_hosts.TblLnkHosttemplateToHosttemplate,
                '"lnkHosttemplateToHosttemplate"':links_hosts.TblLnkHosttemplateToHosttemplate,
                'lnkContactToCommandHost':links_contacts.TblLnkContactToCommandHost,
                '"lnkContactToCommandHost"':links_contacts.TblLnkContactToCommandHost,
                'lnkContactToCommandService':links_contacts.TblLnkContactToCommandService,
                '"lnkContactToCommandService"':links_contacts.TblLnkContactToCommandService,
                'lnkContactToContactgroup':links_contacts.TblLnkContactToContactgroup,
                '"lnkContactToContactgroup"':links_contacts.TblLnkContactToContactgroup,
                'lnkContactToContacttemplate':links_contacts.TblLnkContactToContacttemplate,
                '"lnkContactToContacttemplate"':links_contacts.TblLnkContactToContacttemplate,
                'lnkContactgroupToContact':links_contacts.TblLnkContactgroupToContact,
                '"lnkContactgroupToContact"':links_contacts.TblLnkContactgroupToContact,
                'lnkContactgroupToContactgroup':links_contacts.TblLnkContactgroupToContactgroup,
                '"lnkContactgroupToContactgroup"':links_contacts.TblLnkContactgroupToContactgroup,

                'lnkContacttemplateToCommandhost':links_contacts.TblLnkContacttemplateToCommandHost,
                '"lnkContacttemplateToCommandhost"':links_contacts.TblLnkContacttemplateToCommandHost,
                'lnkContacttemplateToCommandservice':links_contacts.TblLnkContacttemplateToCommandService,
                '"lnkContacttemplateToCommandservice"':links_contacts.TblLnkContacttemplateToCommandService,
                'lnkContacttemplateToContactgroup':links_contacts.TblLnkContacttemplateToContactgroup,
                '"lnkContacttemplateToContactgroup"':links_contacts.TblLnkContacttemplateToContactgroup,
                'lnkContacttemplateToContacttemplate':links_contacts.TblLnkContacttemplateToContacttemplate,
                '"lnkContacttemplateToContacttemplate"':links_contacts.TblLnkContacttemplateToContacttemplate,
                'hosthardwaretype':dbhosts.TblHosthardwaretype,
                'hosttype':dbhosts.TblHosttype,
                'hostdistribution':dbhosts.TblHostdistribution,
                'servicegroup':dbservices.TblServicegroup,
                'autodiscovery':dbautodiscovery.TblAutodiscovery,
                'icingahost':CobraSQLAlchemyResult.IcingaHosts,
                'icingaservice':CobraSQLAlchemyResult.IcingaServices,
		'notification':dbothers.TblNotificationInfo
                }

# create DB options, include select,insert,delete and update options
class Options():

    def select(self,tblclass,key_value):
        ''' return one line which selected
            usage:
            select(table2class[tblclass],key_value)
            tblclass:table's name ,eg: tblclass='host'
            key_value:dictionary of the name and the value which you want to select.
                        eg: you want to select the host_name's value is equal to 'linux-test',
                        key_value={'host_name':'linux-test'} '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        for key,value in key_value.items():
            result=session.query(tblclass).filter(getattr(tblclass,key)==value).all()
        #print "select ",key,value,result
        session.expunge_all()
        session.close()
        return result

    def selectall(self,tblclass, start=0,limit=0,orderby=""):
        '''return all from the seleted table
            usage:
            selectall(table2class[tblclass])
            tblclass:table's name ,eg: tblclass='host' '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        if orderby != "":
            if limit == 0 and start == 0:
                result=session.query(tblclass).order_by(orderby).all()
            else:
                result=session.query(tblclass).order_by(orderby).slice(start,start+limit)
        else:
            if limit == 0 and start == 0:
                result=session.query(tblclass).all()
            else:
                result=session.query(tblclass).slice(start,start+limit)
        session.expunge_all()
        session.close()
        return result
    
    def selectoneclo(self,tblclass,key):
        '''return one clo of the table which selected
            usage:
            selectoneclo(table2class[tblclass],key)
            tblclass:table's name ,eg: tblclass='host' 
            key:the name of the clo eg: key='host_name' '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        result=session.query(getattr(tblclass,key)).all()
        session.expunge_all()
        session.close()
        session.remove()
        #print result
        return result

    def selectonevalue(self,tblclass,keyitem,key_value):
        '''return one value of the key
            usage:
            selectonevalue(table2class[tblclass],keyitem,key)
            tblclass:table's name ,eg: tblclass='host' 
            keyitem:the name of the clo eg: keyitem='host_name'
            key_value:dictionary of the name and the value which you want to select.
                        eg: you want to select the host_name's value is equal to 'linux-test',
                        key_value={'host_name':'linux-test'} '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        for key,value in key_value.items():
            result=session.query(getattr(tblclass,keyitem)).filter(getattr(tblclass,key)==value).all()
        session.expunge_all()
        session.close()
        #print result
        return result

    def selectalltwovalues(self,tblclass,key1,key2,key3=''):
        '''return a list of pairs of values for the table 
            usage:
            selectonevalue(table2class[tblclass],keyitem,key)
            tblclass:table's name ,eg: tblclass='host' 
            key1:the name of the clo eg: keyitem='id'
            key2:the name of the clo eg: keyitem='host_name' '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        if key3=='':
            result=session.query(getattr(tblclass,key1),getattr(tblclass,key2)).all()
        else:
            for key,value in key3.items():
                result=session.query(getattr(tblclass,key1),getattr(tblclass,key2)).filter(getattr(tblclass,key)==value).all()
        session.expunge_all()
        session.close()
        return result
    
    def selectvalues(self,tblclass,keyitem,values):
        '''return a set of rows of the keyitem in the values,
            such as "SELECT * FROM table WHERE id IN (...)"
            usage:
            selectvalues(table2class[tblclass],keyitem,values)
            tblclass:table's name ,eg: tblclass='host' 
            keyitem:the name of the clo eg: keyitem='id'
            values:a list of the values which you want to select.
                        eg: you want to select the host id's value in '1,3,5',
                        values=[1,3,5] '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session = sessionmaker(bind=mysql_engine)
        session = Session()
        result = session.query(table2class[tblclass]).filter(getattr(table2class[tblclass],keyitem).in_(values)).all()
        session.expunge_all()
        session.close()
        #print result
        return result
    
    def selecttwovalues(self,tblclass,key1,key2,key3=''):
        '''return a list of pairs of values for the table 
            usage:
            selecttwovalues(table2class[tblclass],keyitem,key)
            tblclass:table's name ,eg: tblclass='host' 
            key1:the name of the clo eg: keyitem='id'
            key2:the name of the clo eg: keyitem='host_name' '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        if key3=='':
            result=session.query(getattr(tblclass,key1),getattr(tblclass,key2)).all()
        else:
            for key,value in key3.items():
                result=session.query(getattr(tblclass,key1),getattr(tblclass,key2)).filter(getattr(tblclass,key)==value).all()
        session.expunge_all()
        session.close()
        return result

    def insert(self,tblclass,key_value):
        '''insert one line into the table,return the id of the new line
            usage:
            insert(table2class[tblclass],key_value)
            tblclass:table's name ,eg: tblclass='host' 
            key_value:dictionary of the name and the value which you want to insert.
                        eg:  key_value={'host_name':'linux-test','alisa':'test',......}  '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()    
        insertinto=tblclass()
        for key,value in key_value.items():
            setattr(insertinto,key,value)
        result=session.add(insertinto)
        session.commit()
        #session.close()
        return insertinto.id
    def insertlnk(self,tblclass,key_value):
        '''insert one line into the table,return the insert result
            usage:
            insert(table2class[tblclass],key_value)
            tblclass:table's name ,eg: tblclass='host' 
            key_value:dictionary of the name and the value which you want to insert.
                        eg:  key_value={'host_name':'linux-test','alisa':'test',......}  '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()    
        insertinto=tblclass()
        for key,value in key_value.items():
            #print "#############PRINT DBOPTIONS###############"
            #print key,value
            setattr(insertinto,key,value)
        result=session.add(insertinto)
        session.commit()
        #session.close()
        return result  
    def delete(self,tblclass,key_value):
        ''' delete one line from the selected table
            usage:
            delete(table2class[tblclass],key_value)
            tblclass:table's name ,eg: tblclass='host'
            key_value:dictionary of the name and the value which you want to delete.
                        eg: you want to delete the host_name's value is equal to 'linux-test',
                        key_value={'host_name':'linux-test'} '''        
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        for key,value in key_value.items():
            result=session.query(tblclass).filter(getattr(tblclass,key)==value).delete()
        session.commit()
        #session.close()
        #print result
        return result
    
    def update(self,tblclass,key_value,updatekeyvalue): 
        '''update one line on the table
            usage:
            update(table2class[tblclass],key_value,updatekeyvalue)
            tblclass:table's name ,eg: tblclass='host' 
            key_value:dictionary of the name and the value which you want to update.
                        eg:you want to update the line which hostname is linux-test,
                        then key_value= key_value={'host_name':'linux-test'}
            updatekeyvalue:dictionary of the name and the value which you want to update.
                        eg: updatekeyvalue={'host_name':'linux-test','alisa':'test',......}  '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()    
        for key,value in key_value.items():
            result=session.query(tblclass).filter(getattr(tblclass,key)==value).update(updatekeyvalue)
        session.commit()
        #session.close()
        #print result
        return result 
    
    def selectcount(self,tblclass):
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        count = session.query(table2class[tblclass]).count()
        session.close()
        return count
    def selecttwovaluesbylike(self,tblclass,key1,key2,key3=''):
        '''return a list of pairs of values for the table 
            usage:
            selecttwovalues(table2class[tblclass],keyitem,key)
            tblclass:table's name ,eg: tblclass='host' 
            key1:the name of the clo eg: keyitem='id'
            key2:the name of the clo eg: keyitem='host_name' '''
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        if key3=='':
            result=session.query(getattr(tblclass,key1),getattr(tblclass,key2)).all()
        else:
            for key,value in key3.items():
                result=session.query(getattr(tblclass,key1),getattr(tblclass,key2)).filter(getattr(tblclass,key).like(value)).all()
        session.expunge_all()
        session.close()
        return result

    def selectin(self,tblclass,key,values):
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        t=key+" in ("+values+")"
        result=session.query(tblclass).filter(t).all()
        session.expunge_all()
        session.close()
        return result
    def selectallid(self,tblclass, start=0,limit=0,orderby=""):
        DeclarativeBase.metadata.create_all(mysql_engine)
        Session=sessionmaker(bind=mysql_engine)
        session=Session()
        result=session.query(tblclass).filter(
               getattr(tblclass, 'id') > start).slice(0,limit)
        session.expunge_all()
        session.close()
        return result
