'''
Define service and servicetemplate

Created on 2012-5-24

@author: cailiuqing
'''

from sqlalchemy import *
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import relation
import time

DeclarativeBase = declarative_base()

class TblService(DeclarativeBase):
    __tablename__ = 'tbl_service'

    #column definitions
    access_group = Column('access_group', INTEGER(), nullable=False)
    action_url = Column('action_url', VARCHAR(length=255), nullable=False)
    active = Column('active', Enum(u'0', u'1'), nullable=False)
    active_checks_enabled = Column('active_checks_enabled', Integer(), nullable=False)
    check_command = Column('check_command', TEXT(), nullable=False)
    check_freshness = Column('check_freshness', Integer(), nullable=False)
    check_interval = Column('check_interval', INTEGER())
    check_period = Column('check_period', INTEGER(), nullable=False)
    config_id = Column('config_id', Integer(), nullable=False)
    config_name = Column('config_name', VARCHAR(length=255), nullable=False)
    contact_groups = Column('contact_groups', Integer(), nullable=False)
    contact_groups_tploptions = Column('contact_groups_tploptions', Integer(), nullable=False)
    contacts = Column('contacts', Integer(), nullable=False)
    contacts_tploptions = Column('contacts_tploptions', Integer(), nullable=False)
    display_name = Column('display_name', VARCHAR(length=255), nullable=False)
    event_handler = Column('event_handler', INTEGER(), nullable=False)
    event_handler_enabled = Column('event_handler_enabled', Integer(), nullable=False)
    first_notification_delay = Column('first_notification_delay', INTEGER())
    flap_detection_enabled = Column('flap_detection_enabled', Integer(), nullable=False)
    flap_detection_options = Column('flap_detection_options', VARCHAR(length=20), nullable=False)
    freshness_threshold = Column('freshness_threshold', INTEGER())
    high_flap_threshold = Column('high_flap_threshold', INTEGER())
    host_name = Column('host_name', Integer(), nullable=False)
    host_name_tploptions = Column('host_name_tploptions', Integer(), nullable=False)
    hostgroup_name = Column('hostgroup_name', Integer(), nullable=False)
    hostgroup_name_tploptions = Column('hostgroup_name_tploptions', Integer(), nullable=False)
    icon_image = Column('icon_image', VARCHAR(length=500), nullable=False)
    icon_image_alt = Column('icon_image_alt', VARCHAR(length=255), nullable=False)
    id = Column('id', INTEGER(), primary_key=True, nullable=False)
    import_hash = Column('import_hash', VARCHAR(length=255), nullable=False)
    initial_state = Column('initial_state', VARCHAR(length=20), nullable=False)
    is_volatile = Column('is_volatile', Integer(), nullable=False)
    last_modified = Column('last_modified', DATETIME(), nullable=False)
    low_flap_threshold = Column('low_flap_threshold', INTEGER())
    max_check_attempts = Column('max_check_attempts', INTEGER())
    name = Column('name', VARCHAR(length=255), nullable=False)
    notes = Column('notes', VARCHAR(length=255), nullable=False)
    notes_url = Column('notes_url', VARCHAR(length=255), nullable=False)
    notification_interval = Column('notification_interval', INTEGER())
    notification_options = Column('notification_options', VARCHAR(length=20), nullable=False)
    notification_period = Column('notification_period', INTEGER(), nullable=False)
    notifications_enabled = Column('notifications_enabled', Integer(), nullable=False)
    obsess_over_service = Column('obsess_over_service', Integer(), nullable=False)
    parallelize_check = Column('parallelize_check', Integer(), nullable=False)
    passive_checks_enabled = Column('passive_checks_enabled', Integer(), nullable=False)
    process_perf_data = Column('process_perf_data', Integer(), nullable=False)
    register = Column('register', Enum(u'0', u'1'), nullable=False)
    retain_nonstatus_information = Column('retain_nonstatus_information', Integer(), nullable=False)
    retain_status_information = Column('retain_status_information', Integer(), nullable=False)
    retry_interval = Column('retry_interval', INTEGER())
    service_description = Column('service_description', VARCHAR(length=255), nullable=False)
    servicegroups = Column('servicegroups', Integer(), nullable=False)
    servicegroups_tploptions = Column('servicegroups_tploptions', Integer(), nullable=False)
    stalking_options = Column('stalking_options', VARCHAR(length=20), nullable=False)
    use_template = Column('use_template', Integer(), nullable=False)
    use_template_tploptions = Column('use_template_tploptions', Integer(), nullable=False)
    use_variables = Column('use_variables', Integer(), nullable=False)

    #relation definitions

    def __init__(self,config_name='',\
                host_name='0',\
                host_name_tploptions='2',\
                hostgroup_name='0',\
                hostgroup_name_tploptions='2',\
                service_description='',\
                display_name='',\
                servicegroups='0',\
                servicegroups_tploptions='2',\
                use_template='0',\
                use_template_tploptions='2',\
                check_command='',\
                is_volatile='2',\
                initial_state='',\
                max_check_attempts=None,\
                check_interval=None,\
                retry_interval=None,\
                active_checks_enabled='2',\
                passive_checks_enabled='2',\
                check_period='0',\
                parallelize_check='2',\
                obsess_over_service='2',\
                check_freshness='2',\
                freshness_threshold=None,\
                event_handler='0',\
                event_handler_enabled='2',\
                low_flap_threshold=None,\
                high_flap_threshold=None,\
                flap_detection_enabled='2',\
                flap_detection_options='',\
                process_perf_data='2',\
                retain_status_information='2',\
                retain_nonstatus_information='2',\
                notification_interval=None,\
                first_notification_delay=None,\
                notification_period='0',\
                notification_options='',\
                notifications_enabled='2',\
                contacts='0',\
                contacts_tploptions='2',\
                contact_groups='0',\
                contact_groups_tploptions='2',\
                stalking_options='',\
                notes='',\
                notes_url='',\
                action_url='',\
                icon_image='',\
                icon_image_alt='',\
                use_variables='0',\
                name='',\
                register='1',\
                active='1',\
                last_modified=time.strftime('%Y-%m-%d %H:%M:%S',time.localtime()),\
                access_group='0',\
                config_id=1,\
                import_hash=''):
        self.config_name = config_name
        self.host_name = host_name
        self.host_name_tploptions = host_name_tploptions
        self.hostgroup_name = hostgroup_name
        self.hostgroup_name_tploptions = hostgroup_name_tploptions
        self.service_description = service_description
        self.display_name = display_name
        self.servicegroups = servicegroups
        self.servicegroups_tploptions = servicegroups_tploptions
        self.use_template = use_template
        self.use_template_tploptions = use_template_tploptions
        self.check_command = check_command
        self.is_volatile = is_volatile
        self.initial_state = initial_state
        self.max_check_attempts = max_check_attempts
        self.check_interval = check_interval
        self.retry_interval = retry_interval
        self.active_checks_enabled = active_checks_enabled
        self.passive_checks_enabled = passive_checks_enabled
        self.check_period = check_period
        self.parallelize_check = parallelize_check
        self.obsess_over_service = obsess_over_service
        self.check_freshness = check_freshness
        self.freshness_threshold = freshness_threshold
        self.event_handler = event_handler
        self.event_handler_enabled = event_handler_enabled
        self.low_flap_threshold = low_flap_threshold
        self.high_flap_threshold = high_flap_threshold
        self.flap_detection_enabled = flap_detection_enabled
        self.flap_detection_options = flap_detection_options
        self.process_perf_data = process_perf_data
        self.retain_status_information = retain_status_information
        self.retain_nonstatus_information = retain_nonstatus_information
        self.notification_interval = notification_interval
        self.first_notification_delay = first_notification_delay
        self.notification_period = notification_period
        self.notification_options = notification_options
        self.notifications_enabled = notifications_enabled
        self.contacts = contacts
        self.contacts_tploptions = contacts_tploptions
        self.contact_groups = contact_groups
        self.contact_groups_tploptions = contact_groups_tploptions
        self.stalking_options = stalking_options
        self.notes = notes
        self.notes_url = notes_url
        self.action_url = action_url
        self.icon_image = icon_image
        self.icon_image_alt = icon_image_alt
        self.use_variables = use_variables
        self.name = name
        self.register = register
        self.active = active
        self.last_modified = last_modified
        self.access_group = access_group
        self.config_id = config_id
        self.import_hash = import_hash

    def __repr__(self):
        return "{`id`:%s,\
            `config_name`:%s,\
            `host_name`:%s,\
            `host_name_tploptions`:%s,\
            `hostgroup_name`:%s,\
            `hostgroup_name_tploptions`:%s,\
            `service_description`:%s,\
            `display_name`:%s,\
            `servicegroups`:%s,\
            `servicegroups_tploptions`:%s,\
            `use_template`:%s,\
            `use_template_tploptions`:%s,\
            `check_command`:%s,\
            `is_volatile`:%s,\
            `initial_state`:%s,\
            `max_check_attempts`:%s,\
            `check_interval`:%s,\
            `retry_interval`:%s,\
            `active_checks_enabled`:%s,\
            `passive_checks_enabled`:%s,\
            `check_period`:%s,\
            `parallelize_check`:%s,\
            `obsess_over_service`:%s,\
            `check_freshness`:%s,\
            `freshness_threshold`:%s,\
            `event_handler`:%s,\
            `event_handler_enabled`:%s,\
            `low_flap_threshold`:%s,\
            `high_flap_threshold`:%s,\
            `flap_detection_enabled`:%s,\
            `flap_detection_options`:%s,\
            `process_perf_data`:%s,\
            `retain_status_information`:%s,\
            `retain_nonstatus_information`:%s,\
            `notification_interval`:%s,\
            `first_notification_delay`:%s,\
            `notification_period`:%s,\
            `notification_options`:%s,\
            `notifications_enabled`:%s,\
            `contacts`:%s,\
            `contacts_tploptions`:%s,\
            `contact_groups`:%s,\
            `contact_groups_tploptions`:%s,\
            `stalking_options`:%s,\
            `notes`:%s,\
            `notes_url`:%s,\
            `action_url`:%s,\
            `icon_image`:%s,\
            `icon_image_alt`:%s,\
            `use_variables`:%s,\
            `name`:%s,\
            `register`:%s,\
            `active`:%s,\
            `last_modified`:%s,\
            `access_group`:%s,\
            `config_id`:%s,\
            `import_hash`:%s}" % (self.id,\
            self.config_name,\
            self.host_name,\
            self.host_name_tploptions,\
            self.hostgroup_name,\
            self.hostgroup_name_tploptions,\
            self.service_description,\
            self.display_name,\
            self.servicegroups,\
            self.servicegroups_tploptions,\
            self.use_template,\
            self.use_template_tploptions,\
            self.check_command,\
            self.is_volatile,\
            self.initial_state,\
            self.max_check_attempts,\
            self.check_interval,\
            self.retry_interval,\
            self.active_checks_enabled,\
            self.passive_checks_enabled,\
            self.check_period,\
            self.parallelize_check,\
            self.obsess_over_service,\
            self.check_freshness,\
            self.freshness_threshold,\
            self.event_handler,\
            self.event_handler_enabled,\
            self.low_flap_threshold,\
            self.high_flap_threshold,\
            self.flap_detection_enabled,\
            self.flap_detection_options,\
            self.process_perf_data,\
            self.retain_status_information,\
            self.retain_nonstatus_information,\
            self.notification_interval,\
            self.first_notification_delay,\
            self.notification_period,\
            self.notification_options,\
            self.notifications_enabled,\
            self.contacts,\
            self.contacts_tploptions,\
            self.contact_groups,\
            self.contact_groups_tploptions,\
            self.stalking_options,\
            self.notes,\
            self.notes_url,\
            self.action_url,\
            self.icon_image,\
            self.icon_image_alt,\
            self.use_variables,\
            self.name,\
            self.register,\
            self.active,\
            self.last_modified,\
            self.access_group,\
            self.config_id,\
            self.import_hash)

class TblServicetemplate(DeclarativeBase):
    __tablename__ = 'tbl_servicetemplate'

    #column definitions
    access_group = Column('access_group', INTEGER(), nullable=False)
    action_url = Column('action_url', VARCHAR(length=255), nullable=False)
    active = Column('active', Enum(u'0', u'1'), nullable=False)
    active_checks_enabled = Column('active_checks_enabled', Integer(), nullable=False)
    check_command = Column('check_command', TEXT(), nullable=False)
    check_freshness = Column('check_freshness', Integer(), nullable=False)
    check_interval = Column('check_interval', INTEGER())
    check_period = Column('check_period', INTEGER(), nullable=False)
    config_id = Column('config_id', Integer(), nullable=False)
    contact_groups = Column('contact_groups', Integer(), nullable=False)
    contact_groups_tploptions = Column('contact_groups_tploptions', Integer(), nullable=False)
    contacts = Column('contacts', Integer(), nullable=False)
    contacts_tploptions = Column('contacts_tploptions', Integer(), nullable=False)
    display_name = Column('display_name', VARCHAR(length=255), nullable=False)
    event_handler = Column('event_handler', INTEGER(), nullable=False)
    event_handler_enabled = Column('event_handler_enabled', Integer(), nullable=False)
    first_notification_delay = Column('first_notification_delay', INTEGER())
    flap_detection_enabled = Column('flap_detection_enabled', Integer(), nullable=False)
    flap_detection_options = Column('flap_detection_options', VARCHAR(length=20), nullable=False)
    freshness_threshold = Column('freshness_threshold', INTEGER())
    high_flap_threshold = Column('high_flap_threshold', INTEGER())
    host_name = Column('host_name', Integer(), nullable=False)
    host_name_tploptions = Column('host_name_tploptions', Integer(), nullable=False)
    hostgroup_name = Column('hostgroup_name', Integer(), nullable=False)
    hostgroup_name_tploptions = Column('hostgroup_name_tploptions', Integer(), nullable=False)
    icon_image = Column('icon_image', VARCHAR(length=500), nullable=False)
    icon_image_alt = Column('icon_image_alt', VARCHAR(length=255), nullable=False)
    id = Column('id', INTEGER(), primary_key=True, nullable=False)
    import_hash = Column('import_hash', VARCHAR(length=255), nullable=False)
    initial_state = Column('initial_state', VARCHAR(length=20), nullable=False)
    is_volatile = Column('is_volatile', Integer(), nullable=False)
    last_modified = Column('last_modified', DATETIME(), nullable=False)
    low_flap_threshold = Column('low_flap_threshold', INTEGER())
    max_check_attempts = Column('max_check_attempts', INTEGER())
    notes = Column('notes', VARCHAR(length=255), nullable=False)
    notes_url = Column('notes_url', VARCHAR(length=255), nullable=False)
    notification_interval = Column('notification_interval', INTEGER())
    notification_options = Column('notification_options', VARCHAR(length=20), nullable=False)
    notification_period = Column('notification_period', INTEGER(), nullable=False)
    notifications_enabled = Column('notifications_enabled', Integer(), nullable=False)
    obsess_over_service = Column('obsess_over_service', Integer(), nullable=False)
    parallelize_check = Column('parallelize_check', Integer(), nullable=False)
    passive_checks_enabled = Column('passive_checks_enabled', Integer(), nullable=False)
    process_perf_data = Column('process_perf_data', Integer(), nullable=False)
    register = Column('register', Enum(u'0', u'1'), nullable=False)
    retain_nonstatus_information = Column('retain_nonstatus_information', Integer(), nullable=False)
    retain_status_information = Column('retain_status_information', Integer(), nullable=False)
    retry_interval = Column('retry_interval', INTEGER())
    service_description = Column('service_description', VARCHAR(length=255), nullable=False)
    servicegroups = Column('servicegroups', Integer(), nullable=False)
    servicegroups_tploptions = Column('servicegroups_tploptions', Integer(), nullable=False)
    stalking_options = Column('stalking_options', VARCHAR(length=20), nullable=False)
    template_name = Column('template_name', VARCHAR(length=255), nullable=False)
    use_template = Column('use_template', Integer(), nullable=False)
    use_template_tploptions = Column('use_template_tploptions', Integer(), nullable=False)
    use_variables = Column('use_variables', Integer(), nullable=False)

    #relation definitions

    def __init__(self,template_name='',\
                host_name='0',\
                host_name_tploptions='2',\
                hostgroup_name='0',\
                hostgroup_name_tploptions='2',\
                service_description='',\
                display_name='',\
                servicegroups='0',\
                servicegroups_tploptions='2',\
                use_template='0',\
                use_template_tploptions='2',\
                check_command='',\
                is_volatile='2',\
                initial_state='',\
                max_check_attempts='',\
                check_interval='',\
                retry_interval='',\
                active_checks_enabled='2',\
                passive_checks_enabled='2',\
                check_period='0',\
                parallelize_check='2',\
                obsess_over_service='2',\
                check_freshness='2',\
                freshness_threshold='',\
                event_handler='0',\
                event_handler_enabled='2',\
                low_flap_threshold='',\
                high_flap_threshold='',\
                flap_detection_enabled='2',\
                flap_detection_options='',\
                process_perf_data='2',\
                retain_status_information='2',\
                retain_nonstatus_information='2',\
                notification_interval='',\
                first_notification_delay='',\
                notification_period='0',\
                notification_options='',\
                notifications_enabled='2',\
                contacts='0',\
                contacts_tploptions='2',\
                contact_groups='0',\
                contact_groups_tploptions='2',\
                stalking_options='',\
                notes='',\
                notes_url='',\
                action_url='',\
                icon_image='',\
                icon_image_alt='',\
                use_variables='0',\
                register='0',\
                active='1',\
                last_modified='',\
                access_group='0',\
                config_id='0',\
                import_hash=''):
        self.template_name = template_name
        self.host_name = host_name
        self.host_name_tploptions = host_name_tploptions
        self.hostgroup_name = hostgroup_name
        self.hostgroup_name_tploptions = hostgroup_name_tploptions
        self.service_description = service_description
        self.display_name = display_name
        self.servicegroups = servicegroups
        self.servicegroups_tploptions = servicegroups_tploptions
        self.use_template = use_template
        self.use_template_tploptions = use_template_tploptions
        self.check_command = check_command
        self.is_volatile = is_volatile
        self.initial_state = initial_state
        self.max_check_attempts = max_check_attempts
        self.check_interval = check_interval
        self.retry_interval = retry_interval
        self.active_checks_enabled = active_checks_enabled
        self.passive_checks_enabled = passive_checks_enabled
        self.check_period = check_period
        self.parallelize_check = parallelize_check
        self.obsess_over_service = obsess_over_service
        self.check_freshness = check_freshness
        self.freshness_threshold = freshness_threshold
        self.event_handler = event_handler
        self.event_handler_enabled = event_handler_enabled
        self.low_flap_threshold = low_flap_threshold
        self.high_flap_threshold = high_flap_threshold
        self.flap_detection_enabled = flap_detection_enabled
        self.flap_detection_options = flap_detection_options
        self.process_perf_data = process_perf_data
        self.retain_status_information = retain_status_information
        self.retain_nonstatus_information = retain_nonstatus_information
        self.notification_interval = notification_interval
        self.first_notification_delay = first_notification_delay
        self.notification_period = notification_period
        self.notification_options = notification_options
        self.notifications_enabled = notifications_enabled
        self.contacts = contacts
        self.contacts_tploptions = contacts_tploptions
        self.contact_groups = contact_groups
        self.contact_groups_tploptions = contact_groups_tploptions
        self.stalking_options = stalking_options
        self.notes = notes
        self.notes_url = notes_url
        self.action_url = action_url
        self.icon_image = icon_image
        self.icon_image_alt = icon_image_alt
        self.use_variables = use_variables
        self.register = register
        self.active = active
        self.last_modified = last_modified
        self.access_group = access_group
        self.config_id = config_id
        self.import_hash = import_hash
        
    def __repr__(self):
        return "{`id`:%s,\
            `template_name`:%s,\
            `host_name`:%s,\
            `host_name_tploptions`:%s,\
            `hostgroup_name`:%s,\
            `hostgroup_name_tploptions`:%s,\
            `service_description`:%s,\
            `display_name`:%s,\
            `servicegroups`:%s,\
            `servicegroups_tploptions`:%s,\
            `use_template`:%s,\
            `use_template_tploptions`:%s,\
            `check_command`:%s,\
            `is_volatile`:%s,\
            `initial_state`:%s,\
            `max_check_attempts`:%s,\
            `check_interval`:%s,\
            `retry_interval`:%s,\
            `active_checks_enabled`:%s,\
            `passive_checks_enabled`:%s,\
            `check_period`:%s,\
            `parallelize_check`:%s,\
            `obsess_over_service`:%s,\
            `check_freshness`:%s,\
            `freshness_threshold`:%s,\
            `event_handler`:%s,\
            `event_handler_enabled`:%s,\
            `low_flap_threshold`:%s,\
            `high_flap_threshold`:%s,\
            `flap_detection_enabled`:%s,\
            `flap_detection_options`:%s,\
            `process_perf_data`:%s,\
            `retain_status_information`:%s,\
            `retain_nonstatus_information`:%s,\
            `notification_interval`:%s,\
            `first_notification_delay`:%s,\
            `notification_period`:%s,\
            `notification_options`:%s,\
            `notifications_enabled`:%s,\
            `contacts`:%s,\
            `contacts_tploptions`:%s,\
            `contact_groups`:%s,\
            `contact_groups_tploptions`:%s,\
            `stalking_options`:%s,\
            `notes`:%s,\
            `notes_url`:%s,\
            `action_url`:%s,\
            `icon_image`:%s,\
            `icon_image_alt`:%s,\
            `use_variables`:%s,\
            `register`:%s,\
            `active`:%s,\
            `last_modified`:%s,\
            `access_group`:%s,\
            `config_id`:%s,\
            `import_hash`:%s}" % (self.id,\
            self.template_name,\
            self.host_name,\
            self.host_name_tploptions,\
            self.hostgroup_name,\
            self.hostgroup_name_tploptions,\
            self.service_description,\
            self.display_name,\
            self.servicegroups,\
            self.servicegroups_tploptions,\
            self.use_template,\
            self.use_template_tploptions,\
            self.check_command,\
            self.is_volatile,\
            self.initial_state,\
            self.max_check_attempts,\
            self.check_interval,\
            self.retry_interval,\
            self.active_checks_enabled,\
            self.passive_checks_enabled,\
            self.check_period,\
            self.parallelize_check,\
            self.obsess_over_service,\
            self.check_freshness,\
            self.freshness_threshold,\
            self.event_handler,\
            self.event_handler_enabled,\
            self.low_flap_threshold,\
            self.high_flap_threshold,\
            self.flap_detection_enabled,\
            self.flap_detection_options,\
            self.process_perf_data,\
            self.retain_status_information,\
            self.retain_nonstatus_information,\
            self.notification_interval,\
            self.first_notification_delay,\
            self.notification_period,\
            self.notification_options,\
            self.notifications_enabled,\
            self.contacts,\
            self.contacts_tploptions,\
            self.contact_groups,\
            self.contact_groups_tploptions,\
            self.stalking_options,\
            self.notes,\
            self.notes_url,\
            self.action_url,\
            self.icon_image,\
            self.icon_image_alt,\
            self.use_variables,\
            self.register,\
            self.active,\
            self.last_modified,\
            self.access_group,\
            self.config_id,\
            self.import_hash)    

class TblServicegroup(DeclarativeBase):
    __tablename__ = 'tbl_servicegroup'

    #column definitions
    access_group = Column('access_group', INTEGER(), nullable=False)
    action_url = Column('action_url', VARCHAR(length=255))
    active = Column('active', Enum(u'0', u'1'), nullable=False)
    alias = Column('alias', VARCHAR(length=255), nullable=False)
    config_id = Column('config_id', Integer(), nullable=False)
    id = Column('id', INTEGER(), primary_key=True, nullable=False)
    last_modified = Column('last_modified', DATETIME(), nullable=False)
    members = Column('members', Integer(), nullable=False)
    notes = Column('notes', VARCHAR(length=255))
    notes_url = Column('notes_url', VARCHAR(length=255))
    register = Column('register', Enum(u'0', u'1'), nullable=False)
    servicegroup_members = Column('servicegroup_members', Integer(), nullable=False)
    servicegroup_name = Column('servicegroup_name', VARCHAR(length=255), nullable=False)

    #relation definitions
    
    def __init__(self,servicegroup_name='',\
                 alias='',\
                 members='0',\
                 servicegroup_members='0',\
                 notes='',\
                 notes_url='',\
                 action_url='',\
                 register='0',\
                 active='1',\
                 last_modified='',\
                 access_group='0',\
                 config_id='0'):
        self.servicegroup_name = servicegroup_name
        self.alias = alias
        self.members = members
        self.servicegroup_members = servicegroup_members
        self.notes = notes
        self.notes_url = notes_url
        self.action_url = action_url
        self.register = register
        self.active = active
        self.last_modified = last_modified
        self.access_group = access_group
        self.config_id = config_id

    def __repr__(self):
        return "{`id`:%s,\
                `servicegroup_name`:%s,\
                `alias`:%s,\
                `members`:%s,\
                `servicegroup_members`:%s,\
                `notes`:%s,\
                `notes_url`:%s,\
                `action_url`:%s,\
                `register`:%s,\
                `active`:%s,\
                `last_modified`:%s,\
                `access_group`:%s,\
                `config_id`:%s}" % (self.id,\
                self.servicegroup_name,\
                self.alias,\
                self.members,\
                self.servicegroup_members,\
                self.notes,\
                self.notes_url,\
                self.action_url,\
                self.register,\
                self.active,\
                self.last_modified,\
                self.access_group,\
                self.config_id)
