'''
Define link table about contact, 
contactgroup and contacttemplate

Created on 2012-5-24

@author: cailiuqing
'''

from sqlalchemy import *
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import relation

DeclarativeBase = declarative_base()

class TblLnkContactToCommandHost(DeclarativeBase):
    __tablename__ = 'tbl_lnkContactToCommandHost'

    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

class TblLnkContactToCommandService(DeclarativeBase):
    __tablename__ = 'tbl_lnkContactToCommandService'

    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude
        
    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

class TblLnkContactToContactgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkContactToContactgroup'

    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

class TblLnkContactToContacttemplate(DeclarativeBase):
    __tablename__ = 'tbl_lnkContactToContacttemplate'

    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)
    idSort = Column('idSort', INTEGER(), nullable=False)
    idTable = Column('idTable', Integer(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                idSort='',\
                idTable=''):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.idSort=idSort
        self.idTable=idTable
        
    def __repr__(self):
        return "{'idMaster':%d,\
        'idSlave':%d,\
        'idSort':%d,\
        'idTable':%d}" % (self.idMaster,\
        self.idSlave,\
        self.idSort,\
        self.idTable)

class TblLnkContactgroupToContact(DeclarativeBase):
    __tablename__ = 'tbl_lnkContactgroupToContact'

    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

class TblLnkContactgroupToContactgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkContactgroupToContactgroup'

    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude
        
    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

class TblLnkContacttemplateToCommandHost(DeclarativeBase):
    __tablename__ = 'tbl_lnkContacttemplateToCommandHost'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude
        
    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

class TblLnkContacttemplateToCommandService(DeclarativeBase):
    __tablename__ = 'tbl_lnkContacttemplateToCommandService'

    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude
        
    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

class TblLnkContacttemplateToContactgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkContacttemplateToContactgroup'

    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude
        
    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)
            
class TblLnkContacttemplateToContacttemplate(DeclarativeBase):
    __tablename__ = 'tbl_lnkContacttemplateToContacttemplate'

    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)
    idSort = Column('idSort', INTEGER(), nullable=False)
    idTable = Column('idTable', Integer(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                idSort='',\
                idTable=''):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.idSort=idSort
        self.idTable=idTable
        
    def __repr__(self):
        return "{'idMaster':%d,\
        'idSlave':%d,\
        'idSort':%d,\
        'idTable':%d}" % (self.idMaster,\
        self.idSlave,\
        self.idSort,\
        self.idTable)
        
