
from sqlalchemy import *
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import relation

DeclarativeBase = declarative_base()

class TblLnkHostToContact(DeclarativeBase):
    __tablename__ = 'tbl_lnkHostToContact'

    exclude = Column(u'exclude', Integer(), nullable=False)
    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)

    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

class TblLnkHostToContactgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkHostToContactgroup'

    exclude = Column(u'exclude', Integer(), nullable=False)
    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)
            
class TblLnkHostToHost(DeclarativeBase):
    __tablename__ = 'tbl_lnkHostToHost'

    exclude = Column(u'exclude', Integer(), nullable=False)
    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

class TblLnkHostToHostgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkHostToHostgroup'

    exclude = Column(u'exclude', Integer(), nullable=False)
    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)    

class TblLnkHostToHosttemplate(DeclarativeBase):
    __tablename__ = 'tbl_lnkHostToHosttemplate'

    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    idSort = Column(u'idSort', INTEGER(), nullable=False)
    idTable = Column(u'idTable', Integer(), primary_key=True, nullable=False)

    def __init__(self,idMaster='',\
                idSlave='',\
                idSort='',\
                idTable=''):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.idSort=idSort
        self.idTable=idTable
        
    def __repr__(self):
        return "{'idMaster':%d,\
        'idSlave':%d,\
        'idSort':%d,\
        'idTable':%d}" % (self.idMaster,\
        self.idSlave,\
        self.idSort,\
        self.idTable)
        
class TblLnkHostgroupToHost(DeclarativeBase):
    __tablename__ = 'tbl_lnkHostgroupToHost'

    exclude = Column(u'exclude', Integer(), nullable=False)
    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude) 

class TblLnkHostgroupToHostgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkHostgroupToHostgroup'

    exclude = Column(u'exclude', Integer(), nullable=False)
    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude) 

class TblLnkHosttemplateToContact(DeclarativeBase):
    __tablename__ = 'tbl_lnkHosttemplateToContact'

    exclude = Column(u'exclude', Integer(), nullable=False)
    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)
            
class TblLnkHosttemplateToContactgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkHosttemplateToContactgroup'

    exclude = Column(u'exclude', Integer(), nullable=False)
    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)
            
class TblLnkHosttemplateToHost(DeclarativeBase):
    __tablename__ = 'tbl_lnkHosttemplateToHost'

    exclude = Column(u'exclude', Integer(), nullable=False)
    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

class TblLnkHosttemplateToHostgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkHosttemplateToHostgroup'

    #column definitions
    exclude = Column(u'exclude', Integer(), nullable=False)
    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude=0):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.exclude=exclude

    def __repr__(self):
        return "{'idMaster':%d,\
            'idSlave':%d,\
            'exclude':%d}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)
            
class TblLnkHosttemplateToHosttemplate(DeclarativeBase):
    __tablename__ = 'tbl_lnkHosttemplateToHosttemplate'

    idMaster = Column(u'idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column(u'idSlave', INTEGER(), primary_key=True, nullable=False)
    idSort = Column(u'idSort', INTEGER(), nullable=False)
    idTable = Column(u'idTable', Integer(), primary_key=True, nullable=False)
    
    def __init__(self,idMaster='',\
                idSlave='',\
                idSort='',\
                idTable=''):
        self.idMaster=idMaster
        self.idSlave=idSlave
        self.idSort=idSort
        self.idTable=idTable
        
    def __repr__(self):
        return "{'idMaster':%d,\
        'idSlave':%d,\
        'idSort':%d,\
        'idTable':%d}" % (self.idMaster,\
        self.idSlave,\
        self.idSort,\
        self.idTable)