'''
Define link table about service, 
and servicetemplate

Created on 2012-5-24

@author: cailiuqing
'''

from sqlalchemy import *
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import relation

DeclarativeBase = declarative_base()

class TblLnkServiceToContact(DeclarativeBase):
    __tablename__ = 'tbl_lnkServiceToContact'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude
        
    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)                

class TblLnkServiceToContactgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkServiceToContactgroup'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude
        
    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)               

class TblLnkServiceToHost(DeclarativeBase):
    __tablename__ = 'tbl_lnkServiceToHost'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude

    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)               

class TblLnkServiceToHostgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkServiceToHostgroup'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude
    
    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)               

class TblLnkServiceToServicegroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkServiceToServicegroup'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude

    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)               
    
class TblLnkServiceToServicetemplate(DeclarativeBase):
    __tablename__ = 'tbl_lnkServiceToServicetemplate'

    #column definitions
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)
    idSort = Column('idSort', INTEGER(), nullable=False)
    idTable = Column('idTable', Integer(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                idSort='',\
                idTable=''):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.idSort = idSort
        self.idTable = idTable
        
    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `idSort`:%s,\
            `idTable`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.idSort,\
            self.idTable)

class TblLnkServicetemplateToContact(DeclarativeBase):
    __tablename__ = 'tbl_lnkServicetemplateToContact'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude

    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)           

class TblLnkServicetemplateToContactgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkServicetemplateToContactgroup'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions

    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude

    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)               

class TblLnkServicetemplateToHost(DeclarativeBase):
    __tablename__ = 'tbl_lnkServicetemplateToHost'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions

    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude

    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)    

class TblLnkServicetemplateToHostgroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkServicetemplateToHostgroup'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude

    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)    

class TblLnkServicetemplateToServicegroup(DeclarativeBase):
    __tablename__ = 'tbl_lnkServicetemplateToServicegroup'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions

    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude

    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)    

class TblLnkServicetemplateToServicetemplate(DeclarativeBase):
    __tablename__ = 'tbl_lnkServicetemplateToServicetemplate'

    #column definitions
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)
    idSort = Column('idSort', INTEGER(), nullable=False)
    idTable = Column('idTable', Integer(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                idSort='',\
                idTable=''):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.idSort = idSort
        self.idTable = idTable
        
    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `idSort`:%s,\
            `idTable`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.idSort,\
            self.idTable)    
