'''
Define link table about time

Created on 2012-5-24

@author: cailiuqing
'''

from sqlalchemy import *
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import relation

DeclarativeBase = declarative_base()

class TblLnkTimeperiodToTimeperiod(DeclarativeBase):
    __tablename__ = 'tbl_lnkTimeperiodToTimeperiod'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude
        
    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)


class TblLnkTimeperiodToTimeperiodUse(DeclarativeBase):
    __tablename__ = 'tbl_lnkTimeperiodToTimeperiodUse'

    #column definitions
    exclude = Column('exclude', Integer(), nullable=False)
    idMaster = Column('idMaster', INTEGER(), primary_key=True, nullable=False)
    idSlave = Column('idSlave', INTEGER(), primary_key=True, nullable=False)

    #relation definitions
    
    def __init__(self,idMaster='',\
                idSlave='',\
                exclude='0'):
        self.idMaster = idMaster
        self.idSlave = idSlave
        self.exclude = exclude
        
    def __repr__(self):
        return "{`idMaster`:%s,\
            `idSlave`:%s,\
            `exclude`:%s}" % (self.idMaster,\
            self.idSlave,\
            self.exclude)

