from src.monitor.bottle import Bottle, run
from src.monitor.bottle import request, response
from src.monitor.bottle import error
from src.config.service import actionutils
import json

#config
global hostip
global port

hostip = 'localhost'
port = 8080

app = Bottle()

def get(obj):
    response.set_header('Content-Type', 'application/json')
    fieldname=request.query.field
    type=request.query.type
    if fieldname == '' :
        resultdata=actionutils.selectall(obj)
    else:
        if obj == 'command' :
            resultdata=actionutils.selecttwofieldvalue('command', 'id',fieldname,{'command_type':type})
        else :
            resultdata=actionutils.selecttwofieldvalue(obj, 'id',fieldname)
    return resultdata

def get_by_type(obj,colname,colvalue):
    fieldname=request.query.field
    key_value = {colname : colvalue}
    if fieldname == '' :
        resultdata=actionutils.selectdetailinformation(obj,key_value)
    else:
        resultdata=actionutils.selecttwofieldvalue(obj, 'id',fieldname, key_value)
    return resultdata

@app.route('/conf/hosts', method='GET')
def get_hosts():
    resultdata = get('host')
    return resultdata

@app.route('/conf/hosthwtypes', method='GET')
def get_hwtypes():
    resultdata = get('hosthardwaretype')
    return resultdata

@app.route('/conf/hosttypes', method='GET')
def get_hosttypes():
    resultdata = get('hosttype')
    return resultdata

@app.route('/conf/hostdistributions', method='GET')
def get_hostdistributions():
    resultdata = get('hostdistribution')
    return resultdata

@app.route('/conf/hosttype/<hosttypeid:int>/distributions', method='GET')
def get_hostdistributions_by_typeid(hosttypeid):
    resultdata = get_by_type('hostdistribution','hosttype_id',hosttypeid)
    return resultdata

@app.route('/conf/hostgroups', method='GET')
def get_hostgroups():
    resultdata = get('hostgroup')
    return resultdata

@app.route('/conf/contacts', method='GET')
def get_contacts():
    resultdata = get('contact')
    return resultdata

@app.route('/conf/contactgroups', method='GET')
def get_contactgroups():
    resultdata = get('contactgroup')
    return resultdata

@app.route('/conf/commands1', method='GET')
def get_commands():
    resultdata = get('command')
    return resultdata

@app.route('/conf/commands/<typeid:int>', method='GET')
def get_commands_by_type(typeid):
    resultdata = get_by_type('command','command_type',typeid)
    return resultdata

@app.route('/conf/timeperiods', method='GET')
def get_timeperiods():
    resultdata = get('timeperiod')
    return resultdata


run(app, host = hostip, port = port)