#-*-coding = utf-8 -*-
from src.config.db import dboption
from src.utils import utils
from src.config.service import createconfigfile
import json
import time
import ConfigParser
import base64
import os


def selectdetailinformation(tblclass,key_value):
    '''return a list of the select result
        usage:
        selectdetailinformation(tblclass,key_value) 
        tblclass:the name of the class eg:tblcalss= 'host' 
        key_value:dictionary of the name and the value which you want to select.
                        eg: you want to select the host_name's value is equal to 'linux-test',
                        key_value={'host_name':'linux-test'} '''
    returned_result = {}

    result = dboption.Options().select(dboption.table2class[tblclass],key_value)

    resultlist=[]
    for eachresult in result:
        resultdic=utils.classobj2dict(eachresult)
        tablename='tbl_'+tblclass
        relations=dboption.Options().select(dboption.table2class['relationinformation'],{'master':tablename})
        for item in relations:
            itemtra=utils.classobj2dict(item)
            if itemtra['type'] == 2 :
                if resultdic[itemtra['fieldName']] !=0:
                    classtmp=itemtra['linkTable'].replace('tbl_','')
                    mapids=dboption.Options().select(dboption.table2class[classtmp],{'idMaster':resultdic['id']})
                    mapnames=''
                    if mapids != []:
                        for item1 in mapids:
                            tablename1=itemtra['tableName1'].replace('tbl_','')
                            item1=utils.classobj2dict(item1)
                            if  mapnames == '':
                                mapnames += str(item1['idSlave'])
                            else:
                                mapnames += ','+str(item1['idSlave'])
                else:
                    mapnames=''     
                resultdic[itemtra['fieldName']]=mapnames
        resultlist.append(resultdic)

    if resultlist:
        tblclass += 's'
        returned_result = {tblclass:resultlist}
    
    encodedata=json.dumps(returned_result,ensure_ascii=False,encoding='utf-8')
    return encodedata
    

def insertoneinformation(tblclass,key_value):
    ''' insert a new line to a table,include the link tables
        usage:
        insertoneinformation(tblclass,key_vlalue)
        eg. tblclass='host',key_vlaue={'host_name':'test','alias':'fortest',......}
    '''
    tablename='tbl_'+tblclass
    relations=dboption.Options().select(dboption.table2class['relationinformation'],{'master':tablename})
    relationvalue=[]
    for item in relations:
        itemtra=utils.classobj2dict(item)
        tablename1=itemtra['tableName1'].replace('tbl_','')
        if itemtra['type'] == 2 : 
            #if key_value[itemtra['fieldName']] != '':
            if key_value.has_key(itemtra['fieldName']):
                print itemtra['fieldName']
                rname=key_value[itemtra['fieldName']].split(',')
                rtest=[]
                for fieldname in rname:
                    rtest.append(fieldname)
                valuetmp={itemtra['linkTable']:rtest}
                relationvalue.append(valuetmp)
                key_value[itemtra['fieldName']]=1
            else:
                key_value[itemtra['fieldName']]=0
    print relationvalue
    insertnewid=dboption.Options().insert(dboption.table2class[tblclass], key_value)   
    for key1 in relationvalue:
        for key2,value2 in key1.items():
            tableclass1=key2.replace('tbl_','')
            for value3 in value2:
                dboption.Options().insertlnk(dboption.table2class[tableclass1],{'idMaster':insertnewid,'idSlave':value3})
    return insertnewid


def updateoneinformation(tblclass,keytoupdate,key_value):
    ''' update a line to a table,include the link tables
        usage:
        insertoneinformation(tblclass,keytoupdate,key_vlalue)
        eg. tblclass='host',keytoupdate={'id':1},key_vlaue={'host_name':'test','alias':'fortest',......}
    '''
    tablename='tbl_'+tblclass
    relations=dboption.Options().select(dboption.table2class['relationinformation'],{'master':tablename})
    relationvalue=[]
    for item in relations:
        itemtra=utils.classobj2dict(item)
        tablename1=itemtra['tableName1'].replace('tbl_','')
        if itemtra['type'] == 2 : 
            #if key_value[itemtra['fieldName']] != '':
            if key_value.has_key(itemtra['fieldName']):
                rname=key_value[itemtra['fieldName']].split(',')
                rtest=[]
                for fieldname in rname:
                    rtest.append(fieldname)
                valuetmp={itemtra['linkTable']:rtest}
                relationvalue.append(valuetmp)
                key_value[itemtra['fieldName']]=1
            else:
                key_value[itemtra['fieldName']]=0
    key_value['last_modified']=time.strftime('%Y-%m-%d %H:%M:%S',time.localtime())
    dboption.Options().update(dboption.table2class[tblclass],keytoupdate, key_value)
    for key1 in relationvalue:
        for key2,value2 in key1.items():
            tableclass1=key2.replace('tbl_','')
            dboption.Options().delete(dboption.table2class[tableclass1],{'idMaster':keytoupdate['id']})
            for value3 in value2:
                if value3 != "":
                    dboption.Options().insertlnk(dboption.table2class[tableclass1],{'idMaster':keytoupdate['id'],'idSlave':value3})
    
def deleteoneinformation(tblclass,key_value):
    ''' delete a line to a table,include the link tables
        usage:
        deleteoneinformation(tblclass,key_vlalue)
        eg. tblclass='host',key_vlaue={'id' : 1, 'host_name':'test'}
    '''
    tablename='tbl_'+tblclass
    relations=dboption.Options().select(dboption.table2class['relationinformation'],{'master':tablename})
    id = key_value['id']
    i = 0
    for item in relations:
        i = i+1
        itemtra = utils.classobj2dict(item)
        linkTable = itemtra['linkTable'].replace('tbl_','')
        if dboption.table2class.has_key(linkTable) : 
            if itemtra['type'] != 1 :
                dboption.Options().delete(dboption.table2class[linkTable], {'idMaster': id})
    reversrelations=dboption.Options().select(dboption.table2class['relationinformation'],{'tableName1':tablename})
    for item in reversrelations:
        itemtra = utils.classobj2dict(item)
        mastertablename = itemtra['master'].replace('tbl_','')
        reverslinkTable = itemtra['linkTable'].replace('tbl_','')
        if itemtra['type'] == 1:
            if dboption.table2class.has_key(mastertablename):
                r=dboption.Options().selectonevalue(dboption.table2class[mastertablename],'id',{itemtra['fieldName']:key_value['id']})
                if r != []:
                    for ritem in r:
                        dboption.Options().update(dboption.table2class[mastertablename], {'id':ritem[0]}, {itemtra['fieldName']:None})
        if itemtra['type'] ==2:
            linkTable = itemtra['linkTable'].replace('tbl_','')
            if dboption.table2class.has_key(linkTable) :
                tt=dboption.Options().delete(dboption.table2class[reverslinkTable], {'idSlave': key_value['id']})
    # Second delete this key_value
    dboption.Options().delete(dboption.table2class[tblclass], key_value)

def selecttwofieldvalue(tblclass,key1,key2,key3=''):
    result=dboption.Options().selectalltwovalues(dboption.table2class[tblclass],key1,key2,key3)
    resultlist=[]
    for item in result:
        item=tuple(item)
        tmp={key1:item[0],key2:str(item[1])}
        resultlist.append(tmp)
    tblclass += 's'
    data={tblclass:resultlist}
    encodedata=json.dumps(data,ensure_ascii=False,encoding='utf-8')
    return encodedata

def selectall(tblclass,start=0,limit=0,orderby=""):
    if limit < 0:
        return {tblclass: None}    
    if start < 0:
        return {tblclass: None}
    result=dboption.Options().selectall(dboption.table2class[tblclass],start,limit,orderby)
    #count=dboption.Options().selectcount(tblclass)
    count=0
    resultlist=[]
    for item in result:
        item=utils.classobj2dict(item)
        resultlist.append(item)
        count=count+1
    tblclass += 's'
    data={tblclass:resultlist,'count':count}
    encodedata=json.dumps(data,ensure_ascii=False,encoding='utf-8')
    return encodedata

def selectvalues(tblclass,keyitem,values):
    '''
    select a set of result
    when tblclass is not command, return a dict;
    else return a json with lables
    '''
    result=dboption.Options().selectvalues(tblclass, keyitem, values)
    resultlist=[]
    if tblclass != 'command':
        if len(result) > 1 :
            for item in result:
                item=utils.classobj2dict(item)
                resultlist.append(item)
            tblclass += 's'
            data={tblclass:resultlist}
            encodedata=json.dumps(data,ensure_ascii=False,encoding='utf-8')
        else :
            if len(result) == 1:
                for item in result:
                    item=utils.classobj2dict(item)
                    resultlist.append(item)
                encodedata=json.dumps(item)
            else : 
                encodedata=json.dumps({})
        #print encodedata,type(encodedata)
    else:
        for item in result:
            item=utils.classobj2dict(item)
            resultlist.append(item)
        tblclass += 's'
        data={tblclass:resultlist}
        encodedata=json.dumps(data,ensure_ascii=False,encoding='utf-8')
    return encodedata

def checkinuse(tblclass,key_value):
    tablename='tbl_'+tblclass
    relations=dboption.Options().select(dboption.table2class['relationinformation'],{'tableName1':tablename})
    checkresult={}
    for item in relations:
        itemtra = utils.classobj2dict(item)
        mastertablename = itemtra['master'].replace('tbl_','')
        if itemtra['type'] == 1:
            if dboption.table2class.has_key(mastertablename):
                if mastertablename != "service":
                    targetname=mastertablename+'_name'
                else:
                    targetname='service_description'
                if itemtra['fieldName'] == "check_command":
                    r=dboption.Options().selecttwovaluesbylike(dboption.table2class[mastertablename], 'id',targetname,{itemtra['fieldName']:key_value['id']+"!%"})
                    if r == []:
                        r=dboption.Options().selecttwovalues(dboption.table2class[mastertablename], 'id',targetname,{itemtra['fieldName']:key_value['id']}) 
                else:
                    r=dboption.Options().selecttwovalues(dboption.table2class[mastertablename], 'id',targetname,{itemtra['fieldName']:key_value['id']})
                if r != []:
                    for ritem in r:
                        if checkresult.has_key(mastertablename+'s'):
                            if not {'id':ritem[0],'name':ritem[1]} in checkresult[mastertablename+'s']:
                                checkresult[mastertablename+'s'].append({'id':ritem[0],targetname:ritem[1]})
                        else:
                            checkresult[mastertablename+'s']=[{'id':ritem[0],targetname:ritem[1]}]
                        #print mastertablename,itemtra['fieldName'],ritem[0],ritem[1]
                        #dboption.Options().update(dboption.table2class[mastertablename], {'id':ritem}, {itemtra['fieldName']:None})
        if itemtra['type'] ==2:
            linkTable = itemtra['linkTable'].replace('tbl_','')
            if dboption.table2class.has_key(linkTable) :
                r1=dboption.Options().selectonevalue(dboption.table2class[linkTable], 'idMaster',{'idSlave':key_value['id']}) 
                if r1!= []:
                    r2=[]
                    for r1item in r1:
                        if dboption.table2class.has_key(mastertablename):
                            if mastertablename != "service":
                                targetname=mastertablename+'_name'
                            else:
                                targetname='service_description'
                            r2=dboption.Options().selecttwovalues(dboption.table2class[mastertablename], 'id',targetname,{'id':r1item[0]})                            
                        if r2 != []:
                            if checkresult.has_key(mastertablename+'s'):
                                if not {'id':r2[0][0],'name':r2[0][1]} in checkresult[mastertablename+'s']:
                                    checkresult[mastertablename+'s'].append({'id':r2[0][0],targetname:r2[0][1]})
                            else:
                                checkresult[mastertablename+'s']=[{'id':r2[0][0],targetname:r2[0][1]}]
    encode=json.dumps(checkresult)
    return encode

def selectallservicewithname(tblclass='service',start=0,limit=0,orderby=""):
    if limit < 0:
        return {'service': None}    
    if start < 0:
        return {'service': None}
    data=createconfigfile.creatConfig().configselect('service',start,limit,orderby)
    if data == []:
        return {}
    count=dboption.Options().selectcount('service')
    data={'services':data,'count':count}
    encodedata=json.dumps(data,ensure_ascii=False,encoding='utf-8')
    return encodedata

def get_emaildetail():
    confmail = ConfigParser.ConfigParser()
    cfgmail_file = "/opt/cobra/icinga/etc/mail.conf"
    if os.path.isfile(cfgmail_file):
        confmail.read(cfgmail_file)
        type=confmail.get("smtp", "type")
        if type == '1':
            smtp_server= confmail.get("smtp", "smtpserver")
            smtp_user = confmail.get("smtp", "user")
            smtp_passwd = base64.decodestring(confmail.get("smtp", "password"))
            data={'type':1,'smtpserver':smtp_server,'user':smtp_user,'password':smtp_passwd}
        else:
            data={'type':0}
    else:
        file=open('/opt/cobra/icinga/etc/mail.conf','w')
        file.write('[smtp]\ntype=0\n')
        data={'type':0}
    encodedata=json.dumps(data,ensure_ascii=False,encoding='utf-8')
    return encodedata

def set_emaildetail(data):
    file=open('/opt/cobra/icinga/etc/mail.conf','w')
    if data['type'] == 1 or data['type'] == '1':
        file.write('[smtp]\n'\
                   'type=1\n'\
                   'smtpserver='+data['smtpserver']+'\n'\
                   'user='+data['user']+'\n'\
                   'password='+base64.encodestring(data['password'])+'\n')
    else:
        file.write('[smtp]\n'\
                   'type=0\n')
    file.close()
    
def restartcount(countname):
    counttbl=dboption.Options().selectcount(countname)
    counticinga=dboption.Options().selectcount("icinga"+countname)
    print counttbl, counticinga
    return counttbl==counticinga

def selectincommand(tblclass,key,values):
    result=dboption.Options().selectin(dboption.table2class[tblclass],key,values)
    resultlist=[]
    for item in result:
        item=utils.classobj2dict(item)
        resultlist.append(item)
    tblclass += 's'
    data={tblclass:resultlist}
    encodedata=json.dumps(data,ensure_ascii=False,encoding='utf-8')
    return encodedata
def selectallid(tblclass,start=0,limit=0,orderby=""):
    if limit < 0:
        return {tblclass: None}
    if start < 0:
        return {tblclass: None}
    result=dboption.Options().selectallid(dboption.table2class[tblclass],start,limit,orderby)
    #count=dboption.Options().selectcount(tblclass)
    count=0
    resultlist=[]
    for item in result:
        item=utils.classobj2dict(item)
        resultlist.append(item)
        count=count+1
    tblclass += 's'
    data={tblclass:resultlist,'count':count}
    encodedata=json.dumps(data,ensure_ascii=False,encoding='utf-8')
    return encodedata

'''
tblclass='contact'
contactID=1
key_value={"address1":"","alias":"update from client pgm","contact_name":"","contactgroups":"","email":"","host_notification_commands":"","host_notification_options":"","host_notification_period":"","host_notifications_enabled":"","id":1,"last_modified":"","pager":"","register":"","retain_nonstatus_information":"","retain_status_information":"","service_notification_commands":"","service_notification_options":"","service_notification_period":"","service_notifications_enabled":"","use_template":""}

updateoneinformation(tblclass,{'id':contactID},key_value)
'''
#print selectdetailinformation('hostgroup',{'id':1})
