from src.config.db import dboption
from src.utils import utils
from src.config.service import timeperiod
import os
import shutil
import time

class creatConfig:
    configpath='/opt/cobra/icinga/etc/objects/'
    configbackuppath='/opt/cobra/icinga/etc/backup/'
    if not os.path.exists(configpath):
        os.mkdir(configpath)
    if not os.path.exists(configbackuppath):
        os.mkdir(configbackuppath)
    if not os.path.exists('/opt/cobra/icinga/etc/objects/hosts'):    
        os.mkdir('/opt/cobra/icinga/etc/objects/hosts')
    if not os.path.exists('/opt/cobra/icinga/etc/objects/services'):
        os.mkdir('/opt/cobra/icinga/etc/objects/services')
    if not os.path.exists('/opt/cobra/icinga/etc/backup/hosts'):
        os.mkdir('/opt/cobra/icinga/etc/backup/hosts')
    if not os.path.exists('/opt/cobra/icinga/etc/backup/services'):   
        os.mkdir('/opt/cobra/icinga/etc/backup/services')       
    strfile=''
    outputstrstart=''
    outputstrend=''
    def backupconfig(self,configname):
        self.strfile=self.configpath+configname+'s.cfg'
        backupdir=self.configbackuppath+configname+'.cfg'+time.strftime('%y%m%d%H%M%S',time.localtime())
        #copy old file to backup dir 
        if os.path.exists(self.strfile):
            shutil.copyfile(self.strfile, backupdir)
    def createconfigfilestr(self,configname):
        self.outputstrstart="###############################################################################\n\
#\n\
#"+ configname + " configuration file\n\
#\n\
# Created by: icinga\n\
# Date:         "+ time.strftime('%Y-%m-%d %H:%M:%S',time.localtime())+"\n\
# Version:    Icinga 3.0 config file\n\
#\n\
# --- DO NOT EDIT THIS FILE BY HAND --- \n\
# Icinga will overwite all manual settings during the next update\n\
#\n\
############################################################################### \n"

        self.outputstrend="###############################################################################\n\
#\n\
# "+configname+" configuration file\n\
#\n\
# END OF FILE\n\
#\n\
###############################################################################\n"
    def configselect(self,configname,start=0,limit=0,orderby=""):
        resultlist=[]
        result=dboption.Options().selectall(dboption.table2class[configname],start,limit,orderby)
        if result == []:
            return resultlist
        for eachresult in result:
            resultdic=utils.classobj2dict(eachresult)
            tablename='tbl_'+configname
            relations=dboption.Options().select(dboption.table2class['relationinformation'],{'master':tablename})
            for item in relations:
                itemtra=utils.classobj2dict(item)
                if itemtra['type'] == 2 or itemtra['type'] == 3:
                    if resultdic[itemtra['fieldName']] !=0:
                        classtmp=itemtra['linkTable'].replace('tbl_','')
                        mapids=dboption.Options().select(dboption.table2class[classtmp],{'idMaster':resultdic['id']})
                        mapnames=''
                        for item1 in mapids:
                            tablename1=itemtra['tableName1'].replace('tbl_','')
                            item1=utils.classobj2dict(item1)
                            #print item1['idSlave']
                            #if  mapnames == '':
                            #    mapnames += str(item1['idSlave'])
                            #else:
                            #    mapnames += ','+str(item1['idSlave'])
                            if dboption.table2class.has_key(tablename1):
                                mapname=dboption.Options().selectonevalue(dboption.table2class[tablename1],itemtra['target1'],{'id':item1['idSlave']})
                            else:
                                mapname=[]
                            #print mapname
                            if mapname != [] :
                                if mapnames == '':
                                    mapnames += str(mapname[0][0])
                                else:
                                    mapnames += ','+str(mapname[0][0])
                    else:
                        mapnames=''     
                    resultdic[itemtra['fieldName']]=mapnames
                elif itemtra['type'] == 1 :
                    if resultdic[itemtra['fieldName']] !=0 and resultdic[itemtra['fieldName']] != '0':
                        tablename1=itemtra['tableName1'].replace('tbl_','')
                        if itemtra['fieldName'] == 'check_command':
                            if resultdic[itemtra['fieldName']] != '':
                                relationname=resultdic[itemtra['fieldName']].split('!')
                                relationname[0]=dboption.Options().selectonevalue(dboption.table2class[tablename1],itemtra['target1'],{'id':relationname[0]})
                                if relationname[0] !=[]:
                                    relationname[0]=str(relationname[0][0][0])
                                    delimiter='!'
                                    relationname=delimiter.join(relationname)
                        else:
                            relname=dboption.Options().selectonevalue(dboption.table2class[tablename1],itemtra['target1'],{'id':resultdic[itemtra['fieldName']]})
                            if relname != []:
                                relationname=str(relname[0][0])
                    else:
                        relationname='' 
                    resultdic[itemtra['fieldName']]=relationname
            resultlist.append(resultdic)
        return resultlist

    def createcommandconfig(self):
        self.strfile=''
        self.outputstrstart=''
        self.outputstrend=''
        #self.createoneconfigfile('command')
        self.backupconfig('command')
        self.createconfigfilestr('command')
        resultlist=self.configselect('command')
        file=open(self.strfile,'w')
        file.write(self.outputstrstart)
        #datas=dboption.Options().selectall(dboption.table2class['command'])
        #resultlist=[]    
        #for item in datas:
        for item in resultlist:
            #item=utils.classobj2dict(item)
            file.write("\ndefine command {\n")
            file.write("    command_name    "+item["command_name"]+"\n")
            file.write("    command_line    "+item["command_line"]+"\n")
            file.write("    register        "+item["register"]+"\n}\n")
            #print item,type(item)
            #skipEntry(configname,item)
            #resultlist.append(item)    
        file.write(self.outputstrend) 
        file.close()
        #print resultlist
    def createcontactconfig(self):
        self.strfile=''
        self.outputstrstart=''
        self.outputstrend=''
        self.backupconfig('contact')
        self.createconfigfilestr('contact')
        resultlist=self.configselect('contact')
        #self.createoneconfigfile('contact')
        file=open(self.strfile,'w')
        file.write(self.outputstrstart)
        #datas=dboption.Options().selectall(dboption.table2class['contact'])
        #resultlist=[]    
        for item in resultlist:
            file.write("\ndefine contact {\n")
            file.write("    contact_name                    "+item["contact_name"]+"\n")
            if item["alias"]!='':
                file.write("    alias                           "+item["alias"]+"\n")
            if item['contactgroups']!='':               
                file.write("    contactgroups                   "+item["contactgroups"]+"\n")
            file.write("    host_notifications_enabled      "+str(item["host_notifications_enabled"])+"\n")
            file.write("    service_notifications_enabled   "+str(item["service_notifications_enabled"])+"\n")
            if item["host_notification_period"]!="":
                file.write("    host_notification_period        "+item["host_notification_period"]+"\n")
            if item["service_notification_period"]!="":
                file.write("    service_notification_period     "+item["service_notification_period"]+"\n")
            if item["host_notification_options"]!="":
                file.write("    host_notification_options       "+item["host_notification_options"]+"\n")
            if item["service_notification_options"]!="":
                file.write("    service_notification_options    "+item["service_notification_options"]+"\n")
            if item["host_notification_commands"]!="":
                file.write("    host_notification_commands      "+item["host_notification_commands"]+"\n")
            if item["service_notification_commands"]!="":
                file.write("    service_notification_commands   "+item["service_notification_commands"]+"\n")
            if item["email"]!="":
                file.write("    email                           "+item["email"]+"\n")
            if item["pager"]!="":
                file.write("    pager                           "+item["pager"]+"\n")
            if item["use_template"]!="":
                file.write("    use                             "+item["use_template"]+"\n")
            file.write("    register                        "+str(item["register"])+"\n}\n")
        file.write(self.outputstrend)    
        file.close()
    
    def createhostgroupconfig(self):
        self.strfile=''
        self.outputstrstart=''
        self.outputstrendc = ''
        self.backupconfig('hostgroup')
        self.createconfigfilestr('hostgroup')
        resultlist=self.configselect('hostgroup')
        #self.createoneconfigfile('contact')
        file=open(self.strfile,'w')
        file.write(self.outputstrstart)
        for item in resultlist:
            file.write("\ndefine hostgroup {\n")
            file.write("    hostgroup_name       "+item["hostgroup_name"]+"\n")
            file.write("    alias                "+item["alias"]+"\n")
            if item["members"] != "":
                file.write("    members              "+item["members"]+"\n")
            if item["hostgroup_members"] != "":
                file.write("    hostgroup_members    "+item["hostgroup_members"]+"\n")
            file.write("    register             "+str(item["register"])+"\n}\n")
        file.write(self.outputstrend)
        file.close()

    def creathostconfig(self):
        self.strfile=''
        self.outputstrstart=''
        self.outputstrend=''
        self.createconfigfilestr('host')
        resultlist=self.configselect('host')
        for i in os.listdir(self.configpath+"hosts"):
            backupdir=self.configbackuppath+'hosts/'+i+time.strftime('%y%m%d%H%M%S',time.localtime())
            oldfile=self.configpath+'hosts/'+i
            #print oldfile,backupdir
            os.rename(oldfile, backupdir)
        for item in resultlist:
            self.strfile=self.configpath+'hosts/'+item['host_name']+'.cfg'
            #backupdir=self.configbackuppath+'hosts/'+item['host_name']+'.cfg'+time.strftime('%y%m%d%H%M%S',time.localtime())
            #copy old file to backup dir 
            #if os.path.exists(self.strfile):
            #    shutil.copyfile(self.strfile, backupdir) 
            file=open(self.strfile,'w')
            file.write(self.outputstrstart)
            file.write("\ndefine host {\n")
            file.write("    host_name                   "+item["host_name"]+"\n")
            file.write("    alias                       "+item["alias"]+"\n")
            file.write("    address                     "+item["address"]+"\n")
            if item["display_name"]!='':
                file.write("    display_name                "+item["display_name"]+"\n")
            if item["parents"] != "":
                file.write("    parents                     "+item["parents"]+"\n")
            if item["hostgroups"] != "":
                file.write("    hostgroups                  "+item["hostgroups"]+"\n")
            if item["check_command"] != "":
                file.write("    check_command               "+item["check_command"]+"\n")
            if item["use_template"] != "":
                file.write("    use                         "+item["use_template"]+"\n")
            if item["initial_state"] != "":
                file.write("    initial_state               "+item["initial_state"]+"\n")   
            if item["max_check_attempts"] != None:
                #file.write("    max_check_attempts          "+str(item["max_check_attempts"])+"\n")
                file.write("    max_check_attempts          "+'1'+"\n")
            if item["max_check_attempts"] == None:
                file.write("    max_check_attempts          "+'5'+"\n")                       
            if item["check_interval"] != None:
                file.write("    check_interval              "+str(item["check_interval"])+"\n")     
            if item["retry_interval"] != None:
                file.write("    retry_interval              "+str(item["retry_interval"])+"\n") 
            if item["active_checks_enabled"] != 2:
                file.write("    active_checks_enabled       "+str(item["active_checks_enabled"])+"\n")  
            if item["passive_checks_enabled"] != 2:
                file.write("    passive_checks_enabled      "+str(item["passive_checks_enabled"])+"\n")
            if item["check_period"] != "":
                file.write("    check_period                "+item["check_period"]+"\n")    
            if item["contacts"] != "":
                file.write("    contacts                    "+item["contacts"]+"\n")                  
            if item["contact_groups"] != "":
                file.write("    contact_groups              "+item["contact_groups"]+"\n")
            if item["notification_interval"] != None:
                file.write("    notification_interval       "+str(item["notification_interval"])+"\n")                                
            if item["notification_period"] != "":
                file.write("    notification_period         "+item["notification_period"]+"\n")
            if item["first_notification_delay"] != None:
                file.write("    first_notification_delay    "+str(item["first_notification_delay"])+"\n")				 
            if item["notification_options"] != "":
                file.write("    notification_options        "+item["notification_options"]+"\n")
            if item["notifications_enabled"] !=2:
                file.write("    notifications_enabled       "+str(item["notifications_enabled"])+"\n")
	    file.write("    event_handler_enabled       "+'1'+"\n")
	    file.write("    event_handler               "+'event_host_log_todb'+"\n")
            file.write("    register	                "+item["register"]+"\n}\n")
            file.write(self.outputstrend)
            file.close()
    def createcontactgroupconfig(self):
        self.strfile=''
        self.outputstrstart=''
        self.outputstrendc = ''
        self.backupconfig('contactgroup')
        self.createconfigfilestr('contactgroup')
        resultlist=self.configselect('contactgroup')
        file=open(self.strfile,'w')
        file.write(self.outputstrstart)
        for item in resultlist:
            file.write("\ndefine contactgroup {\n")
            file.write("    contactgroup_name       "+item["contactgroup_name"]+"\n")
            file.write("    alias                   "+item["alias"]+"\n")
            if item["members"] != "":
                file.write("    members                 "+item["members"]+"\n")
            if item["contactgroup_members"] != "":
                file.write("    contactgroup_members    "+item["contactgroup_members"]+"\n")
            file.write("    register                "+str(item["register"])+"\n}\n")
        file.write(self.outputstrend)
        file.close()

    def creatservcieconfig(self):
        self.strfile=''
        self.outputstrstart=''
        self.outputstrend=''
        self.createconfigfilestr('service')
        resultlist=self.configselect('service')
        hostnamelist=[]
        file=''
        for i in os.listdir(self.configpath+"services"):
            backupdir=self.configbackuppath+'services/'+i+time.strftime('%y%m%d%H%M%S',time.localtime())
            oldfile=self.configpath+'services/'+i
            #print oldfile,backupdir
            os.rename(oldfile, backupdir)
        for item in resultlist:
            self.strfile=self.configpath+'services/'+item['host_name']+'.cfg'
            #backupdir=self.configbackuppath+'services/'+item['host_name']+'.cfg'+time.strftime('%y%m%d%H%M%S',time.localtime())
            if os.path.exists(self.strfile) and (item['host_name'] not in hostnamelist):
                #shutil.copyfile(self.strfile, backupdir)
                hostnamelist.append(item['host_name'])
                file=open(self.strfile,'w')
                file.write(self.outputstrstart)
                file.close()
            if os.path.exists(self.strfile) and item['host_name'] in hostnamelist:
                file=open(self.strfile,'a+')
            if not os.path.exists(self.strfile):
                file=open(self.strfile,'a+')
                file.write(self.outputstrstart)
                hostnamelist.append(item['host_name'])
            file.write("\ndefine service {\n")
            file.write("    host_name                   "+item["host_name"]+"\n")
            if item["hostgroup_name"] != "":
                file.write("    hostgroup_name              "+item["hostgroup_name"]+"\n")
            file.write("    service_description         "+item["service_description"]+"\n")
            if item["use_template"] != "":
                file.write("    use                         "+item["use_template"]+"\n")            
            if item["check_command"] != "":
                file.write("    check_command               "+item["check_command"]+"\n")
            if item["initial_state"] != "":
                file.write("    initial_state               "+item["initial_state"]+"\n")
            if item["max_check_attempts"] != None:
                #file.write("    max_check_attempts          "+str(item["max_check_attempts"])+"\n")
                file.write("    max_check_attempts          "+'1'+"\n")
            if item["max_check_attempts"] == None:
                file.write("    max_check_attempts          "+'5'+"\n") 
            if item["check_interval"] != None:
                file.write("    check_interval              "+str(item["check_interval"])+"\n")
            if item["retry_interval"] != None:
                file.write("    retry_interval              "+str(item["retry_interval"])+"\n")
            if item["active_checks_enabled"] != 2:
                file.write("    active_checks_enabled       "+str(item["active_checks_enabled"])+"\n")
            if item["passive_checks_enabled"] != 2:
                file.write("    passive_checks_enabled      "+str(item["passive_checks_enabled"])+"\n")
            if item["check_period"] != "":
                file.write("    check_period                "+item["check_period"]+"\n")
            if item["notification_interval"] != None:
                file.write("    notification_interval       "+str(item["notification_interval"])+"\n")
            if item["first_notification_delay"] != None:
                file.write("    first_notification_delay    "+str(item["first_notification_delay"])+"\n")
            if item["notification_period"] != "":
                file.write("    notification_period         "+item["notification_period"]+"\n")
            if item["notification_options"] != "":
                file.write("    notification_options        "+item["notification_options"]+"\n")
            if item["contacts"] != "":
                file.write("    contacts                    "+item["contacts"]+"\n")                  
            if item["contact_groups"] != "":
                file.write("    contact_groups              "+item["contact_groups"]+"\n")
            if item["notifications_enabled"] !=2:
                file.write("    notifications_enabled       "+str(item["notifications_enabled"])+"\n")
            file.write("    event_handler_enabled       "+'1'+"\n")
            file.write("    event_handler               "+'event_service_log_todb'+"\n")

            file.write("    register                    "+item["register"]+"\n}\n")
            file.close()
    def createtimeconfig(self):
        self.strfile=''
        self.outputstrstart=''
        self.outputstrendc = ''
        self.backupconfig('timeperiod')
        self.createconfigfilestr('timeperiod')
        #resultlist=self.configselect('timeperiod')
        resultlist = timeperiod.get_time_detail()
        file=open(self.strfile,'w')
        file.write(self.outputstrstart)
        for item in resultlist:
            file.write("\ndefine timeperiod {\n")
            file.write("    timeperiod_name"+"\t\t\t\t"+item["timeperiod_name"]+"\n")
            if item["alias"] != "":
                file.write("    alias"+"\t\t\t\t"+item["alias"]+"\n")
            for timedefinition in item["time_definitions"]:
                file.write("    "+timedefinition['definition']+"\t\t\t\t"+timedefinition['range']+"\n")
            file.write("    register"+"\t\t\t\t"+str(item["register"])+"\n}\n")
        file.write(self.outputstrend)
        file.close()
'''
creatConfig().createcommandconfig()
creatConfig().createcontactconfig()
creatConfig().creathostconfig()
creatConfig().createhostgroupconfig()
creatConfig().createcontactgroupconfig()
creatConfig().creatservcieconfig()
creatConfig().createtimeconfig()

#file=open("/opt/test/test","a+")
#file.write("\nsssss")
#file.close()
'''
