from src.config.db import dboption
from src.utils import utils

tp = dboption.table2class['timeperiod']
td = dboption.table2class['timedefinition']


def get_all_tp():
    '''return all from the table tbl_timepriod
            usage:
            get_all()
    '''
    result = dboption.Options().selectall(tp)
    return result

# definite function for get all existed timeperiod name

def get_all_tpname():
    '''return all timeperiod types from the table tbl_timepriod
            usage:
            get_all_tpname()
    '''
    result = dboption.Options().selectoneclo(tp, 'timeperiod_name')
    return result

def get_time_detail(tpid=0,tname=''):
    result=[]
    if tpid :
        '''# select one timeperiod's detail information by timeperiod id'''
        key_value = {'id' : tpid}        
        # 1.select detail information of this time period in tbl_timeperiod
        tip_result = dboption.Options().select(tp, key_value)
        # 2.select detail definition information of this time period
        td_kv = {'tipId' : tpid}
        tid_result = dboption.Options().select(td, td_kv)
        # 3.rebuild results
        '''
        tid = []
        for i in range(len(tid_result)):
            tid.append(tid_result[i])
        tids = {'time_definitions' : tid}
        result = utils.classobj2dict(tip_result[0])
        result.update(tids)'''
        tid = []
        for item in tid_result:
            item = utils.classobj2dict(item)
            tid.append(item)
        tids = {'time_definitions' : tid}
        result = utils.classobj2dict(tip_result[0])
        result.update(tids)     
        return result    
#        print "The time period detail info: ",result
    if tname !='':
        key_value = {'timeperiod_name' : tname}
        tip_result = dboption.Options().select(tp, key_value)
        if tip_result == []:
            return {}
        result = utils.classobj2dict(tip_result[0])
        td_kv = {'tipId' : result['id']}
        tid_result = dboption.Options().select(td, td_kv)
        tid = []
        for item in tid_result:
            item = utils.classobj2dict(item)
            tid.append(item)
        tids = {'time_definitions' : tid}
        result.update(tids)
        return result
    else:
        # get all timepeirod with detail information
        #result=[]
        tip_result = dboption.Options().selectall(tp)
        for item in tip_result :
            item = utils.classobj2dict(item)
            td_kv = { 'tipId' : item["id"]}
            tid_result = dboption.Options().select(td, td_kv)
            tid = []
            for tiditem in tid_result :
                tiditem = utils.classobj2dict(tiditem)
                tid.append(tiditem)
            tids = {'time_definitions' : tid}
            item.update(tids)
            result.append(item)
        #print result
    return result


def add_new_tp(key_value):
    '''add a new timeperiod include two parts: time period and time definition'''
    # tp_kv means timepeirod's key_value directory
    tp_kv = {}
    # td_kv means timedefinition's key_value directroy
    # td_kv = {}     
    for key,value in key_value.items():
        if key == 'time_definitions':
            td_kv_i = value
        else:
            tp_kv[key] = value
    print "tp_kv is ",tp_kv
    if dboption.Options().selectonevalue(tp,'timeperiod_name',tp_kv):
        print "This time period is already exists.Please rename it, and try it again."
    else:
        # insert data into tbl_timeperiod
        id = dboption.Options().insert(tp, tp_kv)
        #id = 5
    print  "last insert id is ", id
    for timedef in td_kv_i:
        timedef.update({'tipId':id})
        print timedef
        # insert data into tbl_timedefinition with tipId
        dboption.Options().insert(td, timedef)
    
    return None


def update_tp(key_value):
    '''update time period with time definitions
            usage:
            update_tp(key_value)
            key_value is a whole dict include id,
            timeperiod_name,alias,time_definitions and so on. 
            '''
    # 1.get all time_definitions info and update them
    value = key_value['time_definitions']
    td_kv = {'tipId' : key_value['id']}
    if dboption.Options().select(td, td_kv):
        dboption.Options().delete(td, td_kv)
    if isinstance(value,list):
        for i in range(len(value)):
            td_kv_i = value[i]
            if td_kv_i['id'] =='0' or td_kv_i['id']=='' or td_kv_i['id'] ==0:
                del td_kv_i['id']
            dboption.Options().insert(td, td_kv_i)
    else:
        if value['id'] =='0' or value['id']=='' or value['id'] ==0:
            del value['id']
        print value
        dboption.Options().insert(td, value)
    # 2.get all time period info exclude time_definitions
    print "***********"
    del key_value['time_definitions']   
    id_kv = {'id' : key_value['id']}
    old_result = dboption.Options().select(tp, id_kv)
    old_tpname = old_result[0].timeperiod_name
    old_alias = old_result[0].alias
    if key_value['timeperiod_name'] != old_tpname or key_value['alias'] != old_alias:
        key_value.update({'last_modified':utils.time()})
        dboption.Options().update(tp, id_kv, key_value)
    else:
        pass
    
    return None
    
def update_td(key_value):
    '''update time definitions
            usage:
            update_td(key_value)
            key_value is a whole dict include id,
            tipId,definition,range and so on. 
            '''
    id_kv = {'id': key_value['id']}
    old_result = dboption.Options().select(td, id_kv)
    old_definition = old_result[0].definition
    old_range = old_result[0].range
    if key_value['definition'] != old_definition or key_value['range'] != old_range:
        key_value.update({'last_modified':utils.time()})
        dboption.Options().update(td, id_kv, key_value)
    else:
        pass         
    
    return None


def del_tp(key_value):
    ''' delete the timeperiod and related time definitions
        only with no host,service and contact use it.
        usage:
            del_tp(key_value)
            eg:key_value {'id':1,'timeperiod_name':'test'}
    '''
    tipId = key_value['id']
    '''# 1.make sure host,service and contacts are not use this.
    
    host = dboption.table2class['host']
    h1 = dboption.Options().selectonevalue(host, 'check_period', {'check_period':tipId})
    h2 = dboption.Options().selectonevalue(host, 'notification_period', {'notification_period':tipId})
    service = dboption.table2class['service']
    s1 = dboption.Options().selectonevalue(service, 'check_period', {'check_period':tipId})
    s2 = dboption.Options().selectonevalue(service, 'notification_period', {'notification_period':tipId})
    contact = dboption.table2class['contact']
    c1 = dboption.Options().selectonevalue(contact, 'host_notification_period', {'host_notification_period':tipId})
    c2 = dboption.Options().selectonevalue(contact, 'service_notification_period', {'service_notification_period':tipId})
    if h1 or h2 or s1 or s2 or c1 or c2:
        print "This time period is still be used.Please delete it after stop using it."
        exit
    else:
        print "no use" '''
    # start deleting
    if dboption.Options().select(tp, key_value):
        td_kv = {'tipId' : tipId}
        if dboption.Options().select(td, td_kv):
            dboption.Options().delete(td, td_kv)
        dboption.Options().delete(tp, key_value)
                   
        check_result1 = dboption.Options().select(tp, key_value)
        check_result2 = dboption.Options().select(td, td_kv)
        if not check_result1 and not check_result2:
            print "Successfully delete this timeperiod"
        else:
            print "delete error"
    else:
        print "This time period is not exists." 
    
# update the timeperiod
        

#### TEST ####
'''
#get_all()
#get_all_tpname()
test={'timeperiod_name' : 'test', 'alias' : 'test again and again','definition' : 'test_td', 'range' : '09:00-12:33','definition' : 'test_td1', 'range' : '09:00-12:30'}
#add_new_tp(test)
#del_tp(test)
#get_tp_detail('24x7_sans_holidays')
kv = {'tipId' : '1'}
tid_result = dboption.Options().select(td, kv)
import time
start = time.clock()
for i in range(10000):
    get_time_detail('24x7')
end = time.clock()
print end-start

del_tp({'timeperiod_name':'24x7'})
             'last_modified':'2012-05-31',\
#update_tp(key_value)
get_time_detail(30)
test = {'id':52,'tipId':30,'definition':'mondays-test','range':'09:00-13:00'}
#update_tp(key_value)
test_del = {'id':2,'timeperiod_name':'workhours'}
#del_tp(test_del)
'''
#  test add new 
'''key_value1 = {u'id':'17',\
             u'timeperiod_name' : u'updatetest',\
             u'alias':u'test update',\
             u'time_definitions':[\
                                 {u'id':'62',u'tipId':'17',u'definition':u'mon-up-7',u'range':u'09:00-15:00'},\
                                 {u'id':'0',u'tipId':'17',u'definition':u'tue-up-6',u'range':u'09:00-16:00'}]\
             }
key_value = {u'timeperiod_name' : u'clq_test-up-6',\
             u'alias':u'test second time-up',\
             u'time_definitions':{u'id':'',u'tipId':'',u'definition':u'mon-up-4',u'range':u'09:00-13:00'}
             }
key_value2 = {u'id':'17',\
             u'timeperiod_name' : u'upssss',\
             u'alias':u'test update',\
             u'time_definitions':{u'id':'62',u'tipId':'17',u'definition':u'mon-up-90',u'range':u'09:00-15:00'}
             }
data = utils.unicode2dict(key_value2)'''

#t={'time_definitions': {'definition': 'definiton update success', 'range': '0:00-24:00', 'id': '0', 'tipId': '17'}, 'id': '17', 'timeperiod_name': 'update timePeriod name from pgm'}

#del data['id']
#del item['id']
#update_tp(t)
#del_tp({'id':15})
#add_new_tp(data)
get_time_detail()