'''
CobraApi.py
Created on 2012-5-3

@author: root
'''
from src.monitor.db.CobraSQLAlchemyResult import get_raw_all_hosts, get_raw_ok_hosts, get_raw_problem_hosts, \
get_all_host_count, get_ok_host_count, get_problem_host_count, get_raw_all_services, get_raw_ok_services, \
get_raw_problem_services, get_all_service_count, get_raw_host_detail, get_raw_service_detail, \
get_ok_service_count, get_problem_service_count, get_all_hostgroup_host_count, \
get_raw_service_for_host, get_raw_hostgroups, get_raw_hostgroup_hosts,\
get_raw_host_by_keyword, get_raw_host_by_keyword_count, \
get_raw_services_by_keyword,get_raw_services_by_keyword_count,\
get_raw_host_detail_by_hostname, get_raw_service_for_hostname,\
get_raw_hostgroup_hosts_by_hostgroupname
from src.monitor.db.CobraLogentries import get_paging_logentries, get_all_logentries_count, \
get_paging_logentries_by_keyword ,get_all_logentries_by_keyword_count
from src.monitor.db.CobraRemoteControl import get_ipmi_info_by_hostname
from src.utils.utils import  data_to_json, all_data_to_json, obj2dict
from os import system
import json
from base64 import b64encode , b64decode
from src.utils import utils

host_all_status = ['host_id', 'instance_id', 'alias', 'display_name', 'address', 'address6', \
               'output', 'long_output', 'perfdata', 'current_state', 'current_check_attempt', \
               'max_check_attempts', 'last_check', 'next_check', 'last_state_change','hw_type']

host_status = ['host_id', 'instance_id', 'alias', 'display_name', 'address', 'address6', \
               'output', 'long_output', 'perfdata', 'current_state', 'current_check_attempt', \
               'max_check_attempts', 'last_check', 'next_check', 'last_state_change']

service_status = ['hostname', 'service_id', 'instance_id', 'host_object_id',  'display_name', \
                  'output', 'long_output', 'perfdata', 'current_state', 'current_check_attempt', \
                  'max_check_attempts', 'last_check', 'next_check',]

#hostgroup_status = ['hostgroup_id', 'alias', 'host_object_id', 'state']
hostgroup_status = ['hostgroup_id', 'alias', 'host_count','hostgroup_name']

logentries_status = ['logentry_time','logentry_type','logentry_data']

ipmidetailinfo_status = ['ipmi_device_ip','ipmi_device_user','ipmi_device_pwd','hw_type','host_name']

def get_all_jobs():
    
    return {'jobs':''}

def get_scan_detail():
    
    pass

def get_hosts(status, limit, marker):

    if limit < 0:
        return {'hosts': None}
    
    if marker < 0:
        return {'hosts': None}
    
    if status == -1:
        hosts = get_raw_problem_hosts(limit, marker)
        host_count = get_problem_host_count()
        encodedata = all_data_to_json('hosts', hosts, host_status, host_count)
    elif status == 0:
        hosts = get_raw_ok_hosts(limit, marker)
        host_count = get_ok_host_count()
        encodedata = all_data_to_json('hosts', hosts, host_status, host_count)
    else:
        hosts = get_raw_all_hosts(limit, marker)
        host_count = get_all_host_count()
        encodedata = all_data_to_json('hosts', hosts, host_all_status, host_count)
          
    return encodedata

def get_host_by_keyword(limit,marker,keyword):
    hosts = get_raw_host_by_keyword(limit,marker,keyword)
    host_count = get_raw_host_by_keyword_count(keyword)
    encodedata = all_data_to_json('hosts',hosts,host_all_status,host_count)
    return encodedata

def get_services(status, limit, marker):
    
    if limit < 0:
        return {'services': None}
    
    if marker < 0:
        return {'services': None}
    
    if status == -1:
        services = get_raw_problem_services(limit, marker)
        service_count = get_problem_service_count()
    elif status == 0:
        services = get_raw_ok_services(limit, marker)
        service_count = get_ok_service_count()
    else:
        services = get_raw_all_services(limit, marker)
        service_count = get_all_service_count()
      
    encodedata = all_data_to_json('services', services, service_status, service_count)
    return encodedata    

def get_services_by_keyword(limit , marker , keyword):
    
    services = get_raw_services_by_keyword(limit,marker,keyword)
    services_count = get_raw_services_by_keyword_count(keyword)
    encodedata = all_data_to_json('services',services, service_status,services_count)
    return encodedata
    
def get_host_by_id(hostid):
    host_detail = get_raw_host_detail(hostid)
    encodedata = data_to_json('host_detail', host_detail, host_status)
    return encodedata

def get_service_by_id(hid, sid):
    service_detail = get_raw_service_detail(hid, sid)
    encodedata = data_to_json('service_detail', service_detail, service_status)
    return encodedata

def get_service_by_host(hostid):
    host_services = get_raw_service_for_host(hostid)
    encodedata = data_to_json('services', host_services, service_status)
    return encodedata

def get_hostgroups(limit, marker):
    host_groups = get_raw_hostgroups(limit, marker)
    encodedata = data_to_json('hostgroups', host_groups, hostgroup_status)
    return encodedata

def get_hostgroup_hosts(hostgroupid, limit, marker):
    host_count = get_all_hostgroup_host_count(hostgroupid)
    hostgroup_hosts = get_raw_hostgroup_hosts(hostgroupid, limit, marker)
    encodedata = all_data_to_json('hosts', hostgroup_hosts, host_status, host_count)
    return encodedata

def get_logentries(limit,marker):
    logentries = get_paging_logentries(limit,marker)
    logentries_count = get_all_logentries_count()
    encodedata = all_data_to_json('logentries',logentries,logentries_status,logentries_count)
    return encodedata

def get_logentries_by_keyword(limit,marker,keyword):
    
    keyword_logentries = get_paging_logentries_by_keyword(limit,marker,keyword)
    keyword_logentries_count = get_all_logentries_by_keyword_count(keyword)
    encodedata = all_data_to_json('logentries',keyword_logentries,logentries_status,keyword_logentries_count)
    return encodedata


def get_ipmiobj_by_host(host_name):
    ipmiobj = get_ipmi_info_by_hostname(host_name)
    if str(ipmiobj) == 'None':
        ipmiobj = {}
    else:
        ipmiobj = obj2dict(ipmidetailinfo_status ,ipmiobj)
        #ipmiobj['ipmi_device_pwd'] = b64decode(ipmiobj['ipmi_device_pwd'])
    return json.dumps(ipmiobj)

'''
def modify_ipmiobj(data):
    host_id = int(data['host_id'])
    ipmi_device_ip = data['ipmi_device_ip']
    ipmi_device_user = data['ipmi_device_user']
    ipmi_device_pwd = data['ipmi_device_pwd']
    
    ipmi_device_pwd = b64encode(ipmi_device_pwd)
    
    print "In function modify_ipmiobj : "+str(host_id)
    
    ipmiobj = get_ipmi_info_by_host(host_id)
    if str(ipmiobj) == 'None':
        add_ipmi_info(ipmi_device_ip,ipmi_device_user,ipmi_device_pwd,host_id)
    else:
        update_ipmi_info(ipmi_device_ip,ipmi_device_user,ipmi_device_pwd,host_id)
'''
def detect_all_remotehost(hostnames,cmd):
    
    hostname_list = hostnames.split(',')
    result_list = []
    for hname in hostname_list:
        ipmiobj = get_ipmi_info_by_hostname(hname)
        print ipmiobj[3]
        if str(ipmiobj) == 'None':
            ipmi_dict = {
                            'hostname':hname,
                            'ctlresult':"remotectlresult7"
                        }
        else:
            if ipmiobj[0] == '' or ipmiobj[1] == '' or ipmiobj[2] == '':
                ipmi_dict = {
                                "hostname":ipmiobj[4],
                                "ctlresult":"remotectlresult8"
                            }
            else:
                data = {
                        'ipmi_device_ip':ipmiobj[0],
                        'ipmi_device_user':ipmiobj[1],
                        'ipmi_device_pwd':ipmiobj[2]
                    }
                result = detect_remotehost(data, cmd)
                ipmi_dict = {
                                "hostname":ipmiobj[4],
                                "ctlresult":result
                            } 
        result_list.append(ipmi_dict)
    result_dict = {"remotectlresults": result_list}

    return result_dict
   
#remote_data = {'host_name': 'win2008', 'ipmi_device_ip': '10.1.81.226', 'ipmi_device_user': 'root', 'ipmi_device_pwd': 'abc'}

def detect_remotehost(data,cmd):
    ipmi_device_ip = data['ipmi_device_ip']
    ipmi_device_user = data['ipmi_device_user']
    ipmi_device_pwd = data['ipmi_device_pwd']
    
    cmd_result = '' 
    if cmd == "on" :
        cmd_result = system('ipmitool -H '+ipmi_device_ip+' -I lan -U '+ipmi_device_user+' -P '+ipmi_device_pwd+' chassis power on > /tmp/.remote_log')
    elif cmd == "off":
        cmd_result = system('ipmitool -H '+ipmi_device_ip+' -I lan -U '+ipmi_device_user+' -P '+ipmi_device_pwd+' chassis power off > /tmp/.remote_log')
    elif cmd == "status":
        cmd_result = system('ipmitool -H '+ipmi_device_ip+' -I lan -U '+ipmi_device_user+' -P '+ipmi_device_pwd+' chassis power status > /tmp/.remote_log')
    elif cmd == "reset":
        cmd_result = system('ipmitool -H '+ipmi_device_ip+' -I lan -U '+ipmi_device_user+' -P '+ipmi_device_pwd+' chassis power reset > /tmp/.remote_log')
    else:
        cmd_result = "wrong command"
    
    try:
        f = open('/tmp/.remote_log','r')
        if cmd_result == 0:
            cmd_result = f.read()
        else:
            system('ipmitool -H '+ipmi_device_ip+' -I lan -U '+ipmi_device_user+' -P '+ipmi_device_pwd+' chassis power status > /tmp/.remote_log')
            tmp_res = f.read()
            if tmp_res == "Chassis Power is off\n":
                cmd_result = "The host has powered off and you can't reset it!\n"
            else:
                system("echo \'IP, username or password is wrong\' > /tmp/.remote_log")
                cmd_result = "IP, username or password is wrong!\n"
    finally:
        f.close()
        system('rm /tmp/.remote_log')
        
    cmd_code = ""
    if cmd_result == "Chassis Power is off\n":
        cmd_code = "remotectlresult0"
    elif cmd_result == "Chassis Power is on\n":
        cmd_code = "remotectlresult1"
    elif cmd_result == "Chassis Power Control: Down/Off\n":
        cmd_code = "remotectlresult2"
    elif cmd_result == "Chassis Power Control: Up/On\n":
        cmd_code = "remotectlresult3"
    elif cmd_result == "Chassis Power Control: Reset\n":
        cmd_code = "remotectlresult4"
    elif cmd_result == "The host has powered off and you can't reset it!\n":
        cmd_code = "remotectlresult5"
    elif cmd_result == "IP, username or password is wrong!\n":
        cmd_code = "remotectlresult6"
    else:
        cmd_code = cmd_result
    
    print cmd_code
    return cmd_code


def get_host_by_hostname(hostname):
    host_detail = get_raw_host_detail_by_hostname(hostname)
    encodedata = data_to_json('host_detail', host_detail, host_status)
    return encodedata

def get_service_by_hostname(hostname):
    host_services = get_raw_service_for_hostname(hostname)
    encodedata = data_to_json('services', host_services, service_status)
    return encodedata
def get_hostgroup_hosts_by_hostgroupname(hostgroupname, limit, marker):
    host_count = get_all_hostgroup_host_count(hostgroupname)
    hostgroup_hosts = get_raw_hostgroup_hosts_by_hostgroupname(hostgroupname, limit, marker)
    encodedata = all_data_to_json('hosts', hostgroup_hosts, host_status, host_count)
    return encodedata
