'''
Create on 2012-7-25

@author: Tian Pengfei
'''

from sqlalchemy.dialects.mysql import BIGINT, DATETIME, DOUBLE, INTEGER, SMALLINT, TEXT, VARCHAR,TINYINT,ENUM
from sqlalchemy import Column
from sqlalchemy import BigInteger, Float, String
from sqlalchemy import create_engine
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import sessionmaker
from sqlalchemy.schema import UniqueConstraint, ForeignKey
from sqlalchemy.schema import Index
from sqlalchemy import func,or_,and_
import ConfigParser
from src.config.db.dbhosts import TblHost


cfg_file = "/opt/cobra/cobra-api/config.conf"
#cfg_file = "/root/workspace/Cobra/code/cobra/config.conf"

conf = ConfigParser.ConfigParser()
conf.read(cfg_file)

db_host = conf.get("db", "db_host")   
db_port = conf.get("db", "db_port")   
db_user = conf.get("db", "db_user")   
db_pass = conf.get("db", "db_pass") 
db_name = conf.get("db", "db_name")

#connect = 'mysql://'+db_user+':'+db_pass+'@'+db_host+':'+db_port+'/'+db_name+'?charset=utf8'

#mysql_engine = create_engine(connect, echo=False, pool_size = 20,pool_recycle=3600)

connect = 'postgresql://'+db_user+':'+db_pass+'@'+db_host+':'+db_port+'/'+db_name
mysql_engine = create_engine(connect, encoding="utf-8", echo=False, pool_size = 20,pool_recycle=3600)

base = declarative_base()
metadata = base.metadata
metadata.bind = mysql_engine


class TblHost(base):
        __tablename__ = 'tbl_host'
        __table_args__= (UniqueConstraint('host_name','config_id', name='config_name'),)
        
        id = Column(INTEGER(11),primary_key = True , autoincrement = True)
        host_name = Column(VARCHAR(255),default='')
        alias = Column(VARCHAR(255),default='')
        display_name = Column(VARCHAR(255),default='')
        address = Column(VARCHAR(255),default='')
        hw_address = Column(VARCHAR(255),default='')
        hw_user = Column(VARCHAR(255),default='')
        hw_password = Column(VARCHAR(255),default='')
        hw_type = Column(TINYINT(3),default=1)
        soft_type = Column(TINYINT(3),default=0)
        parents = Column(TINYINT(3),default=0)
        parents_tploptions =Column(TINYINT(3),default=2)
        hostgroups = Column(TINYINT(3),default=0)
        hostgroups_tploptions = Column(TINYINT(3),default=2)
        check_command = Column(TEXT,default='')
        use_template = Column(TINYINT(3),default=0)
        use_template_tploptions = Column(TINYINT(3),default=2)
        initial_state = Column(VARCHAR(20),default='')
        max_check_attempts = Column(INTEGER(11),default=0)
        check_interval = Column(INTEGER(11),default=0)
        retry_interval = Column(INTEGER(11),default=0)
        active_checks_enabled = Column(INTEGER(3),default=2)
        passive_checks_enabled = Column(TINYINT(3),default=2)
        check_period = Column(INTEGER(11),default=0)
        obsess_over_host = Column(TINYINT(3),default=2)
        check_freshness = Column(TINYINT(3),default=2)
        freshness_threshold = Column(INTEGER(11),default=0)
        event_handler = Column(INTEGER(11),default=0)
        event_handler_enabled = Column(INTEGER(TINYINT(3)) , default=2)
        low_flap_threshold = Column(INTEGER(11),default=0)
        high_flap_threshold = Column(INTEGER(11),default=0)
        flap_detection_enabled = Column(TINYINT(3),default=2)
        flap_detection_options = Column(VARCHAR(20),default='')
        process_perf_data = Column(TINYINT(3) , default=2)
        retain_status_information = Column(TINYINT(3) , default=2)
        retain_nonstatus_information = Column(TINYINT(3) , default=2)
        contacts = Column(TINYINT(3), default=0)
        contacts_tploptions = Column(TINYINT(3) , default=2)
        contact_groups = Column(TINYINT(3) , default=0)
        contact_groups_tploptions = Column(TINYINT(3) , default=2)
        notification_interval = Column(INTEGER(11),default=0)
        notification_period = Column(INTEGER(11),default=0)
        first_notification_delay = Column(INTEGER(11),default=0)
        notification_options = Column(VARCHAR(20),default='')
        notifications_enabled = Column(TINYINT(3),default=2)
        stalking_options = Column(VARCHAR(20),default='')
        notes = Column(VARCHAR(255),default='')
        notes_url = Column(VARCHAR(255),default='')
        action_url = Column(VARCHAR(255),default='')
        icon_image = Column(VARCHAR(500),default='')
        icon_image_alt = Column(VARCHAR(255),default='')
        vrml_image = Column(VARCHAR(255),default='')
        statusmap_image = Column(VARCHAR(255),default='')
        d2_coords = Column('2d_coords',VARCHAR(255),default='')
        d3_coords = Column('3d_coords',VARCHAR(255),default='')
        use_variables = Column(TINYINT(3),default=0)
        name = Column(VARCHAR(255),default='')
        register = Column(ENUM('0','1'),default='1')
        active = Column(ENUM('0','1'),default='1')
        last_modified = Column(DATETIME , default='0000-00-00 00:00:00')
        access_group = Column(INTEGER(10) , default = 0)
        config_id = Column(TINYINT(3) , default = 0)
        
        def __init__(self,host_name='',\
                     alias='',\
                     display_name='',\
                     address='',\
                     hw_address='',\
                     hw_user='',\
                     hw_password='',\
                     hw_type=1,\
                     soft_type=0,\
                     parents=0,\
                     parents_tploptions=2,\
                     hostgroups=0,\
                     hostgroups_tploptions=2,\
                     check_command='',\
                     use_template=0,\
                     use_template_tploptions=2,\
                     initial_state=0,\
                     max_check_attempts=0,\
                     check_interval=0,\
                     retry_interval=0,\
                     active_checks_enabled=2,\
                     passive_checks_enabled=2,\
                     check_period=0,\
                     obsess_over_host=2,\
                     check_freshness=2,\
                     freshness_threshold=0,\
                     event_handler=0,\
                     event_handler_enabled=2,\
                     low_flap_threshold=0,\
                     high_flap_threshold=0,\
                     flap_detection_enabled=2,\
                     flap_detection_options='',\
                     process_perf_data=2,\
                     retain_status_information=2,\
                     retain_nonstatus_information=2,\
                     contacts=0,\
                     contacts_tploptions=2,\
                     contact_groups=0,\
                     contact_groups_tploptions=2,\
                     notification_interval=0,\
                     notification_period=0,\
                     first_notification_delay=0,\
                     notification_options='',\
                     notifications_enabled=2,\
                     stalking_options='',\
                     notes='',\
                     notes_url='',\
                     action_url='',\
                     icon_image='',\
                     icon_image_alt='',\
                     vrml_image='',\
                     statusmap_image='',\
                     d2_coords='',\
                     d3_coords='',\
                     use_variables=0,\
                     name='',\
                     register='1',\
                     active='1',\
                     last_modified='0000-00-00 00:00:00',\
                     access_group=0,\
                     config_id=0):
            
            self.host_name = host_name
            self.alias = alias
            self.display_name = display_name
            self.address = address
            self.hw_address = hw_address
            self.hw_user = hw_user
            self.hw_password = hw_password
            self.hw_type = hw_type
            self.soft_type = soft_type
            self.parents = parents
            self.parents_tploptions = parents_tploptions
            self.hostgroups = hostgroups
            self.hostgroups_tploptions = hostgroups_tploptions
            self.check_command = check_command
            self.use_template = use_template
            self.use_template_tploptions = use_template_tploptions
            self.initial_state = initial_state
            self.max_check_attempts = max_check_attempts
            self.check_interval = check_interval
            self.retry_interval = retry_interval
            self.active_checks_enabled = active_checks_enabled
            self.passive_checks_enabled = passive_checks_enabled
            self.check_period = check_period
            self.obsess_over_host = obsess_over_host
            self.check_freshness = check_freshness
            self.freshness_threshold = freshness_threshold
            self.event_handler = event_handler
            self.event_handler_enabled = event_handler_enabled
            self.low_flap_threshold = low_flap_threshold
            self.high_flap_threshold = high_flap_threshold
            self.flap_detection_enabled = flap_detection_enabled
            self.flap_detection_options = flap_detection_options
            self.process_perf_data = process_perf_data
            self.retain_status_information = retain_status_information
            self.retain_nonstatus_information = retain_nonstatus_information
            self.contacts = contacts
            self.contacts_tploptions = contacts_tploptions
            self.contact_groups = contact_groups
            self.contact_groups_tploptions = contact_groups_tploptions
            self.notification_interval = notification_interval
            self.notification_period = notification_period
            self.first_notification_delay = first_notification_delay
            self.notification_options = notification_options
            self.notifications_enabled = notifications_enabled
            self.stalking_options = stalking_options
            self.notes = notes
            self.notes_url = notes_url
            self.action_url = action_url
            self.icon_image = icon_image
            self.icon_image_alt = icon_image_alt
            self.vrml_image = vrml_image
            self.statusmap_image = statusmap_image
            self.d2_coords = d2_coords
            self.d3_coords = d3_coords
            self.use_variables = use_variables
            self.name = name
            self.register = register
            self.active = active
            self.last_modified = last_modified
            self.access_group = access_group
            self.config_id = config_id
            
        def __repr__(self):
            return "{'id':%d \
                     'host_name':%s \
                     'alias':%s \
                     'display_name':%s \
                     'address':%s \
                     'hw_address':%s \
                     'hw_user':%s \
                     'hw_password':%s \
                     'hw_type':%d \
                     'soft_type':%d \
                     'parents':%d \
                     'parents_tploptions':%d \
                     'hostgroups':%d \
                     'hostgroups_tploptions':%d \
                     'check_command':%d \
                     'use_template':%d \
                     'use_template_tploptions':%d \
                     'initial_state':%s \
                     'max_check_attempts':%d \
                     'check_interval':%d \
                     'retry_interval';%d \
                     'active_checks_enabled':%d \
                     'passive_checks_enabled':%d \
                     'check_period': %d \
                     'obsess_over_host':%d \
                     'check_freshness':%d \
                     'freshness_threshold':%d \
                     'event_handler':%d \
                     'event_handler_enabled':%d \
                     'low_flap_threshold':%d \
                     'high_flap_threshold':%d \
                     'flap_detection_enabled':%d \
                     'flap_detection_options':%d \
                     'process_perf_data':%d \
                     'retain_status_information':%d \
                     'retain_nonstatus_information':%d \
                     'contacts':%d \
                     'contacts_tploptions':%d \
                     'contact_groups':%d \
                     'contact_groups_tploptions':%d \
                     'notification_interval':%d \
                     'notification_period':%d \
                     'first_notification_delay':%d \
                     'notification_options':%s \
                     'notifications_enabled':%d \
                     'stalking_options':%s \
                     'notes':%s \
                     'notes_url':%s \
                     'action_url':%s \
                     'icon_image':%s \
                     'icon_image_alt':%s \
                     'vrml_image':%s \
                     'statusmap_image':%s \
                     '2d_coords':%s \
                     '3d_coords':%s \
                     'use_variables':%d \
                     'name':%s \
                     'register':%d \
                     'active':%d \
                     'last_modified':%s \
                     'access_group':%d \
                     'config_id':%d \
                    }"%(self.id, \
                        self.host_name, \
                        self.alias, \
                        self.display_name, \
                        self.address, \
                        self.hw_address, \
                        self.hw_user, \
                        self.hw_password, \
                        self.hw_type, \
                        self.soft_type, \
                        self.parents, \
                        self.parents_tploptions, \
                        self.hostgroups, \
                        self.hostgroups_tploptions, \
                        self.check_command, \
                        self.use_template, \
                        self.use_template_tploptions, \
                        self.initial_state, \
                        self.max_check_attempts, \
                        self.check_interval, \
                        self.retry_interval, \
                        self.active_checks_enabled, \
                        self.passive_checks_enabled, \
                        self.check_period, \
                        self.obsess_over_host, \
                        self.check_freshness, \
                        self.freshness_threshold, \
                        self.event_handler, \
                        self.event_handler_enabled, \
                        self.low_flap_threshold, \
                        self.high_flap_threshold, \
                        self.flap_detection_enabled, \
                        self.flap_detection_options, \
                        self.process_perf_data, \
                        self.retain_status_information, \
                        self.retain_nonstatus_information, \
                        self.contacts, \
                        self.contacts_tploptions, \
                        self.contact_groups, \
                        self.contact_groups_tploptions, \
                        self.notification_interval, \
                        self.notification_period, \
                        self.first_notification_delay, \
                        self.notification_options, \
                        self.notifications_enabled, \
                        self.stalking_options, \
                        self.notes, \
                        self.notes_url, \
                        self.action_url, \
                        self.icon_image, \
                        self.icon_image_alt, \
                        self.vrml_image, \
                        self.statusmap_image, \
                        self.d2_coords, \
                        self.d3_coords, \
                        self.use_variables, \
                        self.name, \
                        self.register, \
                        self.active, \
                        self.last_modified, \
                        self.access_group, \
                        self.config_id)



def get_ipmi_info_by_hostname(host_name):
    
    Session = sessionmaker(bind = mysql_engine)
    session = Session()
    ipmiobj = session.query(TblHost.hw_address,TblHost.hw_user, \
                            TblHost.hw_password,TblHost.hw_type,TblHost.host_name) \
                            .filter(TblHost.host_name == host_name) \
                            .first()
    session.flush()
    session.close()
    return ipmiobj


def get_ipmi_info_all():
    
    Session = sessionmaker(bind = mysql_engine)
    session = Session()
    
    ipmiobj = session.query(TblHost).all()
    session.flush()
    session.close()
    print ipmiobj
    return ipmiobj


'''
class TblIpmidetailinfo(base):
        __tablename__ = 'tbl_ipmidetailinfo' 
        
        ipmi_device_id = Column(INTEGER(11),primary_key = True ,autoincrement = True)
        ipmi_device_ip = Column(VARCHAR(20),default = '')
        ipmi_device_user = Column(VARCHAR(255),default = '')
        ipmi_device_pwd = Column(VARCHAR(255),default = '')
        host_id = Column(INTEGER(11))
        
        def __init__(self, ipmi_device_ip = '',ipmi_device_user = '' , ipmi_device_pwd = '' ,host_id = 0):
            
            self.ipmi_device_ip = ipmi_device_ip
            self.ipmi_device_user = ipmi_device_user
            self.ipmi_device_pwd = ipmi_device_pwd
            self.host_id = host_id
            
        
        def __repr__(self):
            return "{'ipmi_device_id':%d \
                     'ipmi_device_ip':%s \
                     'ipmi_device_user':%s \
                     'ipmi_device_pwd':%s \
                     'host_id':%d \
                    }" % (self.ipmi_device_id, \
                    self.ipmi_device_ip, \
                    self.ipmi_device_user, \
                    self.ipmi_device_pwd, \
                    self.host_id)
                    

def add_ipmi_info(ipmi_ip , ipmi_user , ipmi_pwd , host_id):
    
    Session = sessionmaker(bind = mysql_engine)
    session = Session()
       
    ipmi_obj = TblIpmidetailinfo(ipmi_ip , ipmi_user ,ipmi_pwd ,host_id)
    session.add(ipmi_obj)
    
    session.flush()
    session.close()

def update_ipmi_info(ipmi_ip , ipmi_user , ipmi_pwd , host_id):
    
    Session = sessionmaker(bind = mysql_engine)
    session = Session()
    
    ipmiobj = session.query(TblIpmidetailinfo).filter(TblIpmidetailinfo.host_id == host_id).first()
    ipmiobj.ipmi_device_ip = ipmi_ip
    ipmiobj.ipmi_device_user = ipmi_user
    ipmiobj.ipmi_device_pwd = ipmi_pwd
    
    session.flush()
    session.close()

def get_ipmi_info_by_host(host_id):
    
    Session = sessionmaker(bind = mysql_engine)
    session = Session()
    
    ipmiobj = session.query(TblIpmidetailinfo.ipmi_device_ip,TblIpmidetailinfo.ipmi_device_user, \
                            TblIpmidetailinfo.ipmi_device_pwd,TblIpmidetailinfo.host_id,IcingaHosts.display_name) \
                            .filter(and_(TblIpmidetailinfo.host_id == host_id,IcingaHosts.host_id == host_id)) \
                            .first()
    session.flush()
    session.close()
    return ipmiobj
'''
#print get_ipmi_info_by_hostname('localhost')
