'''
Created on 2012-5-3

@author: root
'''
from sqlalchemy.dialects.mysql import BIGINT, DATETIME, DOUBLE, INTEGER, SMALLINT, TEXT, VARCHAR
from sqlalchemy import Column
from sqlalchemy import BigInteger, Float, String
from sqlalchemy import create_engine
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import sessionmaker
from sqlalchemy.schema import UniqueConstraint
from sqlalchemy.schema import Index
from sqlalchemy import func , or_
import ConfigParser
import sys
from src.utils import utils
from src.monitor.db.CobraRemoteControl import TblHost
from sqlalchemy.sql.expression import outerjoin


global base
global mysql_engine

'''
user='icinga'
passwd='icinga'
dbname='icinga'
hostip='127.0.0.1'
port='3306'
'''


cfg_file = "/opt/cobra/cobra-api/config.conf"
#cfg_file = "/root/workspace/Cobra/code/cobra/config.conf"

conf = ConfigParser.ConfigParser()
conf.read(cfg_file)
#print conf.sections()
db_host = conf.get("db", "db_host")   
db_port = conf.get("db", "db_port")   
db_user = conf.get("db", "db_user")   
db_pass = conf.get("db", "db_pass") 
db_name = conf.get("db", "db_name")

#connect = 'mysql://'+db_user+':'+db_pass+'@'+db_host+':'+db_port+'/'+db_name+'?charset=utf8'
connect = 'postgresql://'+db_user+':'+db_pass+'@'+db_host+':'+db_port+'/'+db_name
mysql_engine = create_engine(connect, encoding="utf-8", echo=False, pool_size = 20,pool_recycle=3600)
base = declarative_base()
metadata = base.metadata
metadata.bind = mysql_engine

class IcingaHosts(base):
        __tablename__ = 'icinga_hosts'
        __table_args__= (UniqueConstraint('host_id', name='host_id'), \
                         UniqueConstraint('instance_id', 'config_type', 'host_object_id',  name='instance_id'))

        host_id = Column(BIGINT(20), primary_key=True, autoincrement=True)
        instance_id  = Column(BIGINT(20), default=0)
        config_type = Column(SMALLINT(6), default=0)
        host_object_id = Column(BIGINT(20), default=0)
        alias = Column(VARCHAR(64), default = '')
        display_name = Column(VARCHAR(255), default = '')
        address = Column(VARCHAR(128), default = '')
        address6 = Column( VARCHAR(128), default = '')
        check_command_object_id = Column( BIGINT(20), default = 0)
        check_command_args = Column(VARCHAR(255), default = '')
        eventhandler_command_object_id = Column(BIGINT(20), default = 0)
        eventhandler_command_args = Column(VARCHAR(255), default = '')
        notification_timeperiod_object_id = Column(BIGINT(20), default = 0)
        check_timeperiod_object_id = Column(BIGINT(20),  default = 0)
        failure_prediction_options = Column( VARCHAR(64), default = '')
        check_interval = Column( DOUBLE, default = 0)
        retry_interval = Column( DOUBLE, default = 0)
        max_check_attempts = Column(SMALLINT(6), default = 0)
        first_notification_delay = Column( DOUBLE, default = 0)
        notification_interval = Column(DOUBLE, default = 0)
        notify_on_down = Column(SMALLINT(6), default = 0)
        notify_on_unreachable = Column(SMALLINT(6), default = 0)
        notify_on_recovery = Column(SMALLINT(6), default = 0)
        notify_on_flapping = Column(SMALLINT(6), default = 0)
        notify_on_downtime = Column(SMALLINT(6), default = 0)
        stalk_on_up = Column(SMALLINT(6), default = 0)
        stalk_on_down = Column(SMALLINT(6), default = 0)
        stalk_on_unreachable = Column(SMALLINT(6), default = 0)
        flap_detection_enabled = Column(SMALLINT(6), default = 0)
        flap_detection_on_up = Column(SMALLINT(6), default = 0)
        flap_detection_on_down = Column(SMALLINT(6), default = 0)
        flap_detection_on_unreachable = Column(SMALLINT(6), default = 0)
        low_flap_threshold = Column(DOUBLE, default = 0)
        high_flap_threshold = Column(DOUBLE, default = 0)
        process_performance_data = Column(SMALLINT(6), default = 0)
        freshness_checks_enabled = Column(SMALLINT(6), default = 0)
        freshness_threshold = Column(SMALLINT(6), default = 0)
        passive_checks_enabled = Column(SMALLINT(6), default = 0)
        event_handler_enabled = Column(SMALLINT(6), default = 0)
        active_checks_enabled = Column(SMALLINT(6), default = 0)
        retain_status_information = Column(SMALLINT(6), default = 0)
        retain_nonstatus_information = Column(SMALLINT(6), default = 0)
        notifications_enabled = Column(SMALLINT(6), default = 0)
        obsess_over_host = Column(SMALLINT(6), default = 0)
        failure_prediction_enabled = Column(SMALLINT(6), default = 0)
        notes = Column(VARCHAR(255), default = '')
        notes_url = Column(VARCHAR(255), default = '')
        action_url = Column(VARCHAR(255), default = '')
        icon_image = Column(VARCHAR(255), default = '')
        icon_image_alt = Column(VARCHAR(255), default = '')
        vrml_image = Column(VARCHAR(255), default = '')
        statusmap_image = Column(VARCHAR(255), default = '')
        have_2d_coords = Column(SMALLINT(6), default = 0)
        x_2d = Column(SMALLINT(6), default = 0)
        y_2d = Column(SMALLINT(6), default = 0)
        have_3d_coords = Column(SMALLINT(6), default = 0)
        x_3d = Column(DOUBLE, default = 0)
        y_3d = Column(DOUBLE, default = 0)
        z_3d = Column(DOUBLE, default = 0)

        def __init__(self,instance_id = 0,\
                    config_type = 0,\
                    host_object_id = 0,\
                    alias = '',\
                    display_name = '',\
                    address = '',\
                    address6 = '',\
                    check_command_object_id = 0,\
                    check_command_args = '',\
                    eventhandler_command_object_id = 0,\
                    eventhandler_command_args = '',\
                    notification_timeperiod_object_id = 0,\
                    check_timeperiod_object_id = 0,\
                    failure_prediction_options = '',\
                    check_interval = 0,\
                    retry_interval = 0,\
                    max_check_attempts = 0,\
                    first_notification_delay = 0,\
                    notification_interval = 0,\
                    notify_on_down = 0,\
                    notify_on_unreachable = 0,\
                    notify_on_recovery = 0,\
                    notify_on_flapping = 0,\
                    notify_on_downtime = 0,\
                    stalk_on_up = 0,\
                    stalk_on_down = 0,\
                    stalk_on_unreachable = 0,\
                    flap_detection_enabled = 0,\
                    flap_detection_on_up = 0,\
                    flap_detection_on_down = 0,\
                    flap_detection_on_unreachable = 0,\
                    low_flap_threshold = 0,\
                    high_flap_threshold = 0,\
                    process_performance_data = 0,\
                    freshness_checks_enabled = 0,\
                    freshness_threshold = 0,\
                    passive_checks_enabled = 0,\
                    event_handler_enabled = 0,\
                    active_checks_enabled = 0,\
                    retain_status_information = 0,\
                    retain_nonstatus_information = 0,\
                    notifications_enabled = 0,\
                    obsess_over_host = 0,\
                    failure_prediction_enabled = 0,\
                    notes = '',\
                    notes_url = '',\
                    action_url = '',\
                    icon_image = '',\
                    icon_image_alt = '',\
                    vrml_image = '',\
                    statusmap_image = '',\
                    have_2d_coords = 0,\
                    x_2d = 0,\
                    y_2d = 0,\
                    have_3d_coords = 0,\
                    x_3d = 0,\
                    y_3d = 0,\
                    z_3d = 0):
            
                self.instance_id = instance_id
                self.config_type = config_type
                self.host_object_id = host_object_id
                self.alias = alias
                self.display_name = display_name
                self.address = address
                self.address6 = address6
                self.check_command_object_id = check_command_object_id
                self.check_command_args = check_command_args
                self.eventhandler_command_object_id = eventhandler_command_object_id
                self.eventhandler_command_args = eventhandler_command_args
                self.notification_timeperiod_object_id = notification_timeperiod_object_id
                self.check_timeperiod_object_id = check_timeperiod_object_id
                self.failure_prediction_options = failure_prediction_options
                self.check_interval = check_interval
                self.retry_interval = retry_interval
                self.max_check_attempts = max_check_attempts
                self.first_notification_delay = first_notification_delay
                self.notification_interval = notification_interval
                self.notify_on_down = notify_on_down
                self.notify_on_unreachable = notify_on_unreachable
                self.notify_on_recovery = notify_on_recovery
                self.notify_on_flapping = notify_on_flapping
                self.notify_on_downtime = notify_on_downtime
                self.stalk_on_up = stalk_on_up
                self.stalk_on_down = stalk_on_down
                self.stalk_on_unreachable = stalk_on_unreachable
                self.flap_detection_enabled = flap_detection_enabled
                self.flap_detection_on_up = flap_detection_on_up
                self.flap_detection_on_down = flap_detection_on_down
                self.flap_detection_on_unreachable = flap_detection_on_unreachable
                self.low_flap_threshold = low_flap_threshold
                self.high_flap_threshold = high_flap_threshold
                self.process_performance_data = process_performance_data
                self.freshness_checks_enabled = freshness_checks_enabled
                self.freshness_threshold = freshness_threshold
                self.passive_checks_enabled = passive_checks_enabled
                self.event_handler_enabled = event_handler_enabled
                self.active_checks_enabled = active_checks_enabled
                self.retain_status_information = retain_status_information
                self.retain_nonstatus_information = retain_nonstatus_information
                self.notifications_enabled = notifications_enabled
                self.obsess_over_host = obsess_over_host
                self.failure_prediction_enabled = failure_prediction_enabled
                self.notes = notes
                self.notes_url = notes_url
                self.action_url = action_url
                self.icon_image = icon_image
                self.icon_image_alt = icon_image_alt
                self.vrml_image = vrml_image
                self.statusmap_image = statusmap_image
                self.have_2d_coords = have_2d_coords
                self.x_2d = x_2d
                self.y_2d = y_2d
                self.have_3d_coords = have_3d_coords
                self.x_3d = x_3d
                self.y_3d = y_3d
                self.z_3d = z_3d
                
                Index('host_object_id', IcingaHostchecks.host_object_id)
                Index('hosts_i_id_idx', IcingaHostchecks.instance_id)
                Index('hosts_host_object_id_idx', IcingaHostchecks.host_object_id)

        def __repr__(self):
            
                return "{'host_id':%d,\
                        'instance_id':%d,\
                        'config_type':%d,\
                        'host_object_id':%d,\
                        'alias':'%s',\
                        'display_name':'%s',\
                        'address':'%s',\
                        'address6':'%s',\
                        'check_command_object_id':%d,\
                        'check_command_args':'%s',\
                        'eventhandler_command_object_id':%d,\
                        'eventhandler_command_args':'%s',\
                        'notification_timeperiod_object_id':%d,\
                        'check_timeperiod_object_id':%d,\
                        'failure_prediction_options''%s',\
                        'check_interval':%d,\
                        'retry_interval':%d,\
                        'max_check_attempts':%d,\
                        'first_notification_delay':%d,\
                        'notification_interval':%d,\
                        'notify_on_down':%d,\
                        'notify_on_unreachable':%d,\
                        'notify_on_recovery':%d,\
                        'notify_on_flapping':%d,\
                        'notify_on_downtime':%d,\
                        'stalk_on_up':%d,\
                        'stalk_on_down':%d,\
                        'stalk_on_unreachable':%d,\
                        'flap_detection_enabled':%d,\
                        'flap_detection_on_up':%d,\
                        'flap_detection_on_down':%d,\
                        'flap_detection_on_unreachable':%d,\
                        'low_flap_threshold':%d,\
                        'high_flap_threshold':%d,\
                        'process_performance_data':%d,\
                        'freshness_checks_enabled':%d,\
                        'freshness_threshold':%d,\
                        'passive_checks_enabled':%d,\
                        'event_handler_enabled':%d,\
                        'active_checks_enabled':%d,\
                        'retain_status_information':%d,\
                        'retain_nonstatus_information':%d,\
                        'notifications_enabled':%d,\
                        'obsess_over_host':%d,\
                        'failure_prediction_enabled':%d,\
                        'notes':'%s',\
                        'notes_url':'%s',\
                        'action_url':'%s',\
                        'icon_image':'%s',\
                        'icon_image_alt':'%s',\
                        'vrml_image':'%s',\
                        'statusmap_image':'%s',\
                        'have_2d_coords':%d,\
                        'x_2d':%d,\
                        'y_2d':%d,\
                        'have_3d_coords':%d,\
                        'x_3d':%d,\
                        'y_3d':%d,\
                        'z_3d':%d}" % (self.host_id,\
                        self.instance_id,\
                        self.config_type,\
                        self.host_object_id,\
                        self.alias,\
                        self.display_name,\
                        self.address,\
                        self.address6,\
                        self.check_command_object_id,\
                        self.check_command_args,\
                        self.eventhandler_command_object_id,\
                        self.eventhandler_command_args,\
                        self.notification_timeperiod_object_id,\
                        self.check_timeperiod_object_id,\
                        self.failure_prediction_options,\
                        self.check_interval,\
                        self.retry_interval,\
                        self.max_check_attempts,\
                        self.first_notification_delay,\
                        self.notification_interval,\
                        self.notify_on_down,\
                        self.notify_on_unreachable,\
                        self.notify_on_recovery,\
                        self.notify_on_flapping,\
                        self.notify_on_downtime,\
                        self.stalk_on_up,\
                        self.stalk_on_down,\
                        self.stalk_on_unreachable,\
                        self.flap_detection_enabled,\
                        self.flap_detection_on_up,\
                        self.flap_detection_on_down,\
                        self.flap_detection_on_unreachable,\
                        self.low_flap_threshold,\
                        self.high_flap_threshold,\
                        self.process_performance_data,\
                        self.freshness_checks_enabled,\
                        self.freshness_threshold,\
                        self.passive_checks_enabled,\
                        self.event_handler_enabled,\
                        self.active_checks_enabled,\
                        self.retain_status_information,\
                        self.retain_nonstatus_information,\
                        self.notifications_enabled,\
                        self.obsess_over_host,\
                        self.failure_prediction_enabled,\
                        self.notes,\
                        self.notes_url,\
                        self.action_url,\
                        self.icon_image,\
                        self.icon_image_alt,\
                        self.vrml_image,\
                        self.statusmap_image,\
                        self.have_2d_coords,\
                        self.x_2d,\
                        self.y_2d,\
                        self.have_3d_coords,\
                        self.x_3d,\
                        self.y_3d,\
                        self.z_3d)

class IcingaHostchecks(base):
        __tablename__ = 'icinga_hostchecks'
        __table_args__= (UniqueConstraint('hostcheck_id', name='hostcheck_id'),)

        hostcheck_id = Column(BIGINT(20), primary_key=True, autoincrement=True)
        instance_id  = Column(BIGINT(20), default=0)
        host_object_id = Column(BIGINT(20), unique = True, default=0)
        check_type = Column(SMALLINT(6), default=0)
        is_raw_check = Column(SMALLINT(6), default=0)
        current_check_attempt = Column(SMALLINT(6), default=0)
        max_check_attempts = Column(SMALLINT(6), default=0)
        state = Column(SMALLINT(6), default=0)
        state_type = Column(SMALLINT(6), default=0)
        start_time =  Column(DATETIME, default='0000-00-00 00:00:00')
        start_time_usec = Column(INTEGER(11), default=0)
        end_time =  Column(DATETIME, default='0000-00-00 00:00:00')
        end_time_usec = Column(INTEGER(11), default=0)
        command_object_id = Column(BIGINT(20), default=0) 
        command_args = Column(VARCHAR(255), default='')
        command_line = Column(VARCHAR(1024), default='') 
        timeout = Column(SMALLINT(6), default=0)
        early_timeout = Column(SMALLINT(6), default=0) 
        execution_time = Column(DOUBLE, default=0)
        latency = Column(DOUBLE, default=0)
        return_code = Column(SMALLINT(6), default=0) 
        output = Column(VARCHAR(255), default='')
        long_output = Column(TEXT)
        perfdata = Column(TEXT)
        
        def __init__(self, instance_id=0, host_object_id=0, check_type=0, \
                     is_raw_check=0, current_check_attempt=0, max_check_attempts=0, \
                     state=0, state_type=0, start_time='0000-00-00 00:00:00', \
                     start_time_usec=0, end_time='0000-00-00 00:00:00',\
                     end_time_usec=0, command_object_id=0, command_args='', \
                     command_line='', timeout=0, early_timeout=0, execution_time=0, \
                     latency=0, return_code=0, output='', long_output='', perfdata=''):
            
                self.instance_id = instance_id
                self.host_object_id = host_object_id
                self.check_type = check_type
                self.current_check_attempt = current_check_attempt
                self.max_check_attempts = max_check_attempts
                self.state = state
                self.state_type = state_type
                self.start_time = start_time
                self.start_time_usec = start_time_usec
                self.end_time = end_time
                self.end_time_usec = end_time_usec
                self.command_object_id = command_object_id
                self.command_args = command_args
                self.command_line = command_line
                self.timeout = timeout
                self.early_timeout = early_timeout
                self.execution_time = execution_time
                self.latency = latency
                self.return_code = return_code
                self.output = output
                self.long_output = long_output
                self.perfdata = perfdata
                        
                Index('hostchecks_i_id_idx', IcingaHostchecks.instance_id)
                Index('hostchecks_time_id_idx', IcingaHostchecks.start_time)
                Index('hostchks_h_obj_id_idx', IcingaHostchecks.host_object_id)
            
        def __repr__(self):
            
                return "{'hostcheck_id':%d, 'instance_id':%d, 'host_object_id':%d, 'check_type':%d, \
                        'is_raw_check':%d, 'current_check_attempt':%d, 'max_check_attempts':%d, \
                        'state':%d, 'state_type':%d, 'start_time':'%s', 'start_time_usec':'%s', \
                        'end_time':'%s', 'end_time_usec':'%s', \
                        'command_object_id':%d, 'command_args':'%s', 'command_line':'%s', \
                        'timeout':%d, 'early_timeout':%d, 'execution_time':%d, 'latency':%d, \
                        'return_code':%d, 'output':'%s', \
                        'long_output':'%s', 'perfdata':'%s'}" \
                        % (self.hostcheck_id, self.instance_id, self.host_object_id, self.check_type,\
                        self.is_raw_check, self.current_check_attempt, self.max_check_attempts, \
                        self.state, self.state_type, self.start_time, self.start_time_usec, self.end_time, self.end_time_usec, \
                        self.command_object_id, self.command_args, self.command_line, self.timeout, self.early_timeout, \
                        self.execution_time, self.latency, self.return_code, self.output, self.long_output, self.perfdata)


class IcingaHoststatus(base):
        __tablename__ = 'icinga_hoststatus'

        hoststatus_id = Column(BIGINT(20), primary_key=True, autoincrement=True)
        instance_id  = Column(BIGINT(20), default=0)
        host_object_id = Column(BIGINT(20), unique = True, default=0)
        status_update_time = Column(DATETIME, default='0000-00-00 00:00:00')
        output  = Column(String(255), default='')
        long_output = Column(TEXT, default='')
        perfdata = Column(TEXT, default='')
        current_state = Column(SMALLINT, default=0)
        has_been_checked = Column(SMALLINT, default=0)
        should_be_scheduled = Column(SMALLINT, default=0)
        current_check_attempt = Column(SMALLINT, default=0)
        max_check_attempts = Column(SMALLINT, default=0)
        last_check = Column(DATETIME, default='0000-00-00 00:00:00')
        next_check = Column(DATETIME, default='0000-00-00 00:00:00')
        check_type = Column(SMALLINT, default=0)
        last_state_change = Column(DATETIME, default='0000-00-00 00:00:00')
        last_hard_state_change = Column(DATETIME, default='0000-00-00 00:00:00')
        last_hard_state = Column(SMALLINT, default=0)
        last_time_up = Column(DATETIME, default='0000-00-00 00:00:00')
        last_time_down = Column(DATETIME, default='0000-00-00 00:00:00')
        last_time_unreachable = Column(DATETIME, default='0000-00-00 00:00:00')
        state_type = Column(SMALLINT, default=0)
        last_notification = Column(DATETIME, default='0000-00-00 00:00:00')
        next_notification = Column(DATETIME, default='0000-00-00 00:00:00')
        no_more_notifications = Column(SMALLINT, default=0)
        notifications_enabled = Column(SMALLINT, default=0)
        problem_has_been_acknowledged = Column(SMALLINT, default=0)
        acknowledgement_type = Column(SMALLINT, default=0)
        current_notification_number = Column(SMALLINT, default=0)
        passive_checks_enabled = Column(SMALLINT, default=0)
        active_checks_enabled = Column(SMALLINT, default=0)
        event_handler_enabled = Column(SMALLINT, default=0)
        flap_detection_enabled = Column(SMALLINT, default=0)
        is_flapping = Column(SMALLINT, default=0)
        percent_state_change = Column(DOUBLE, default=0)
        latency = Column(DOUBLE, default=0)
        execution_time = Column(DOUBLE, default=0)
        scheduled_downtime_depth = Column(SMALLINT, default=0)
        failure_prediction_enabled = Column(SMALLINT, default=0)
        process_performance_data = Column(SMALLINT, default=0)
        obsess_over_host = Column(SMALLINT, default=0)
        modified_host_attributes = Column(INTEGER, default=0)
        event_handler = Column(String(255), default='')
        check_command = Column(String(255), default='')
        normal_check_interval = Column(DOUBLE, default=0)
        retry_check_interval = Column(DOUBLE, default=0)
        check_timeperiod_object_id = Column(BIGINT, default=0)
     
        def __init__(self, instance_id=0, host_object_id=0, status_update_time='0000-00-00 00:00:00', output='', \
                     long_output='', perfdata='', current_state=0, has_been_checked=0, \
                     should_be_scheduled=0, current_check_attempt=0, max_check_attempts=0, \
                     last_check='0000-00-00 00:00:00', next_check='0000-00-00 00:00:00', check_type=0, \
                     last_state_change='0000-00-00 00:00:00', last_hard_state_change='0000-00-00 00:00:00', last_hard_state=0, last_time_up='0000-00-00 00:00:00', \
                     last_time_down='0000-00-00 00:00:00', last_time_unreachable='0000-00-00 00:00:00', state_type=0, \
                     last_notification='0000-00-00 00:00:00', next_notification='0000-00-00 00:00:00', no_more_notifications=0, notifications_enabled=0, problem_has_been_acknowledged=0, \
                     acknowledgement_type=0, current_notification_number=0, passive_checks_enabled=0, active_checks_enabled=0, event_handler_enabled=0, \
                     flap_detection_enabled=0, is_flapping=0, percent_state_change=0, latency=0, execution_time=0, scheduled_downtime_depth=0, failure_prediction_enabled=0, \
                     process_performance_data=0, obsess_over_host=0, modified_host_attributes=0, event_handler='', check_command='', \
                     normal_check_interval=0, retry_check_interval=0, check_timeperiod_object_id=0 ):
            
                self.instance_id = instance_id
                self.host_object_id =  host_object_id
                self.status_update_time = status_update_time
                self.output = output
                self.long_output = long_output
                self.perfdata = perfdata
                self.current_state =  current_state
                self.has_been_checked =  has_been_checked
                self.should_be_scheduled = should_be_scheduled 
                self.current_check_attempt =  current_check_attempt
                self.max_check_attempts = max_check_attempts
                self.last_check = last_check
                self.next_check = next_check
                self.check_type = check_type
                self.last_state_change = last_state_change
                self.last_hard_state_change =  last_hard_state_change
                self.last_hard_state = last_hard_state
                self.last_time_up = last_time_up
                self.last_time_down = last_time_down
                self.last_time_unreachable = last_time_unreachable
                self.state_type = state_type
                self.last_notification = last_notification
                self.next_notification = next_notification
                self.no_more_notifications = no_more_notifications
                self.notifications_enabled = notifications_enabled
                self.problem_has_been_acknowledged = problem_has_been_acknowledged
                self.acknowledgement_type = acknowledgement_type
                self.current_notification_number = current_notification_number
                self.passive_checks_enabled = passive_checks_enabled
                self.active_checks_enabled = active_checks_enabled
                self.event_handler_enabled = event_handler_enabled
                self.flap_detection_enabled = flap_detection_enabled
                self.is_flapping = is_flapping
                self.percent_state_change = percent_state_change
                self.latency = latency
                self.execution_time = execution_time
                self.scheduled_downtime_depth = scheduled_downtime_depth
                self.failure_prediction_enabled = failure_prediction_enabled
                self.process_performance_data = process_performance_data
                self.obsess_over_host = obsess_over_host
                self.modified_host_attributes = modified_host_attributes
                self.event_handler = event_handler
                self.check_command = check_command
                self.normal_check_interval = normal_check_interval
                self.retry_check_interval = retry_check_interval
                self.check_timeperiod_object_id = check_timeperiod_object_id
                
        def __repr__(self):
                return "{'hoststatus_id':%d, 'instance_id':%d, 'host_object_id':%d, 'status_update_time':'%s', 'output':'%s', 'long_output':'%s', \
                        'perfdata':'%s', 'current_state':%d, 'has_been_checked':%d, \
                        'should_be_scheduled':'%s', 'current_check_attempt':'%s',\
                        'max_check_attempts':'%s', \
                        'last_check':'%s', 'next_check':'%s', 'check_type':'%s', 'last_state_change':'%s', \
                        'last_hard_state_change':'%s', 'last_hard_state':'%s', \
                        'last_time_up':'%s', 'last_time_down':'%s', 'last_time_unreachable':'%s', \
                        'state_type':'%s', 'last_notification':'%s', 'next_notification':'%s', 'no_more_notifications':'%s', \
                        'notifications_enabled':'%s', 'problem_has_been_acknowledged':'%s', \
                        'acknowledgement_type':'%s', 'current_notification_number':'%s', 'passive_checks_enabled':'%s', \
                        'active_checks_enabled':'%s', 'event_handler_enabled':'%s', 'flap_detection_enabled':'%s', \
                        'is_flapping':'%s', 'percent_state_change':'%s', 'latency':'%s', 'execution_time':'%s', \
                        'scheduled_downtime_depth':'%s', 'failure_prediction_enabled':'%s', 'process_performance_data':'%s', \
                        'obsess_over_host':'%s', 'modified_host_attributes':'%s', 'event_handler':'%s', \
                        'check_command':'%s', 'normal_check_interval':'%s', 'retry_check_interval':'%s', 'check_timeperiod_object_id':'%s'}" \
                        % (self.hoststatus_id, self.instance_id, self.host_object_id, self.status_update_time,\
                        self.output, self.long_output, self.perfdata, self.current_state, self.has_been_checked, \
                        self.should_be_scheduled, self.current_check_attempt, self.max_check_attempts, self.last_check, \
                        self.next_check, self.check_type, self.last_state_change, self.last_hard_state_change, self.last_hard_state, \
                        self.last_time_up, self.last_time_down, self.last_time_unreachable, \
                        self.state_type, self.last_notification, self.next_notification, self.no_more_notifications, \
                        self.notifications_enabled, self.problem_has_been_acknowledged, \
                        self.acknowledgement_type, self.current_notification_number, \
                        self.passive_checks_enabled, self.active_checks_enabled, self.event_handler_enabled,\
                        self.flap_detection_enabled, self.is_flapping, self.percent_state_change, self.latency, self.execution_time, \
                        self.scheduled_downtime_depth, self.failure_prediction_enabled, self.process_performance_data,\
                        self.obsess_over_host, self.modified_host_attributes, self.event_handler, self.check_command, self.normal_check_interval, \
                        self.retry_check_interval, self.check_timeperiod_object_id)
                        
class IcingaServices(base):
    
        __tablename__ = 'icinga_services'
#        __table_args__= (UniqueConstraint('service_id', name='service_id'), \
#                         UniqueConstraint('instance_id', 'config_type', 'service_object_id',  name='instance_id'))
        
        service_id = Column('service_id', BigInteger(), primary_key=True, nullable=False, autoincrement=True)
        action_url = Column('action_url', VARCHAR(length=255))
        active_checks_enabled = Column('active_checks_enabled', SMALLINT())
        check_command_args = Column('check_command_args', VARCHAR(length=255))
        check_command_object_id = Column('check_command_object_id', BigInteger())
        check_interval = Column('check_interval', Float(asdecimal=True))
        check_timeperiod_object_id = Column('check_timeperiod_object_id', BigInteger())
        config_type = Column('config_type', SMALLINT())
        display_name = Column('display_name', VARCHAR(length=255))
        event_handler_enabled = Column('event_handler_enabled', SMALLINT())
        eventhandler_command_args = Column('eventhandler_command_args', VARCHAR(length=255))
        eventhandler_command_object_id = Column('eventhandler_command_object_id', BigInteger())
        failure_prediction_enabled = Column('failure_prediction_enabled', SMALLINT())
        failure_prediction_options = Column('failure_prediction_options', VARCHAR(length=64))
        first_notification_delay = Column('first_notification_delay', Float(asdecimal=True))
        flap_detection_enabled = Column('flap_detection_enabled', SMALLINT())
        flap_detection_on_critical = Column('flap_detection_on_critical', SMALLINT())
        flap_detection_on_ok = Column('flap_detection_on_ok', SMALLINT())
        flap_detection_on_unknown = Column('flap_detection_on_unknown', SMALLINT())
        flap_detection_on_warning = Column('flap_detection_on_warning', SMALLINT())
        freshness_checks_enabled = Column('freshness_checks_enabled', SMALLINT())
        freshness_threshold = Column('freshness_threshold', SMALLINT())
        high_flap_threshold = Column('high_flap_threshold', Float(asdecimal=True))
        host_object_id = Column('host_object_id', BigInteger())
        icon_image = Column('icon_image', VARCHAR(length=255))
        icon_image_alt = Column('icon_image_alt', VARCHAR(length=255))
        instance_id = Column('instance_id', BigInteger())
        is_volatile = Column('is_volatile', SMALLINT())
        low_flap_threshold = Column('low_flap_threshold', Float(asdecimal=True))
        max_check_attempts = Column('max_check_attempts', SMALLINT())
        notes = Column('notes', VARCHAR(length=255))
        notes_url = Column('notes_url', VARCHAR(length=255))
        notification_interval = Column('notification_interval', Float(asdecimal=True))
        notification_timeperiod_object_id = Column('notification_timeperiod_object_id', BigInteger())
        notifications_enabled = Column('notifications_enabled', SMALLINT())
        notify_on_critical = Column('notify_on_critical', SMALLINT())
        notify_on_downtime = Column('notify_on_downtime', SMALLINT())
        notify_on_flapping = Column('notify_on_flapping', SMALLINT())
        notify_on_recovery = Column('notify_on_recovery', SMALLINT())
        notify_on_unknown = Column('notify_on_unknown', SMALLINT())
        notify_on_warning = Column('notify_on_warning', SMALLINT())
        obsess_over_service = Column('obsess_over_service', SMALLINT())
        passive_checks_enabled = Column('passive_checks_enabled', SMALLINT())
        process_performance_data = Column('process_performance_data', SMALLINT())
        retain_nonstatus_information = Column('retain_nonstatus_information', SMALLINT())
        retain_status_information = Column('retain_status_information', SMALLINT())
        retry_interval = Column('retry_interval', Float(asdecimal=True))
        service_object_id = Column('service_object_id', BigInteger())
        stalk_on_critical = Column('stalk_on_critical', SMALLINT())
        stalk_on_ok = Column('stalk_on_ok', SMALLINT())
        stalk_on_unknown = Column('stalk_on_unknown', SMALLINT())
        stalk_on_warning = Column('stalk_on_warning', SMALLINT())
        
        def __init( self, \
                    service_id=0,\
                    instance_id=0,\
                    config_type=0,\
                    host_object_id=0,\
                    service_object_id=0,\
                    display_name='',\
                    check_command_object_id=0,\
                    check_command_args='',\
                    eventhandler_command_object_id=0,\
                    eventhandler_command_args='',\
                    notification_timeperiod_object_id=0,\
                    check_timeperiod_object_id=0,\
                    failure_prediction_options='',\
                    check_interval=0,\
                    retry_interval=0,\
                    max_check_attempts=0,\
                    first_notification_delay=0,\
                    notification_interval=0,\
                    notify_on_warning=0,\
                    notify_on_unknown=0,\
                    notify_on_critical=0,\
                    notify_on_recovery=0,\
                    notify_on_flapping=0,\
                    notify_on_downtime=0,\
                    stalk_on_ok=0,\
                    stalk_on_warning=0,\
                    stalk_on_unknown=0,\
                    stalk_on_critical=0,\
                    is_volatile=0,\
                    flap_detection_enabled=0,\
                    flap_detection_on_ok=0,\
                    flap_detection_on_warning=0,\
                    flap_detection_on_unknown=0,\
                    flap_detection_on_critical=0,\
                    low_flap_threshold=0,\
                    high_flap_threshold=0,\
                    process_performance_data=0,\
                    freshness_checks_enabled=0,\
                    freshness_threshold=0,\
                    passive_checks_enabled=0,\
                    event_handler_enabled=0,\
                    active_checks_enabled=0,\
                    retain_status_information=0,\
                    retain_nonstatus_information=0,\
                    notifications_enabled=0,\
                    obsess_over_service=0,\
                    failure_prediction_enabled=0,\
                    notes='',\
                    notes_url='',\
                    action_url='',\
                    icon_image='',\
                    icon_image_alt=''):
            
                self.service_id = service_id
                self.instance_id = instance_id
                self.config_type = config_type
                self.host_object_id = host_object_id
                self.service_object_id = service_object_id
                self.display_name = display_name
                self.check_command_object_id = check_command_object_id
                self.check_command_args = check_command_args
                self.eventhandler_command_object_id = eventhandler_command_object_id
                self.eventhandler_command_args = eventhandler_command_args
                self.notification_timeperiod_object_id = notification_timeperiod_object_id
                self.check_timeperiod_object_id = check_timeperiod_object_id
                self.failure_prediction_options = failure_prediction_options
                self.check_interval = check_interval
                self.retry_interval = retry_interval
                self.max_check_attempts = max_check_attempts
                self.first_notification_delay = first_notification_delay
                self.notification_interval = notification_interval
                self.notify_on_warning = notify_on_warning
                self.notify_on_unknown = notify_on_unknown
                self.notify_on_critical = notify_on_critical
                self.notify_on_recovery = notify_on_recovery
                self.notify_on_flapping = notify_on_flapping
                self.notify_on_downtime = notify_on_downtime
                self.stalk_on_ok = stalk_on_ok
                self.stalk_on_warning = stalk_on_warning
                self.stalk_on_unknown = stalk_on_unknown
                self.stalk_on_critical = stalk_on_critical
                self.is_volatile = is_volatile
                self.flap_detection_enabled = flap_detection_enabled
                self.flap_detection_on_ok = flap_detection_on_ok
                self.flap_detection_on_warning = flap_detection_on_warning
                self.flap_detection_on_unknown = flap_detection_on_unknown
                self.flap_detection_on_critical = flap_detection_on_critical
                self.low_flap_threshold = low_flap_threshold
                self.high_flap_threshold = high_flap_threshold
                self.process_performance_data = process_performance_data
                self.freshness_checks_enabled = freshness_checks_enabled
                self.freshness_threshold = freshness_threshold
                self.passive_checks_enabled = passive_checks_enabled
                self.event_handler_enabled = event_handler_enabled
                self.active_checks_enabled = active_checks_enabled
                self.retain_status_information = retain_status_information
                self.retain_nonstatus_information = retain_nonstatus_information
                self.notifications_enabled = notifications_enabled
                self.obsess_over_service = obsess_over_service
                self.failure_prediction_enabled = failure_prediction_enabled
                self.notes = notes
                self.notes_url = notes_url
                self.action_url = action_url
                self.icon_image = icon_image
                self.icon_image_alt = icon_image_alt
  
                Index(u'service_id', IcingaServices.service_id, unique=True)
                Index(u'instance_id', IcingaServices.instance_id, IcingaServices.config_type, IcingaServices.service_object_id, unique=True)
                Index(u'services_host_object_id_idx', IcingaServices.host_object_id, unique=False)
                Index(u'service_object_id', IcingaServices.service_object_id, unique=False)
                Index(u'services_i_id_idx', IcingaServices.instance_id, unique=False)
                
        def __repr__(self):
                return "{'service_id':%d,\
                        'instance_id':%d,\
                        'config_type':%d,\
                        'host_object_id':%d,\
                        'service_object_id':%d,\
                        'display_name':%d,\
                        'check_command_object_id':%d,\
                        'check_command_args':'%s',\
                        'eventhandler_command_object_id':%d,\
                        'eventhandler_command_args':'%s',\
                        'notification_timeperiod_object_id':%d,\
                        'check_timeperiod_object_id':%d,\
                        'failure_prediction_options':'%s',\
                        'check_interval':%d,\
                        'retry_interval':%d,\
                        'max_check_attempts':%d,\
                        'first_notification_delay':%d,\
                        'notification_interval':%d,\
                        'notify_on_warning':%d,\
                        'notify_on_unknown':%d,\
                        'notify_on_critical':%d,\
                        'notify_on_recovery':%d,\
                        'notify_on_flapping':%d,\
                        'notify_on_downtime':%d,\
                        'stalk_on_ok':%d,\
                        'stalk_on_warning':%d,\
                        'stalk_on_unknown':%d,\
                        'stalk_on_critical':%d,\
                        'is_volatile':%d,\
                        'flap_detection_enabled':%d,\
                        'flap_detection_on_ok':%d,\
                        'flap_detection_on_warning':%d,\
                        'flap_detection_on_unknown':%d,\
                        'flap_detection_on_critical':%d,\
                        'low_flap_threshold':%d,\
                        'high_flap_threshold':%d,\
                        'process_performance_data':%d,\
                        'freshness_checks_enabled':%d,\
                        'freshness_threshold':%d,\
                        'passive_checks_enabled':%d,\
                        'event_handler_enabled':%d,\
                        'active_checks_enabled':%d,\
                        'retain_status_information':%d,\
                        'retain_nonstatus_information':%d,\
                        'notifications_enabled':%d,\
                        'obsess_over_service':%d,\
                        'failure_prediction_enabled':%d,\
                        'notes':%d,\
                        'notes_url':%d,\
                        'action_url':%d,\
                        'icon_image':%d,\
                        'icon_image_alt':%d}" %  \
                        (self.service_id,\
                        self.instance_id,\
                        self.config_type,\
                        self.host_object_id,\
                        self.service_object_id,\
                        self.display_name,\
                        self.check_command_object_id,\
                        self.check_command_args,\
                        self.eventhandler_command_object_id,\
                        self.eventhandler_command_args,\
                        self.notification_timeperiod_object_id,\
                        self.check_timeperiod_object_id,\
                        self.failure_prediction_options,\
                        self.check_interval,\
                        self.retry_interval,\
                        self.max_check_attempts,\
                        self.first_notification_delay,\
                        self.notification_interval,\
                        self.notify_on_warning,\
                        self.notify_on_unknown,\
                        self.notify_on_critical,\
                        self.notify_on_recovery,\
                        self.notify_on_flapping,\
                        self.notify_on_downtime,\
                        self.stalk_on_ok,\
                        self.stalk_on_warning,\
                        self.stalk_on_unknown,\
                        self.stalk_on_critical,\
                        self.is_volatile,\
                        self.flap_detection_enabled,\
                        self.flap_detection_on_ok,\
                        self.flap_detection_on_warning,\
                        self.flap_detection_on_unknown,\
                        self.flap_detection_on_critical,\
                        self.low_flap_threshold,\
                        self.high_flap_threshold,\
                        self.process_performance_data,\
                        self.freshness_checks_enabled,\
                        self.freshness_threshold,\
                        self.passive_checks_enabled,\
                        self.event_handler_enabled,\
                        self.active_checks_enabled,\
                        self.retain_status_information,\
                        self.retain_nonstatus_information,\
                        self.notifications_enabled,\
                        self.obsess_over_service,\
                        self.failure_prediction_enabled,\
                        self.notes,\
                        self.notes_url,\
                        self.action_url,\
                        self.icon_image,\
                        self.icon_image_alt)
                       
        
        
class IcingaServicechecks(base):
    
        __tablename__ = 'icinga_servicechecks'
    
        __table_args__ = {'schema': 'icinga'}
    
        #column definitions
        servicecheck_id = Column('servicecheck_id', BigInteger(), primary_key=True, nullable=False, autoincrement=True)
        check_type = Column('check_type', SMALLINT())
        command_args = Column('command_args', VARCHAR(length=255))
        command_line = Column('command_line', VARCHAR(length=1024))
        command_object_id = Column('command_object_id', BigInteger())
        current_check_attempt = Column('current_check_attempt', SMALLINT())
        early_timeout = Column('early_timeout', SMALLINT())
        end_time = Column('end_time', DATETIME())
        end_time_usec = Column('end_time_usec', INTEGER())
        execution_time = Column('execution_time', Float(asdecimal=True))
        instance_id = Column('instance_id', BigInteger())
        latency = Column('latency', Float(asdecimal=True))
        long_output = Column('long_output', TEXT())
        max_check_attempts = Column('max_check_attempts', SMALLINT())
        output = Column('output', VARCHAR(length=255))
        perfdata = Column('perfdata', TEXT())
        return_code = Column('return_code', SMALLINT())
        service_object_id = Column('service_object_id', BigInteger())
        start_time = Column('start_time', DATETIME())
        start_time_usec = Column('start_time_usec', INTEGER())
        state = Column('state', SMALLINT())
        state_type = Column('state_type', SMALLINT())
        timeout = Column('timeout', SMALLINT())
        
        def __init__(self, \
                    servicecheck_id = 0,\
                    instance_id = 0,\
                    service_object_id = 0,\
                    check_type = 0,\
                    current_check_attempt = 0,\
                    max_check_attempts = 0,\
                    state = 0,\
                    state_type = 0,\
                    start_time = '0000-00-00 00:00:00',\
                    start_time_usec = 0,\
                    end_time = '0000-00-00 00:00:00',\
                    end_time_usec = 0,\
                    command_object_id = 0,\
                    command_args = '',\
                    command_line = '',\
                    timeout = 0,\
                    early_timeout = 0,\
                    execution_time = 0,\
                    latency = 0,\
                    return_code = 0,\
                    output = '',\
                    long_output = '',\
                    perfdata = ''):
            
                self.servicecheck_id = servicecheck_id
                self.instance_id = instance_id
                self.service_object_id = service_object_id
                self.check_type = check_type
                self.current_check_attempt = current_check_attempt
                self.max_check_attempts = max_check_attempts
                self.state = state
                self.state_type = state_type
                self.start_time = start_time
                self.start_time_usec = start_time_usec
                self.end_time = end_time
                self.end_time_usec = end_time_usec
                self.command_object_id = command_object_id
                self.command_args = command_args
                self.command_line = command_line
                self.timeout = timeout
                self.early_timeout = early_timeout
                self.execution_time = execution_time
                self.latency = latency
                self.return_code = return_code
                self.output = output
                self.long_output = long_output
                self.perfdata = perfdata
            
                Index(u'servicecheck_id', IcingaServicechecks.servicecheck_id, unique=True)
                Index(u'servicechecks_i_id_idx', IcingaServicechecks.instance_id, unique=False)
                Index(u'servicechecks_time_id_idx', IcingaServicechecks.start_time, unique=False)
                Index(u'servicechks_s_obj_id_idx', IcingaServicechecks.service_object_id, unique=False)
                
        def __repr__(self):
            
                return "{'servicecheck_id':%d,\
                        'instance_id':%d,\
                        'service_object_id':%d,\
                        'check_type':%d,\
                        'current_check_attempt':%d,\
                        'max_check_attempts':%d,\
                        'state':%d,\
                        'state_type':%d,\
                        'start_time':'%s',\
                        'start_time_usec':%d,\
                        'end_time':'%s',\
                        'end_time_usec':%d,\
                        'command_object_id':%d,\
                        'command_args':'%s',\
                        'command_line':'%s',\
                        'timeout':%d,\
                        'early_timeout':%d,\
                        'execution_time':%f,\
                        'latency':%f,\
                        'return_code':%d,\
                        'output':'%s',\
                        'long_output':'%s',\
                        'perfdata':'%s'}" % (self.servicecheck_id,\
                        self.instance_id,\
                        self.service_object_id,\
                        self.check_type,\
                        self.current_check_attempt,\
                        self.max_check_attempts,\
                        self.state,\
                        self.state_type,\
                        self.start_time,\
                        self.start_time_usec,\
                        self.end_time,\
                        self.end_time_usec,\
                        self.command_object_id,\
                        self.command_args,\
                        self.command_line,\
                        self.timeout,\
                        self.early_timeout,\
                        self.execution_time,\
                        self.latency,\
                        self.return_code,\
                        self.output,\
                        self.long_output,\
                        self.perfdata)



class IcingaServicestatus(base):
        __tablename__ = 'icinga_servicestatus'
    
        #column definitions
        servicestatus_id = Column('servicestatus_id', BigInteger(), primary_key=True, nullable=False)
        acknowledgement_type = Column('acknowledgement_type', SMALLINT())
        active_checks_enabled = Column('active_checks_enabled', SMALLINT())
        check_command = Column('check_command', VARCHAR(length=255))
        check_timeperiod_object_id = Column('check_timeperiod_object_id', BigInteger())
        check_type = Column('check_type', SMALLINT())
        current_check_attempt = Column('current_check_attempt', SMALLINT())
        current_notification_number = Column('current_notification_number', SMALLINT())
        current_state = Column('current_state', SMALLINT())
        event_handler = Column('event_handler', VARCHAR(length=255))
        event_handler_enabled = Column('event_handler_enabled', SMALLINT())
        execution_time = Column('execution_time', Float(asdecimal=True))
        failure_prediction_enabled = Column('failure_prediction_enabled', SMALLINT())
        flap_detection_enabled = Column('flap_detection_enabled', SMALLINT())
        has_been_checked = Column('has_been_checked', SMALLINT())
        instance_id = Column('instance_id', BigInteger())
        is_flapping = Column('is_flapping', SMALLINT())
        last_check = Column('last_check', DATETIME())
        last_hard_state = Column('last_hard_state', SMALLINT())
        last_hard_state_change = Column('last_hard_state_change', DATETIME())
        last_notification = Column('last_notification', DATETIME())
        last_state_change = Column('last_state_change', DATETIME())
        last_time_critical = Column('last_time_critical', DATETIME())
        last_time_ok = Column('last_time_ok', DATETIME())
        last_time_unknown = Column('last_time_unknown', DATETIME())
        last_time_warning = Column('last_time_warning', DATETIME())
        latency = Column('latency', Float(asdecimal=True))
        long_output = Column('long_output', TEXT())
        max_check_attempts = Column('max_check_attempts', SMALLINT())
        modified_service_attributes = Column('modified_service_attributes', INTEGER())
        next_check = Column('next_check', DATETIME())
        next_notification = Column('next_notification', DATETIME())
        no_more_notifications = Column('no_more_notifications', SMALLINT())
        normal_check_interval = Column('normal_check_interval', Float(asdecimal=True))
        notifications_enabled = Column('notifications_enabled', SMALLINT())
        obsess_over_service = Column('obsess_over_service', SMALLINT())
        output = Column('output', VARCHAR(length=255))
        passive_checks_enabled = Column('passive_checks_enabled', SMALLINT())
        percent_state_change = Column('percent_state_change', Float(asdecimal=True))
        perfdata = Column('perfdata', TEXT())
        problem_has_been_acknowledged = Column('problem_has_been_acknowledged', SMALLINT())
        process_performance_data = Column('process_performance_data', SMALLINT())
        retry_check_interval = Column('retry_check_interval', Float(asdecimal=True))
        scheduled_downtime_depth = Column('scheduled_downtime_depth', SMALLINT())
        service_object_id = Column('service_object_id', BigInteger())
        should_be_scheduled = Column('should_be_scheduled', SMALLINT())
        state_type = Column('state_type', SMALLINT())
        status_update_time = Column('status_update_time', DATETIME())
        
        def __init_(self, \
                    servicestatus_id = 0,\
                    instance_id = 0,\
                    service_object_id = 0,\
                    status_update_time = '0000-00-00 00:00:00',\
                    output = '',\
                    long_output = '',\
                    perfdata = '',\
                    current_state = 0,\
                    has_been_checked = 0,\
                    should_be_scheduled = 0,\
                    current_check_attempt = 0,\
                    max_check_attempts = 0,\
                    last_check = '0000-00-00 00:00:00',\
                    next_check = '0000-00-00 00:00:00',\
                    check_type = 0,\
                    last_state_change = '0000-00-00 00:00:00',\
                    last_hard_state_change = '0000-00-00 00:00:00',\
                    last_hard_state = 0,\
                    last_time_ok = '0000-00-00 00:00:00',\
                    last_time_warning = '0000-00-00 00:00:00',\
                    last_time_unknown = '0000-00-00 00:00:00',\
                    last_time_critical = '0000-00-00 00:00:00',\
                    state_type = 0,\
                    last_notification = '0000-00-00 00:00:00',\
                    next_notification = '0000-00-00 00:00:00',\
                    no_more_notifications = 0,\
                    notifications_enabled = 0,\
                    problem_has_been_acknowledged = 0,\
                    acknowledgement_type = 0,\
                    current_notification_number = 0,\
                    passive_checks_enabled = 0,\
                    active_checks_enabled = 0,\
                    event_handler_enabled = 0,\
                    flap_detection_enabled = 0,\
                    is_flapping = 0,\
                    percent_state_change = 0,\
                    latency = 0,\
                    execution_time = 0,\
                    scheduled_downtime_depth = 0,\
                    failure_prediction_enabled = 0,\
                    process_performance_data = 0,\
                    obsess_over_service = 0,\
                    modified_service_attributes = 0,\
                    event_handler = '',\
                    check_command = '',\
                    normal_check_interval = 0,\
                    retry_check_interval = 0,\
                    check_timeperiod_object_id = 0):
                
                self.servicestatus_id = servicestatus_id
                self.instance_id = instance_id
                self.service_object_id = service_object_id
                self.status_update_time = status_update_time
                self.output = output
                self.long_output = long_output
                self.perfdata = perfdata
                self.current_state = current_state
                self.has_been_checked = has_been_checked
                self.should_be_scheduled = should_be_scheduled
                self.current_check_attempt = current_check_attempt
                self.max_check_attempts = max_check_attempts
                self.last_check = last_check
                self.next_check = next_check
                self.check_type = check_type
                self.last_state_change = last_state_change
                self.last_hard_state_change = last_hard_state_change
                self.last_hard_state = last_hard_state
                self.last_time_ok = last_time_ok
                self.last_time_warning = last_time_warning
                self.last_time_unknown = last_time_unknown
                self.last_time_critical = last_time_critical
                self.state_type = state_type
                self.last_notification = last_notification
                self.next_notification = next_notification
                self.no_more_notifications = no_more_notifications
                self.notifications_enabled = notifications_enabled
                self.problem_has_been_acknowledged = problem_has_been_acknowledged
                self.acknowledgement_type = acknowledgement_type
                self.current_notification_number = current_notification_number
                self.passive_checks_enabled = passive_checks_enabled
                self.active_checks_enabled = active_checks_enabled
                self.event_handler_enabled = event_handler_enabled
                self.flap_detection_enabled = flap_detection_enabled
                self.is_flapping = is_flapping
                self.percent_state_change = percent_state_change
                self.latency = latency
                self.execution_time = execution_time
                self.scheduled_downtime_depth = scheduled_downtime_depth
                self.failure_prediction_enabled = failure_prediction_enabled
                self.process_performance_data = process_performance_data
                self.obsess_over_service = obsess_over_service
                self.modified_service_attributes = modified_service_attributes
                self.event_handler = event_handler
                self.check_command = check_command
                self.normal_check_interval = normal_check_interval
                self.retry_check_interval = retry_check_interval
                self.check_timeperiod_object_id = check_timeperiod_object_id
                
                Index(u'srvcstatus_current_state_idx', IcingaServicestatus.current_state, unique=False)
                Index(u'object_id', IcingaServicestatus.service_object_id, unique=True)
                Index(u'srvcstatus_notif_enabled_idx', IcingaServicestatus.notifications_enabled, unique=False)
                Index(u'srvcstatus_p_state_chg_idx', IcingaServicestatus.percent_state_change, unique=False)
                Index(u'srvcstatus_is_flapping_idx', IcingaServicestatus.is_flapping, unique=False)
                Index(u'srvcstatus_act_chks_en_idx', IcingaServicestatus.active_checks_enabled, unique=False)
                Index(u'srvcstatus_pas_chks_en_idx', IcingaServicestatus.passive_checks_enabled, unique=False)
                Index(u'srvcstatus_check_type_idx', IcingaServicestatus.check_type, unique=False)
                Index(u'servicestatus_i_id_idx', IcingaServicestatus.instance_id, unique=False)
                Index(u'srvcstatus_sch_downt_d_idx', IcingaServicestatus.scheduled_downtime_depth, unique=False)
                Index(u'servicestatus_id', IcingaServicestatus.servicestatus_id, unique=True)
                Index(u'srvcstatus_event_hdl_en_idx', IcingaServicestatus.event_handler_enabled, unique=False)
                Index(u'srvcstatus_state_type_idx', IcingaServicestatus.state_type, unique=False)
                Index(u'srvcstatus_problem_ack_idx', IcingaServicestatus.problem_has_been_acknowledged, unique=False)
                Index(u'srvcstatus_stat_upd_time_idx', IcingaServicestatus.status_update_time, unique=False)
                Index(u'srvcstatus_ex_time_idx', IcingaServicestatus.execution_time, unique=False)
                Index(u'srvcstatus_latency_idx', IcingaServicestatus.latency, unique=False)
                Index(u'srvcstatus_flap_det_en_idx', IcingaServicestatus.flap_detection_enabled, unique=False)
                Index(u'srvcstatus_last_state_chg_idx', IcingaServicestatus.last_state_change, unique=False)
                
        def __repr__(self):
            
            return "{'servicestatus_id':%d,\
                    'instance_id':%d,\
                    'service_object_id':%d,\
                    'status_update_time':%d,\
                    'output':'%s',\
                    'long_output':'%s',\
                    'perfdata':'%s',\
                    'current_state':%d,\
                    'has_been_checked':%d,\
                    'should_be_scheduled':%d,\
                    'current_check_attempt':%d,\
                    'max_check_attempts':%d,\
                    'last_check':'%s',\
                    'next_check':'%s',\
                    'check_type':%d,\
                    'last_state_change':'%s',\
                    'last_hard_state_change':'%s',\
                    'last_hard_state':%d,\
                    'last_time_ok':'%s',\
                    'last_time_warning':'%s',\
                    'last_time_unknown':'%s',\
                    'last_time_critical':'%s',\
                    'state_type':%d,\
                    'last_notification':'%s',\
                    'next_notification':'%s',\
                    'no_more_notifications':%d,\
                    'notifications_enabled':%d,\
                    'problem_has_been_acknowledged':%d,\
                    'acknowledgement_type':%d,\
                    'current_notification_number':%d,\
                    'passive_checks_enabled':%d,\
                    'active_checks_enabled':%d,\
                    'event_handler_enabled':%d,\
                    'flap_detection_enabled':%d,\
                    'is_flapping':%d,\
                    'percent_state_change':%f,\
                    'latency':%f,\
                    'execution_time':%f,\
                    'scheduled_downtime_depth':%d,\
                    'failure_prediction_enabled':%d,\
                    'process_performance_data':%d,\
                    'obsess_over_service':%d,\
                    'modified_service_attributes':%d,\
                    'event_handler':'%s',\
                    'check_command':'%s',\
                    'normal_check_interval':%f,\
                    'retry_check_interval':%f,\
                    'check_timeperiod_object_id':%d }" % (
                    self.servicestatus_id,\
                    self.instance_id,\
                    self.service_object_id,\
                    self.status_update_time,\
                    self.output,\
                    self.long_output,\
                    self.perfdata,\
                    self.current_state,\
                    self.has_been_checked,\
                    self.should_be_scheduled,\
                    self.current_check_attempt,\
                    self.max_check_attempts,\
                    self.last_check,\
                    self.next_check,\
                    self.check_type,\
                    self.last_state_change,\
                    self.last_hard_state_change,\
                    self.last_hard_state,\
                    self.last_time_ok,\
                    self.last_time_warning,\
                    self.last_time_unknown,\
                    self.last_time_critical,\
                    self.state_type,\
                    self.last_notification,\
                    self.next_notification,\
                    self.no_more_notifications,\
                    self.notifications_enabled,\
                    self.problem_has_been_acknowledged,\
                    self.acknowledgement_type,\
                    self.current_notification_number,\
                    self.passive_checks_enabled,\
                    self.active_checks_enabled,\
                    self.event_handler_enabled,\
                    self.flap_detection_enabled,\
                    self.is_flapping,\
                    self.percent_state_change,\
                    self.latency,\
                    self.execution_time,\
                    self.scheduled_downtime_depth,\
                    self.failure_prediction_enabled,\
                    self.process_performance_data,\
                    self.obsess_over_service,\
                    self.modified_service_attributes,\
                    self.event_handler,\
                    self.check_command,\
                    self.normal_check_interval,\
                    self.retry_check_interval,\
                    self.check_timeperiod_object_id)




class IcingaHostgroups(base):
        __tablename__ = 'icinga_hostgroups'
    
        __table_args__ = {'schema': 'icinga'}
    
        #column definitions
        alias = Column('alias', VARCHAR(length=255))
        config_type = Column('config_type', SMALLINT())
        hostgroup_id = Column('hostgroup_id', BigInteger(), primary_key=True, nullable=False)
        hostgroup_object_id = Column('hostgroup_object_id', BigInteger())
        instance_id = Column('instance_id', BigInteger())
    
        #relation definitions
        
        def __init_(self,hostgroup_id = 0,\
                    instance_id = 0,\
                    config_type = 0,\
                    hostgroup_object_id = 0,\
                    alias = ''):
                
                self.hostgroup_id = hostgroup_id
                self.instance_id = instance_id
                self.config_type = config_type
                self.hostgroup_object_id = hostgroup_object_id
                self.alias = alias
                
                Index(u'hostgroup_id', IcingaHostgroups.hostgroup_id, unique=True)
                Index(u'instance_id', IcingaHostgroups.instance_id, IcingaHostgroups.hostgroup_object_id, unique=True)
                Index(u'hostgroups_i_id_idx', IcingaHostgroups.instance_id, unique=False)

        
        def __repr__(self):
            
                return "{'hostgroup_id':%d,\
                        'instance_id':%d,\
                        'config_type':%d,\
                        'hostgroup_object_id':%d,\
                        'alias':'%s'}" % (self.hostgroup_id,\
                        self.instance_id,\
                        self.config_type,\
                        self.hostgroup_object_id,\
                        self.alias)


class IcingaHostgroupMembers(base):
        __tablename__ = 'icinga_hostgroup_members'
    
        __table_args__ = {'schema': 'icinga'}
    
        #column definitions
        host_object_id = Column('host_object_id', BigInteger())
        hostgroup_id = Column('hostgroup_id', BigInteger())
        hostgroup_member_id = Column('hostgroup_member_id', BigInteger(), primary_key=True, nullable=False)
        instance_id = Column('instance_id', BigInteger())

        def __init(self, hostgroup_member_id = 0,\
                   instance_id = 0,\
                   hostgroup_id = 0,\
                   host_object_id = 0):
            
                self.hostgroup_member_id = hostgroup_member_id
                self.instance_id = instance_id
                self.hostgroup_id = hostgroup_id
                self.host_object_id = host_object_id
                
                Index(u'hostgroup_member_id', IcingaHostgroupMembers.hostgroup_member_id, unique=True)
                Index(u'instance_id', IcingaHostgroupMembers.hostgroup_id, IcingaHostgroupMembers.host_object_id, unique=True)
                Index(u'hostgroup_members_i_id_idx', IcingaHostgroupMembers.instance_id, unique=False)


        def __repr__(self):
            
                return "{'hostgroup_member_id':%d,\
                        'instance_id':%d,\
                        'hostgroup_id':%d,\
                        'host_object_id':%d}" % (self.hostgroup_member_id,\
                        self.instance_id,\
                        self.hostgroup_id,\
                        self.host_object_id)
        

class IcingaObjects(base):
        __tablename__ = 'icinga_objects'
        
        __table_args__ = {'schema': 'icinga'}
        
        object_id = Column(BIGINT(20),primary_key=True,autoincrement=True)
        instance_id = Column(BIGINT(20),default=0)
        objecttype_id = Column(BIGINT(20),default=0)
        name1 = Column(VARCHAR(128),default='')
        name2 = Column(VARCHAR(128),default='')
        is_active = Column(SMALLINT(6),default='')
        
        def __init__(self, instance_id=0,objecttype_id=0,name1='',name2='',is_active=''):
            
            self.instance_id = instance_id
            self.objecttype_id = objecttype_id
            self.name1 = name1
            self.name2 = name2
            self.is_active = is_active
        
        def __repr__(self):
            
            return "{'object_id':%d, \
                     'instance_id':%d, \
                     'objecttype_id':%d, \
                     'name1':%s, \
                     'name2':%s, \
                     'is_active':%d \
                    }"%(self.object_id, \
                    self.instance_id, \
                    self.objecttype_id, \
                    self.name1, \
                    self.name2, \
                    self.is_active)

def get_raw_ok_hosts(limit, start):
    '''
    Get all ok hosts.
    limit: limited count returned this time.
    start: initial ok host number.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    if limit == 0 and start == 0:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                               filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).\
                               filter(IcingaHoststatus.current_state == 0).all()

    else:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                               filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).\
                               filter(IcingaHoststatus.current_state == 0).\
                               slice(start,start+limit)
    session.close()
    return result

def get_raw_problem_hosts(limit, start):
    '''
    Get all problem hosts.
    limit: limited count returned this time.
    start: initial problem host number.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    if limit == 0 and start == 0:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                               filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).\
                               filter(IcingaHoststatus.current_state > 0). \
                               order_by(IcingaHosts.display_name). \
                               all()

    else:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                               filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).\
                               filter(IcingaHoststatus.current_state > 0).\
                               order_by(IcingaHosts.display_name). \
                               slice(start,start+limit)
    session.close()
    return result

def get_raw_all_hosts(limit, start):
    '''
    Get all hosts.
    limit: limited count returned this time.
    start: initial host number.
    
    old method:
    result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                               filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).\
                               slice(start,start+limit).all()
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    
    if limit == 0 and start == 0:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change,TblHost.hw_type).\
                               from_statement('select h.host_id , h.instance_id , h.alias, h.display_name , h.address , h.address6 ,  \
                                               h.output, h.long_output , h.perfdata, h.current_state , h.current_check_attempt , \
                                               h.max_check_attempts , h.last_check , h.next_check , h.last_state_change , tbl_host.hw_type from \
                                               (select icinga_hosts.host_id  , icinga_hosts.instance_id , icinga_hosts.alias, \
                                               icinga_hosts.display_name , icinga_hosts.address , icinga_hosts.address6 , \
                                               icinga_hoststatus.output, icinga_hoststatus.long_output , icinga_hoststatus.perfdata, \
                                               icinga_hoststatus.current_state , icinga_hoststatus.current_check_attempt , \
                                               icinga_hoststatus.max_check_attempts , icinga_hoststatus.last_check , icinga_hoststatus.next_check , \
                                               icinga_hoststatus.last_state_change from icinga_hosts , \
                                               icinga_hoststatus WHERE icinga_hosts.host_object_id = icinga_hoststatus.host_object_id ORDER BY icinga_hosts.display_name ASC) as h \
                                               LEFT OUTER JOIN tbl_host ON h.display_name = tbl_host.host_name;').all()

    else:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change,TblHost.hw_type).\
                               from_statement('select h.host_id , h.instance_id , h.alias, h.display_name , h.address , h.address6 ,  \
                                               h.output, h.long_output , h.perfdata, h.current_state , h.current_check_attempt , \
                                               h.max_check_attempts , h.last_check , h.next_check , h.last_state_change , tbl_host.hw_type from \
                                               (select icinga_hosts.host_id  , icinga_hosts.instance_id , icinga_hosts.alias, \
                                               icinga_hosts.display_name , icinga_hosts.address , icinga_hosts.address6 , \
                                               icinga_hoststatus.output, icinga_hoststatus.long_output , icinga_hoststatus.perfdata, \
                                               icinga_hoststatus.current_state , icinga_hoststatus.current_check_attempt , \
                                               icinga_hoststatus.max_check_attempts , icinga_hoststatus.last_check , icinga_hoststatus.next_check , \
                                               icinga_hoststatus.last_state_change from icinga_hosts , \
                                               icinga_hoststatus WHERE icinga_hosts.host_object_id = icinga_hoststatus.host_object_id ORDER BY icinga_hosts.display_name ASC\
                                                LIMIT '+str(start)+','+str(limit)+') as h \
                                                LEFT OUTER JOIN tbl_host ON h.display_name = tbl_host.host_name;').all()
    session.flush()
    session.close()
    return result
     
def get_raw_host_by_keyword(limit , start ,keyword):
    '''
    Get all hosts by keyword
    
    old method:
    result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                               filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).\
                               filter(or_(IcingaHosts.display_name.like('%'+('%s')%keyword+'%'),IcingaHosts.address.like('%'+('%s')%keyword+'%'))).\
                               slice(start,start+limit).all()
    '''
    Session = sessionmaker(bind=mysql_engine)
    session = Session()

    if limit == 0 and start == 0:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change,TblHost.hw_type). \
                               from_statement('select h.host_id , h.instance_id , h.alias, h.display_name , h.address , h.address6 ,  \
                                               h.output, h.long_output , h.perfdata, h.current_state , h.current_check_attempt , \
                                               h.max_check_attempts , h.last_check , h.next_check , h.last_state_change , tbl_host.hw_type from \
                                               (select icinga_hosts.host_id  , icinga_hosts.instance_id , icinga_hosts.alias, \
                                               icinga_hosts.display_name , icinga_hosts.address , icinga_hosts.address6 , \
                                               icinga_hoststatus.output, icinga_hoststatus.long_output , icinga_hoststatus.perfdata, \
                                               icinga_hoststatus.current_state , icinga_hoststatus.current_check_attempt , \
                                               icinga_hoststatus.max_check_attempts , icinga_hoststatus.last_check , icinga_hoststatus.next_check , \
                                               icinga_hoststatus.last_state_change from icinga_hosts , \
                                               icinga_hoststatus WHERE icinga_hosts.host_object_id = icinga_hoststatus.host_object_id AND \
                                               (LOWER(icinga_hosts.display_name) LIKE \'%'+keyword+'%\' OR LOWER(address) LIKE \'%'+keyword+'%\') ORDER BY icinga_hosts.display_name ASC) as h \
                                               LEFT OUTER JOIN tbl_host ON h.display_name = tbl_host.host_name;').all()
    else:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change,TblHost.hw_type). \
                               from_statement('select h.host_id , h.instance_id , h.alias, h.display_name , h.address , h.address6 ,  \
                                               h.output, h.long_output , h.perfdata, h.current_state , h.current_check_attempt , \
                                               h.max_check_attempts , h.last_check , h.next_check , h.last_state_change , tbl_host.hw_type from \
                                               (select icinga_hosts.host_id  , icinga_hosts.instance_id , icinga_hosts.alias, \
                                               icinga_hosts.display_name , icinga_hosts.address , icinga_hosts.address6 , \
                                               icinga_hoststatus.output, icinga_hoststatus.long_output , icinga_hoststatus.perfdata, \
                                               icinga_hoststatus.current_state , icinga_hoststatus.current_check_attempt , \
                                               icinga_hoststatus.max_check_attempts , icinga_hoststatus.last_check , icinga_hoststatus.next_check , \
                                               icinga_hoststatus.last_state_change from icinga_hosts , \
                                               icinga_hoststatus WHERE icinga_hosts.host_object_id = icinga_hoststatus.host_object_id AND \
                                               (LOWER(icinga_hosts.display_name) LIKE \'%'+keyword+'%\' OR LOWER(address) LIKE \'%'+keyword+'%\') ORDER BY icinga_hosts.display_name ASC\
                                                LIMIT '+str(start)+','+str(limit)+') as h \
                                                LEFT OUTER JOIN tbl_host ON h.display_name = tbl_host.host_name;').all()
    session.flush()
    session.close()
    return result

def get_raw_all_services(limit, start):    
    '''
    Get all services.
    limit: limited service count returned this time.
    start: initial service number.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()

    if limit == 0 and start == 0:
        result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                               IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                               IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                               IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                               ).filter(IcingaHosts.host_object_id == IcingaServices.host_object_id).filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id ). \
                               order_by(IcingaHosts.display_name.asc(),IcingaServices.display_name.asc()).all()
    else:
        result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                               IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                               IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                               IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                               ).filter(IcingaHosts.host_object_id == IcingaServices.host_object_id).filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id ).\
                               order_by(IcingaHosts.display_name.asc(),IcingaServices.display_name.asc()).slice(start,start+limit).all()
    session.close()
    return result

def get_raw_ok_services(limit, start):    
    '''
    Get all ok services.
    limit: limited service count returned this time.
    start: initial ok service number.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()

    if limit == 0 and start == 0:
        result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                               IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                               IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                               IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                               ).filter(IcingaHosts.host_object_id == IcingaServices.host_object_id).filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id ). \
                               filter(IcingaServicestatus.current_state == 0 ). \
                               all()
    else:
        result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                               IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                               IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                               IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                               ).filter(IcingaHosts.host_object_id == IcingaServices.host_object_id).filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id ).\
                               filter(IcingaServicestatus.current_state == 0 ). \
                               slice(start,start+limit)
    session.close()
    return result

def get_raw_problem_services(limit, start):    
    '''
    Get all problem services.
    limit: limited service count returned this time.
    start: initial problem service number.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()

    if limit == 0 and start == 0:
        result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                               IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                               IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                               IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                               ).filter(IcingaHosts.host_object_id == IcingaServices.host_object_id).filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id ). \
                               filter(IcingaServicestatus.current_state > 1 ).order_by(IcingaHosts.display_name.asc(),IcingaServices.display_name.asc()). \
                               all()
    else:
        result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                               IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                               IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                               IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                               ).filter(IcingaHosts.host_object_id == IcingaServices.host_object_id).filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id ).\
                               filter(IcingaServicestatus.current_state > 1 ).order_by(IcingaHosts.display_name.asc(),IcingaServices.display_name.asc()). \
                               slice(start,start+limit)
    session.close()
    return result


def get_raw_services_by_keyword(limit,start,keyword):
    '''
    Get all services by keyword
    
    old method:
    result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                               IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                               IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                               IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                               ).filter(IcingaHosts.host_object_id == IcingaServices.host_object_id).filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id ).\
                               filter(IcingaServices.display_name.like('%'+('%s')%keyword + '%')). \
                               slice(start,start+limit).all()
    
    '''
    Session = sessionmaker(bind=mysql_engine)
    session = Session()
    
    if limit == 0 and start == 0:
        result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                               IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                               IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                               IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                               ).from_statement('SELECT icinga_hosts.display_name as icinga_hosts_display_name , icinga_services.service_id , icinga_services.instance_id , icinga_services.host_object_id , icinga_services.display_name,\
                                                 icinga_servicestatus.output , icinga_servicestatus.long_output , icinga_servicestatus.perfdata , icinga_servicestatus.current_state , \
                                                 icinga_servicestatus.current_check_attempt, icinga_servicestatus.max_check_attempts , icinga_servicestatus.last_check , \
                                                 icinga_servicestatus.next_check FROM icinga_hosts , icinga_services , icinga_servicestatus \
                                                 WHERE icinga_hosts.host_object_id = icinga_services.host_object_id and icinga_services.service_object_id = icinga_servicestatus.service_object_id \
                                                 AND LOWER(icinga_services.display_name) LIKE \'%'+keyword+'%\' ORDER BY icinga_hosts_display_name ASC,icinga_services.display_name ASC;') \
                                .all()
    else:
        result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                               IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                               IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                               IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                               ).from_statement('SELECT  icinga_hosts.display_name as icinga_hosts_display_name , icinga_services.service_id , icinga_services.instance_id , icinga_services.host_object_id , icinga_services.display_name,\
                                                 icinga_servicestatus.output , icinga_servicestatus.long_output , icinga_servicestatus.perfdata , icinga_servicestatus.current_state , \
                                                 icinga_servicestatus.current_check_attempt, icinga_servicestatus.max_check_attempts , icinga_servicestatus.last_check , \
                                                 icinga_servicestatus.next_check FROM icinga_hosts , icinga_services , icinga_servicestatus \
                                                 WHERE icinga_hosts.host_object_id = icinga_services.host_object_id and icinga_services.service_object_id = icinga_servicestatus.service_object_id \
                                                 AND LOWER(icinga_services.display_name) LIKE \'%'+keyword+'%\' ORDER BY icinga_hosts_display_name ASC,icinga_services.display_name ASC LIMIT '+str(start)+','+str(limit)+';').all()
                                                
                                
    
    session.flush()
    session.close()
    return result

def get_raw_host_detail(hostid):
    '''
    Get host details by hostid.
    hostid: host id
    
    return host details.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                           IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                           IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                           IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                           IcingaHoststatus.max_check_attempts, \
                           IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                           filter(IcingaHosts.host_id == hostid).group_by(IcingaHosts.host_id).all()
    session.close()
    return result

def get_raw_service_detail(hostid, serviceid):
    '''
    Get service details by hostid and serviceid.
    hostid: host id
    serviceid: service id
    
    return service details.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    
    result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                           IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                           IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                           IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                           ).filter(IcingaHosts.host_id == hostid).filter(IcingaHosts.host_object_id == IcingaServices.host_object_id). \
                           filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id).filter(IcingaServices.service_id == serviceid). \
                           all()
    session.close()
    return result

def get_raw_service_for_host(hostid):
    '''
    Get all services belonging to one host.
    hostid: host id.
    
    return: all services belonging to this host.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    #filterid = session.query(IcingaHosts.host_object_id).filter(IcingaHosts.host_id == hostid).first()
    #print filterid
    #print type(filterid)
    #print type(filterid[0])
    #result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
    #                       IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
    #                       IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
    #                       IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
    #                       ).filter(IcingaServices.host_object_id == filterid[0]).group_by(IcingaServices.service_id).all()
    result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                           IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                           IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                           IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                           ).filter(IcingaHosts.host_id == hostid). \
                           filter(IcingaHosts.host_object_id == IcingaServices.host_object_id).filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id ).all()
    session.close()
    return result

def get_all_host_count():
    '''
    Get count of all hosts .
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    host_count = session.query(IcingaHosts).count()
    session.close()
    return host_count

def get_ok_host_count():
    '''
    Get count of ok host.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    host_count = session.query(IcingaHoststatus).filter(IcingaHoststatus.current_state == 0).count()
    
    session.close()
    return host_count

def get_problem_host_count():
    '''
    Get count of problem host .
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    host_count = session.query(IcingaHosts,IcingaHoststatus).filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).filter(IcingaHoststatus.current_state > 0).count()
    session.close()
    return host_count

def get_raw_host_by_keyword_count(keyword):
    '''
    Get all hosts count by keyword
    '''
    Session = sessionmaker(bind=mysql_engine)
    session = Session()
    

    count = len(session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change). \
                               from_statement('select icinga_hosts.host_id  , icinga_hosts.instance_id , icinga_hosts.alias, \
                                                icinga_hosts.display_name , icinga_hosts.address , icinga_hosts.address6 , \
                                                icinga_hoststatus.output, icinga_hoststatus.long_output , icinga_hoststatus.perfdata, \
                                                icinga_hoststatus.current_state , icinga_hoststatus.current_check_attempt , \
                                                icinga_hoststatus.max_check_attempts , icinga_hoststatus.last_check , icinga_hoststatus.next_check , \
                                                icinga_hoststatus.last_state_change from icinga_hosts , \
                                                icinga_hoststatus where icinga_hosts.host_object_id = icinga_hoststatus.host_object_id AND \
                                                (LOWER(icinga_hosts.display_name) LIKE \'%'+keyword+'%\' OR LOWER(address) LIKE \'%'+keyword+'%\')').all())
    session.flush()
    session.close()
    return count

def get_raw_services_by_keyword_count(keyword):
    '''
    Get all services count by keyword
    '''
    Session = sessionmaker(bind=mysql_engine)
    session = Session()
    
    count = len(session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                               IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                               IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                               IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                               ).from_statement('SELECT icinga_hosts.display_name as icinga_hosts_display_name , icinga_services.service_id , icinga_services.instance_id , icinga_services.host_object_id , icinga_services.display_name,\
                                                 icinga_servicestatus.output , icinga_servicestatus.long_output , icinga_servicestatus.perfdata , icinga_servicestatus.current_state , \
                                                 icinga_servicestatus.current_check_attempt, icinga_servicestatus.max_check_attempts , icinga_servicestatus.last_check , \
                                                 icinga_servicestatus.next_check FROM icinga_hosts , icinga_services , icinga_servicestatus \
                                                 WHERE icinga_hosts.host_object_id = icinga_services.host_object_id and icinga_services.service_object_id = icinga_servicestatus.service_object_id \
                                                 AND LOWER(icinga_services.display_name) LIKE \'%'+keyword+'%\';').all())
                               
    
    session.flush()
    session.close()
    return count

def get_all_service_count():
    '''
    Get count of all services.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    service_count = session.query(IcingaServices).count()
    session.close()
    return service_count

def get_ok_service_count():
    '''
    Get count of all ok services.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    service_count = session.query(IcingaServicestatus).filter(IcingaServicestatus.current_state == 0).count()
    session.close()
    return service_count

def get_problem_service_count():
    '''
    Get count of all problem services.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    service_count = session.query(IcingaHosts,IcingaServices,IcingaServicestatus).\
                    filter(IcingaHosts.host_object_id == IcingaServices.host_object_id).filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id ).\
                    filter(IcingaServicestatus.current_state > 1).count()
    session.close()
    return service_count
    
def get_raw_hostgroups(limit, marker):
    '''
    Get hostgroup info. 
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    result = session.query(IcingaHostgroups.hostgroup_id, IcingaHostgroups.alias, \
                           func.count(IcingaHostgroupMembers.host_object_id),IcingaObjects.name1). \
                           filter(IcingaHostgroups.hostgroup_id == IcingaHostgroupMembers.hostgroup_id).\
                           group_by(IcingaHostgroups.hostgroup_id). \
                           filter(IcingaHostgroups.hostgroup_object_id == IcingaObjects.object_id).all()
    session.close()
    return result


def get_raw_hostgroup_hosts(hostgroupid, limit, start):
    '''
    Get  all hosts of one hostgroup.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    if limit == 0 and start == 0:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                               filter(IcingaHosts.host_object_id.in_(session.query(IcingaHostgroupMembers.host_object_id).\
                                      filter(IcingaHostgroupMembers.hostgroup_id == hostgroupid))).\
                               filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).all()

    else:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                               filter(IcingaHosts.host_object_id.in_(session.query(IcingaHostgroupMembers.host_object_id).\
                               filter(IcingaHostgroupMembers.hostgroup_id == hostgroupid))).\
                               filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).\
                               slice(start,start+limit).all()

    session.close()
    return result
                      
def get_all_hostgroup_host_count(hostgroupid):
    '''
    Get host count of one hostgroup.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    host_count = session.query(IcingaHostgroupMembers).filter(IcingaHostgroupMembers.hostgroup_id == hostgroupid).count()
    session.close()
    return host_count

def get_raw_host_detail_by_hostname(hostname):
    '''
    Get host details by hostid.
    hostid: host id
    
    return host details.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                           IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                           IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                           IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                           IcingaHoststatus.max_check_attempts, \
                           IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                           filter(IcingaHosts.display_name == hostname).\
			   filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).group_by(IcingaHosts.display_name,IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                           IcingaHosts.address, IcingaHosts.address6, \
                           IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                           IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                           IcingaHoststatus.max_check_attempts, \
                           IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).all()

#group_by(IcingaHosts.display_name).all()
    session.close()
    return result
def get_raw_service_for_hostname(hostname):
    '''
    Get all services belonging to one host.
    hostid: host id.
    
    return: all services belonging to this host.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()

    result = session.query(IcingaHosts.display_name, IcingaServices.service_id, IcingaServices.instance_id, IcingaServices.host_object_id, \
                           IcingaServices.display_name, IcingaServicestatus.output, IcingaServicestatus.long_output, \
                           IcingaServicestatus.perfdata, IcingaServicestatus.current_state, IcingaServicestatus.current_check_attempt, \
                           IcingaServicestatus.max_check_attempts, IcingaServicestatus.last_check, IcingaServicestatus.next_check, \
                           ).filter(IcingaHosts.display_name == hostname). \
                           filter(IcingaHosts.host_object_id == IcingaServices.host_object_id).filter(IcingaServices.service_object_id == IcingaServicestatus.service_object_id ).all()
    session.close()
    return result
def get_raw_hostgroup_hosts_by_hostgroupname(hostgroupname, limit, start):
    '''
    Get  all hosts of one hostgroup.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    if limit == 0 and start == 0:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                               filter(IcingaHosts.host_object_id.in_(session.query(IcingaHostgroupMembers.host_object_id).\
                                      filter(IcingaHostgroupMembers.hostgroup_id.in_(session.query(IcingaHostgroups.alias == hostgroupname))))).\
                               filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).all()

    else:
        result = session.query(IcingaHosts.host_id, IcingaHosts.instance_id, IcingaHosts.alias, \
                               IcingaHosts.display_name, IcingaHosts.address, IcingaHosts.address6, \
                               IcingaHoststatus.output, IcingaHoststatus.long_output, IcingaHoststatus.perfdata, \
                               IcingaHoststatus.current_state, IcingaHoststatus.current_check_attempt, \
                               IcingaHoststatus.max_check_attempts, \
                               IcingaHoststatus.last_check, IcingaHoststatus.next_check,IcingaHoststatus.last_state_change).\
                               filter(IcingaHosts.host_object_id.in_(session.query(IcingaHostgroupMembers.host_object_id).\
                               filter(IcingaHostgroupMembers.hostgroup_id.in_(session.query(IcingaHostgroups.alias == hostgroupname))))).\
                               filter(IcingaHosts.host_object_id == IcingaHoststatus.host_object_id).\
                               slice(start,start+limit).all()

    session.close()
    return result
def get_all_hostgroup_host_count_by_hostgroupname(hostgroupname):
    '''
    Get host count of one hostgroup.
    '''
    Session=sessionmaker(bind=mysql_engine)
    session=Session()
    host_count = session.query(IcingaHostgroupMembers).filter(IcingaHostgroupMembers.hostgroup_id.in_(session.query(IcingaHostgroups.alias == hostgroupname))).count()
    session.close()
    return host_count

