'''
Created on 2012-5-15

@author: root

Monitor_server is used to response to requests from UI.

Get: handle get requests
Post: handle post reques
'''

from bottle import Bottle, run
from bottle import request, response
from bottle import error
from src.monitor.api.CobraApi import *
from src.utils.utils import data_to_int

#config
global hostip
global port

hostip = '10.1.81.16'
port = 8080

app = Bottle()

@app.route('/monitor/hosts', method='GET')
def monitor_hosts():
    
    marker = request.query.marker or 0
    limit = request.query.limit or 0
    status = request.query.status or 111
    data = get_hosts(data_to_int(status), data_to_int(limit), data_to_int(marker))
    response.set_header('Content-Type', 'application/json')
    return data

@app.route('/monitor/host/<hostid:int>', method='GET')
def monitor_host_detail(hostid):
    assert isinstance(hostid, int)
    #print request.url
    #print request.content_length
    data = get_host_by_id(hostid)
    response.set_header('Content-Type', 'application/json')
    return data


@app.route('/monitor/services', method='GET')
def monitor_services():
    
    marker = request.query.marker or 0
    limit = request.query.limit or 0
    status = request.query.status or 111
    
    response.set_header('Content-Type', 'application/json')
    data = get_services(data_to_int(status), data_to_int(limit), data_to_int(marker))
    return data

@app.route('/monitor/host/<hostid:int>/services', method='GET')
def monitor_host_service(hostid):
    assert isinstance(hostid, int)
    data = get_service_by_host(hostid)
    response.set_header('Content-Type', 'application/json')
    return data

@app.route('/monitor/host/<hid:int>/service/<sid:int>', method='GET')
def monitor_service_detail(hid, sid):
    assert isinstance(hid, int)
    assert isinstance(sid, int)
    data = get_service_by_id(hid, sid)
    response.set_header('Content-Type', 'application/json')
    return data

@app.route('/monitor/hostgrups', method='GET')
def monitor_hostgroups():
    
    limit = request.query.limit or 0
    marker = request.query.marker or 0
    data = get_hostgroups(data_to_int(limit), data_to_int(marker))
    response.set_header('Content-Type', 'application/json')
    return data

@app.route('/monitor/hostgroup/<hostgroupid:int>/hosts', method='GET')
def monitor_hostgroup_hosts(hostgroupid):
    assert isinstance(hostgroupid, int)
    limit = request.query.limit or 0
    marker = request.query.marker or 0
    data = get_hostgroup_hosts(hostgroupid, data_to_int(limit), data_to_int(marker))
    response.set_header('Content-Type', 'application/json')
    return data

@error(403)
@error(404)
def error404(error):
    return 'Nothing here, sorry'

@error(500)
def error500(error):
    return 'No information returned!'

run(app, host = hostip, port = port)