from time import strftime,localtime
import re
from string import atof, atoi
import json

def list2list(pre_list):
    post_list = []
    for va in pre_list:
        post_list.append(va[0])
    return post_list

# convert a class object to dictionary
def obj2dict(keys=[], values =[]):
        '''sumary'''
        _dict = {}
        if (len(keys) == len(values)):  
            for m in range(len(keys)):
                if(str(type(values[m])) == '<type \'datetime.datetime\'>'):
                    values[m] = values[m].strftime('%Y-%m-%d %H:%M:%S')
                elif(str(type(values[m])) == '<class \'decimal.Decimal\'>'):
                    _dict[m] = atof('%lf' % (_dict[m],))
                elif(str(type(values[m])) == '<type \'unicode\'>'):
                    _dict[m] = str(values[m])
                _dict[keys[m]] = values[m]        
        return _dict

# convert a class object to dictionary
def classobj2dict(obj):
        '''sumary'''
        memberlist = [m for m in dir(obj)]
        _dict = {}
        for m in memberlist:
            if m[0] != "_" and not callable(m):
                _dict[m] = getattr(obj,m)
                #print type(_dict[m]), ":",_dict[m]
                if(str(type(_dict[m])) == '<type \'datetime.datetime\'>'):
                    _dict[m] = _dict[m].strftime('%Y-%m-%d %H:%M:%S')
                if(str(type(_dict[m])) == '<type \'datetime.time\'>'):
                    _dict[m] = _dict[m].isoformat()
                elif(str(type(_dict[m])) == '<class \'decimal.Decimal\'>'):
                    _dict[m] = atof('%lf' % (_dict[m],))
                elif(str(type(_dict[m])) == '<class \'sqlalchemy.sql.schema.MetaData\'>'):
                    del _dict[m]
                elif(str(type(_dict[m])) == '<type \'unicode\'>'):
                    _dict[m] = str(_dict[m])
#                print _dict[m]
        #print _dict
        #print len(_dict)
        return _dict
    
    
def  data_to_tuple(result = None):   
    
    data = []
    for va in result:
        en_dict=obj2dict(va)    
        #print type(en_dict)
        data.append(en_dict)
        #encodejson = json.dumps(en_dict)
        #print type(encodejson)
        #encodedata=json.dumps(data)
        #print encodejson
        
def data_to_json(value = '', data = [], data_list = []):
    result_list = []
    for va in data:
        en_dict=obj2dict(data_list, list(va))    
        result_list.append(en_dict)
    result = {value:result_list}
    encodedata=json.dumps(result)
    return encodedata
        
def all_data_to_json(value = '', data = None, data_list = [], count = 0):
    '''Translate dict to json.
    value: 
    data: Dict data 
    data_list: 
    '''
    result_list = []
    for va in data:
        en_dict=obj2dict(data_list, list(va))    
        result_list.append(en_dict)
    result = {value:result_list, 'count':count }
    encodedata=json.dumps(result)
    return encodedata

def data_to_int(value):
    if str(type(value)) == '<type \'unicode\'>':
        return atoi(value)
    if str(type(value)) == '<type \'int\'>':
        return value

def time():
    #get datetime,format='YYYY-MM-DD HH:MM:SS'
    time = strftime("%Y-%m-%d %H:%M:%S",localtime())
    return time


# create command description by administrator with regex
def create_json_by_admin_old(name,msg,args,argv,argd,regex):
    '''
        args is the number of paprms' count,such as:
            args = 3
        argv is a dict of key_value:[lable,type,defValue,desc,regex],such as:
            argv = ['Host','string','localhost','host is host ip','regex']
            argv = {'Host':'localhost','Port':22,'Check_interval':3}
        argd is a list of paprms' description,such as: 
            argd = ["host is host","port is port","The check interval time(minutes) of monitoring the service(s)."]
    '''
    desc = {
        "msg" : msg,
        "paprm" : []
        }
    paprmlist = []
    warn_id=''
    for i in range(args):
        paprmlist.append({"id":"cobra_"+name+str(i+1),
                          "lable":argv.keys()[i],
                          "type":"",
                          "defValue": argv.values()[i],
                          "desc":argd[i],
                          "regex": "regex"})
        if re.findall(r"warn",argv.keys()[i],re.I):
            warn_id = "cobra_"+name+str(i+1)
    if warn_id :
        for i in range(args):
            if re.findall(r"criti",argv.keys()[i],re.I):
                paprmlist[i]["regex"] = regex+"[\"#"+warn_id+"\"]"
    desc["paprm"] = paprmlist
    print desc

# create command description by user without regex
# this function will be used when user add new check command
def create_json_by_user(name,msg,args,argv,argd):
    desc = {
        "msg" : msg,
        "paprm" : []
        }
    paprmlist = []
    warn_id=''
    for i in range(args):
        paprmlist.append({"id":"cobra_"+name+str(i+1),
                          "lable":argv.keys()[i],
                          "defValue": argv.values()[i],
                          "desc":argd[i],
                          "regex": "regex-string"})
        
    desc["paprm"] = paprmlist
    print desc
    
    
# create command description by administrator with regex

def create_json_by_admin(name,msg,type,args,argv):
    '''
        args is the number of paprms' count,such as:
            args = 3
        argv is a dict of key_value:[{lable:a,type:int,require:0,defValue:10,desc:test,regex:regexMax}],such as:
            argv = [{'lable':'Host','type':'text','require':0,'defValue':'localhost','desc':'host is host ip','regex':'regexMax'},\
                    {'lable':'Port','type':'text','require':1,'defValue':'80','desc':'port','regex':'regex'}]
    '''
    desc = {
            "msg" : msg,
            "show_type" : type,
            "paprm" : []
            }
    warn_id = ''
    for i in range(args):
        argv[i].update({"id":"cobra_"+name+str(i+1)})
        for j in range(len(argv[i].values())):
            if re.findall(r"warn",str(argv[i].values()[j]),re.I):
                warn_id = argv[i]["id"]
    if warn_id:
        for i in range(args):
            for j in range(len(argv[i].values())):
                if re.findall(r"criti",str(argv[i].values()[j]),re.I):
                    new_re="regexMax"+"[\"#"+warn_id+"\"]"
                    argv[i]["regex"] = re.sub("regexMax",new_re,argv[i].get('regex'))
       
    desc["paprm"]=argv
    print name ,desc
    
def unicode2dict(data):
    s = str(data).replace("u'", "'")
    data =  eval(s)
    return data

def dealspecialstr(str):    
    str = str.replace('%','\%').replace('#', '\#').replace('&', '\&').replace('_', '\_').replace('\'','\\\'')
    return str
